function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    function openNavTray() {
        $.navTray.toggle($.content);
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "browserview";
    if (arguments[0]) {
        {
            __processArg(arguments[0], "__parentSymbol");
        }
        {
            __processArg(arguments[0], "$model");
        }
        {
            __processArg(arguments[0], "__itemTemplate");
        }
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.container = Ti.UI.createWindow({
        backgroundColor: "#fa72c0",
        navBarHidden: "true",
        id: "container"
    });
    $.__views.container && $.addTopLevelView($.__views.container);
    $.__views.statusBar = Ti.UI.createView({
        top: 0,
        height: 20,
        backgroundColor: "#88fcf9f9",
        id: "statusBar"
    });
    $.__views.container.add($.__views.statusBar);
    $.__views.wrapper = Ti.UI.createView({
        id: "wrapper"
    });
    $.__views.container.add($.__views.wrapper);
    $.__views.navTray = Alloy.createWidget("navtray", "widget", {
        id: "navTray",
        __parentSymbol: $.__views.wrapper
    });
    $.__views.navTray.setParent($.__views.wrapper);
    $.__views.content = Ti.UI.createView({
        height: Titanium.UI.FILL,
        backgroundColor: "white",
        id: "content"
    });
    $.__views.wrapper.add($.__views.content);
    $.__views.topNavbar = Ti.UI.createView({
        backgroundColor: "white",
        top: 0,
        height: 45,
        id: "topNavbar"
    });
    $.__views.content.add($.__views.topNavbar);
    $.__views.pageTitle = Ti.UI.createLabel({
        color: "#ff99cc",
        font: {
            fontSize: 16,
            fontFamily: "HelveticaNeue-Medium"
        },
        text: "Page Title",
        id: "pageTitle"
    });
    $.__views.topNavbar.add($.__views.pageTitle);
    $.__views.btn_menu = Ti.UI.createImageView({
        right: 15,
        top: 5,
        height: 30,
        width: 30,
        backgroundColor: "transparent",
        title: "Menu",
        id: "btn_menu",
        image: "/images/icons/menu.png"
    });
    $.__views.topNavbar.add($.__views.btn_menu);
    openNavTray ? $.__views.btn_menu.addEventListener("click", openNavTray) : __defers["$.__views.btn_menu!click!openNavTray"] = true;
    $.__views.topNavbar_separator = Ti.UI.createView({
        top: 46,
        height: 1,
        width: Titanium.UI.FILL,
        backgroundColor: "#cccccc",
        id: "topNavbar_separator"
    });
    $.__views.content.add($.__views.topNavbar_separator);
    $.__views.mainView = Ti.UI.createView({
        top: 47,
        bottom: 40,
        id: "mainView"
    });
    $.__views.content.add($.__views.mainView);
    $.__views.browserView = Ti.UI.createWebView({
        userAgent: "Mozilla/5.0 (Windows NT 6.2; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1667.0 Safari/537.36",
        id: "browserView"
    });
    $.__views.mainView.add($.__views.browserView);
    $.__views.bottomToolbar = Alloy.createWidget("toolbar", "widget", {
        id: "bottomToolbar",
        __parentSymbol: $.__views.content
    });
    $.__views.bottomToolbar.setParent($.__views.content);
    exports.destroy = function() {};
    _.extend($, $.__views);
    $.container.orientationModes = [ Ti.UI.PORTRAIT ];
    Titanium.UI.orientation = Ti.UI.PORTRAIT;
    var pages = require("/pageutils");
    var args = arguments[0] || {};
    var title = args.title || "";
    var pageName = args.name || "";
    Alloy.Globals.activeWindows[args.name] = $.container;
    Alloy.Globals.currentWindow = $.container;
    var actInd = Titanium.UI.createActivityIndicator({
        width: 50,
        height: 50
    });
    $.container.add(actInd);
    actInd.show();
    $.bottomToolbar.showRefresh();
    $.browserView.title = title;
    $.pageTitle.text = "FAQ" == title ? title.toUpperCase() : title.capitalize();
    $.bottomToolbar.setCurrentView(pageName);
    $.browserView.url = "flashsales" != pageName || Alloy.Globals.flashSaleInfo.started ? args.link : "http://www.themonogrammedlife.com/p/flash-sale.html?m=1";
    $.statusBar.visible = Alloy.Globals.isiOS7Plus() ? true : false;
    $.wrapper.top = Alloy.Globals.isiOS7Plus() ? 20 : 0;
    $.container.addEventListener("load", function() {
        $.navTray.navTray.visible = true;
        actInd.hide();
    });
    Alloy.Globals.setFlashSaleTimer(pageName, $.navTray.updateTimer);
    Titanium.UI.addEventListener("app:refreshPage", function() {
        pages.log("Called Refresh on BrowserView for page: " + pageName);
        actInd.show();
        $.browserView.reload();
    });
    __defers["$.__views.btn_menu!click!openNavTray"] && $.__views.btn_menu.addEventListener("click", openNavTray);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;