function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    function openNavTray() {
        $.navTray.toggle($.content);
    }
    function swipeListener() {}
    function sendMarketingForm() {
        if (0 === $.nameMarketing.value.length) {
            alert("You must enter your name to continue");
            return;
        }
        if (0 === $.emailMarketing.value.length) {
            alert("You must enter your email to continue");
            return;
        }
        sendDataToServer({
            form: "marketing",
            name: $.nameMarketing.value,
            email: $.emailMarketing.value,
            twitter: $.twitterMarketing.value,
            instagram: $.instagramMarketing.value,
            message: $.messageMarketing.value + "<br /><br />App Version: " + Titanium.App.version,
            attachment: attachment
        });
    }
    function sendCustomerServiceForm() {
        if (0 === $.nameCustomerService.value.length) {
            alert("You must enter your name to continue");
            return;
        }
        if (0 === $.emailCustomerService.value.length) {
            alert("You must enter your email to continue");
            return;
        }
        sendDataToServer({
            form: "customerservice",
            name: $.nameCustomerService.value,
            email: $.emailCustomerService.value,
            phone: $.phoneCustomerService.value,
            order: $.orderCustomerService.value,
            message: $.messageCustomerService.value + "<br /><br />App Version: " + Titanium.App.version,
            attachment: attachment
        });
    }
    function openAttachmentSelector(e) {
        target = e.source.customTarget;
        var dialog = Ti.UI.createOptionDialog({
            title: "Share",
            options: [ "Choose an Existing Photo", "Take a New Picture", "Cancel" ],
            cancel: 2
        });
        dialog.addEventListener("click", function(e) {
            if (e.index == e.cancel) return;
            switch (e.index) {
              case 0:
                chooseFromPhotoGallery(e);
                break;

              case 1:
                takePicture(e);
            }
        });
        dialog.show();
    }
    function setPhotoThumb(image) {
        "customerService" == target ? $.photo_thumbCustomerService.image = image : $.photo_thumbMarketing.image = image;
    }
    function clearPhotoThumb() {
        $.photo_thumbCustomerService.image = "";
        $.photo_thumbMarketing.image = "";
    }
    function chooseFromPhotoGallery() {
        Titanium.Media.openPhotoGallery({
            success: function(e) {
                if (e.mediaType == Ti.Media.MEDIA_TYPE_PHOTO) {
                    setPhotoThumb(e.media);
                    attachment = e.media;
                }
            },
            cancel: function() {},
            error: function(error) {
                var a = Titanium.UI.createAlertDialog({
                    title: "Photo Gallery"
                });
                a.setMessage("Unexpected error: " + error.code);
                a.show();
            },
            allowEditing: true,
            mediaTypes: [ Ti.Media.MEDIA_TYPE_PHOTO ]
        });
    }
    function takePicture() {
        Titanium.Media.showCamera({
            success: function(e) {
                if (e.mediaType == Ti.Media.MEDIA_TYPE_PHOTO) {
                    setPhotoThumb(e.media);
                    attachment = e.media;
                } else alert("Wrong media type returned. Take a picture or select one from the photo gallery");
            },
            cancel: function() {},
            error: function(error) {
                var a = Titanium.UI.createAlertDialog({
                    title: "Camera"
                });
                a.setMessage(error.code == Titanium.Media.NO_CAMERA ? "Please run this test on device" : "Unexpected error: " + error.code);
                a.show();
            },
            allowEditing: true,
            mediaTypes: [ Ti.Media.MEDIA_TYPE_PHOTO ]
        });
    }
    function switchTabs(e) {
        if ("marketingTab" == e.source.id) {
            $.customerService.visible = false;
            $.customerServiceTab.backgroundColor = "#eeeeee";
            $.customerServiceTab.color = "#999999";
            $.marketing.visible = true;
            $.marketingTab.backgroundColor = "#f8f8f8";
            $.marketingTab.color = "#8dc63f";
        } else {
            $.customerService.visible = true;
            $.customerServiceTab.backgroundColor = "#f8f8f8";
            $.customerServiceTab.color = "#8dc63f";
            $.marketing.visible = false;
            $.marketingTab.backgroundColor = "#eeeeee";
            $.marketingTab.color = "#999999";
        }
    }
    function sendDataToServer(data) {
        if (true === Titanium.Network.online) {
            var url = Alloy.Globals.ADMIN_SERVER_URL + "/contact";
            pages.log("CONTACT: ADMIN_SERVER_URL: " + url);
            actInd.show();
            var c = Titanium.Network.createHTTPClient();
            c.setTimeout(2e4);
            c.onload = function() {
                if (200 == c.status) {
                    if ("marketing" == data.form) {
                        $.nameMarketing.value = "";
                        $.nameMarketing.value = "";
                        $.twitterMarketing.value = "";
                        $.instagramMarketing.value = "";
                        $.messageMarketing.value = "";
                        alert("Thank you for submitting your photo to Marley Lilly!  We will be sure to tag you if your photo is posted!");
                    } else {
                        $.nameCustomerService.value = "";
                        $.emailCustomerService.value = "";
                        $.phoneCustomerService.value = "";
                        $.orderCustomerService.value = "";
                        $.messageCustomerService.value = "";
                        alert("Thank you for contacting Marley Lilly.  Our reps respond to all emails within 24-48 business hours.");
                    }
                    attachment = "";
                    clearPhotoThumb();
                } else {
                    pages.log("There was an unkown error accessing the Marley Lilly servers.");
                    alert("There was an unknown error accessing the Marley Lilly servers.");
                }
                actInd.hide();
            };
            c.onerror = function(e) {
                pages.log("There was an error submitting form data to the server: ERROR: " + e.error);
                alert("There was an error submitting your information to the Marley Lilly server.\n\nPlease make sure you have a working Internet connection and try again.");
                actInd.hide();
            };
            c.open("POST", url);
            c.send(data);
        } else {
            file_obj.error = "no internet";
            alert("You currently have no Internet Connection. You need Internet access in order to send your message to Marley Lilly. Please connect to the Internet and try again.");
            actInd.hide();
        }
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "contact";
    if (arguments[0]) {
        {
            __processArg(arguments[0], "__parentSymbol");
        }
        {
            __processArg(arguments[0], "$model");
        }
        {
            __processArg(arguments[0], "__itemTemplate");
        }
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.container = Ti.UI.createWindow({
        backgroundColor: "#fa72c0",
        navBarHidden: "true",
        id: "container"
    });
    $.__views.container && $.addTopLevelView($.__views.container);
    swipeListener ? $.__views.container.addEventListener("swipe", swipeListener) : __defers["$.__views.container!swipe!swipeListener"] = true;
    $.__views.statusBar = Ti.UI.createView({
        top: 0,
        height: 20,
        backgroundColor: "#88fcf9f9",
        id: "statusBar"
    });
    $.__views.container.add($.__views.statusBar);
    $.__views.wrapper = Ti.UI.createView({
        id: "wrapper"
    });
    $.__views.container.add($.__views.wrapper);
    $.__views.navTray = Alloy.createWidget("navtray", "widget", {
        id: "navTray",
        __parentSymbol: $.__views.wrapper
    });
    $.__views.navTray.setParent($.__views.wrapper);
    $.__views.content = Ti.UI.createView({
        height: Titanium.UI.FILL,
        backgroundColor: "white",
        id: "content"
    });
    $.__views.wrapper.add($.__views.content);
    $.__views.topNavbar = Ti.UI.createView({
        backgroundColor: "white",
        top: 0,
        height: 45,
        id: "topNavbar"
    });
    $.__views.content.add($.__views.topNavbar);
    $.__views.pageTitle = Ti.UI.createLabel({
        color: "#ff99cc",
        font: {
            fontSize: 16,
            fontFamily: "HelveticaNeue-Medium"
        },
        text: "Contact",
        id: "pageTitle"
    });
    $.__views.topNavbar.add($.__views.pageTitle);
    $.__views.btn_menu = Ti.UI.createImageView({
        right: 15,
        top: 5,
        height: 30,
        width: 30,
        backgroundColor: "transparent",
        title: "Menu",
        id: "btn_menu",
        image: "/images/icons/menu.png"
    });
    $.__views.topNavbar.add($.__views.btn_menu);
    openNavTray ? $.__views.btn_menu.addEventListener("click", openNavTray) : __defers["$.__views.btn_menu!click!openNavTray"] = true;
    $.__views.tabBar = Ti.UI.createView({
        top: 46,
        height: 40,
        id: "tabBar"
    });
    $.__views.content.add($.__views.tabBar);
    $.__views.marketingTab = Ti.UI.createLabel({
        color: "#999999",
        backgroundColor: "#eeeeee",
        borderColor: "transparent",
        height: Titanium.UI.FILL,
        textAlign: Titanium.UI.TEXT_ALIGNMENT_CENTER,
        right: 30,
        width: 100,
        text: "Marketing",
        id: "marketingTab"
    });
    $.__views.tabBar.add($.__views.marketingTab);
    switchTabs ? $.__views.marketingTab.addEventListener("click", switchTabs) : __defers["$.__views.marketingTab!click!switchTabs"] = true;
    $.__views.customerServiceTab = Ti.UI.createLabel({
        color: "#8dc63f",
        backgroundColor: "#f8f8f8",
        borderColor: "transparent",
        height: Titanium.UI.FILL,
        textAlign: Titanium.UI.TEXT_ALIGNMENT_CENTER,
        left: 30,
        width: 150,
        text: "Customer Service",
        id: "customerServiceTab"
    });
    $.__views.tabBar.add($.__views.customerServiceTab);
    switchTabs ? $.__views.customerServiceTab.addEventListener("click", switchTabs) : __defers["$.__views.customerServiceTab!click!switchTabs"] = true;
    $.__views.marketing = Ti.UI.createView({
        top: 100,
        bottom: 52,
        backgroundColor: "#FFFFFF",
        id: "marketing"
    });
    $.__views.content.add($.__views.marketing);
    $.__views.formWrap = Ti.UI.createScrollView({
        layout: "vertical",
        width: 250,
        id: "formWrap"
    });
    $.__views.marketing.add($.__views.formWrap);
    $.__views.__alloyId2 = Ti.UI.createView({
        height: Titanium.UI.SIZE,
        bottom: 10,
        left: 0,
        id: "__alloyId2"
    });
    $.__views.formWrap.add($.__views.__alloyId2);
    $.__views.__alloyId3 = Ti.UI.createLabel({
        height: Titanium.UI.SIZE,
        color: "#777777",
        font: {
            fontSize: 12
        },
        left: 0,
        text: "Want to see your photo on our social media accounts? Submit them here:",
        id: "__alloyId3"
    });
    $.__views.__alloyId2.add($.__views.__alloyId3);
    $.__views.nameMarketing = Ti.UI.createTextField({
        backgroundColor: "#eeeeee",
        width: Titanium.UI.FILL,
        textAlign: "left",
        height: 35,
        id: "nameMarketing",
        hintText: "NAME*"
    });
    $.__views.formWrap.add($.__views.nameMarketing);
    $.__views.emailMarketing = Ti.UI.createTextField({
        backgroundColor: "#eeeeee",
        width: Titanium.UI.FILL,
        textAlign: "left",
        height: 35,
        top: 10,
        id: "emailMarketing",
        hintText: "EMAIL*"
    });
    $.__views.formWrap.add($.__views.emailMarketing);
    $.__views.instagramMarketing = Ti.UI.createTextField({
        backgroundColor: "#eeeeee",
        width: Titanium.UI.FILL,
        textAlign: "left",
        height: 35,
        top: 10,
        id: "instagramMarketing",
        hintText: "INSTAGRAM HANDLE"
    });
    $.__views.formWrap.add($.__views.instagramMarketing);
    $.__views.twitterMarketing = Ti.UI.createTextField({
        backgroundColor: "#eeeeee",
        width: Titanium.UI.FILL,
        textAlign: "left",
        height: 35,
        top: 10,
        id: "twitterMarketing",
        hintText: "TWITTER HANDLE"
    });
    $.__views.formWrap.add($.__views.twitterMarketing);
    $.__views.messageMarketing = Ti.UI.createTextArea({
        backgroundColor: "#eeeeee",
        width: Titanium.UI.FILL,
        textAlign: "left",
        height: 70,
        top: 10,
        id: "messageMarketing",
        hintText: "MESSAGE"
    });
    $.__views.formWrap.add($.__views.messageMarketing);
    $.__views.attachmentView = Ti.UI.createView({
        height: 40,
        width: Titanium.UI.FILL,
        top: 10,
        left: 10,
        id: "attachmentView"
    });
    $.__views.formWrap.add($.__views.attachmentView);
    $.__views.__alloyId4 = Ti.UI.createView({
        width: 200,
        left: 0,
        id: "__alloyId4"
    });
    $.__views.attachmentView.add($.__views.__alloyId4);
    $.__views.__alloyId5 = Ti.UI.createImageView({
        left: 0,
        image: "/images/icons/camera.png",
        id: "__alloyId5"
    });
    $.__views.__alloyId4.add($.__views.__alloyId5);
    $.__views.btnPhotoMarketing = Ti.UI.createButton({
        borderColor: "transparent",
        color: "#ff99cc",
        right: 0,
        borderRadius: 0,
        style: 0,
        font: {
            fontSize: 18
        },
        height: 35,
        opacity: .9,
        textAlign: Titanium.UI.TEXT_ALIGNMENT_CENTER,
        backgroundColor: "transparent",
        left: 50,
        id: "btnPhotoMarketing",
        customTarget: "marketing",
        title: "ATTACH PHOTO"
    });
    $.__views.__alloyId4.add($.__views.btnPhotoMarketing);
    openAttachmentSelector ? $.__views.btnPhotoMarketing.addEventListener("click", openAttachmentSelector) : __defers["$.__views.btnPhotoMarketing!click!openAttachmentSelector"] = true;
    $.__views.photo_thumbMarketing = Ti.UI.createImageView({
        width: 40,
        right: 0,
        id: "photo_thumbMarketing",
        customTarget: "marketing"
    });
    $.__views.attachmentView.add($.__views.photo_thumbMarketing);
    openAttachmentSelector ? $.__views.photo_thumbMarketing.addEventListener("click", openAttachmentSelector) : __defers["$.__views.photo_thumbMarketing!click!openAttachmentSelector"] = true;
    $.__views.btnSendMarketing = Ti.UI.createButton({
        borderRadius: 0,
        borderColor: "transparent",
        style: 0,
        font: {
            fontSize: 18
        },
        color: "#999999",
        height: 30,
        backgroundColor: "#eeeeee",
        opacity: .9,
        textAlign: Titanium.UI.TEXT_ALIGNMENT_CENTER,
        top: 10,
        width: 80,
        id: "btnSendMarketing",
        title: "SEND"
    });
    $.__views.formWrap.add($.__views.btnSendMarketing);
    sendMarketingForm ? $.__views.btnSendMarketing.addEventListener("click", sendMarketingForm) : __defers["$.__views.btnSendMarketing!click!sendMarketingForm"] = true;
    $.__views.customerService = Ti.UI.createView({
        top: 100,
        bottom: 52,
        backgroundColor: "#FFFFFF",
        id: "customerService"
    });
    $.__views.content.add($.__views.customerService);
    $.__views.formWrap = Ti.UI.createScrollView({
        layout: "vertical",
        width: 250,
        id: "formWrap"
    });
    $.__views.customerService.add($.__views.formWrap);
    $.__views.__alloyId6 = Ti.UI.createView({
        height: Titanium.UI.SIZE,
        bottom: 10,
        left: 0,
        id: "__alloyId6"
    });
    $.__views.formWrap.add($.__views.__alloyId6);
    $.__views.__alloyId7 = Ti.UI.createLabel({
        height: Titanium.UI.SIZE,
        color: "#777777",
        font: {
            fontSize: 12
        },
        left: 0,
        text: "Have a question or concern regarding your order? Submit questions here(Please include photos if necessary!):",
        id: "__alloyId7"
    });
    $.__views.__alloyId6.add($.__views.__alloyId7);
    $.__views.nameCustomerService = Ti.UI.createTextField({
        backgroundColor: "#eeeeee",
        width: Titanium.UI.FILL,
        textAlign: "left",
        height: 35,
        id: "nameCustomerService",
        hintText: "NAME*"
    });
    $.__views.formWrap.add($.__views.nameCustomerService);
    $.__views.emailCustomerService = Ti.UI.createTextField({
        backgroundColor: "#eeeeee",
        width: Titanium.UI.FILL,
        textAlign: "left",
        height: 35,
        top: 10,
        id: "emailCustomerService",
        hintText: "EMAIL*"
    });
    $.__views.formWrap.add($.__views.emailCustomerService);
    $.__views.phoneCustomerService = Ti.UI.createTextField({
        backgroundColor: "#eeeeee",
        width: Titanium.UI.FILL,
        textAlign: "left",
        height: 35,
        top: 10,
        id: "phoneCustomerService",
        hintText: "PHONE"
    });
    $.__views.formWrap.add($.__views.phoneCustomerService);
    $.__views.orderCustomerService = Ti.UI.createTextField({
        backgroundColor: "#eeeeee",
        width: Titanium.UI.FILL,
        textAlign: "left",
        height: 35,
        top: 10,
        id: "orderCustomerService",
        hintText: "ORDER #"
    });
    $.__views.formWrap.add($.__views.orderCustomerService);
    $.__views.messageCustomerService = Ti.UI.createTextArea({
        backgroundColor: "#eeeeee",
        width: Titanium.UI.FILL,
        textAlign: "left",
        height: 70,
        top: 10,
        id: "messageCustomerService",
        hintText: "MESSAGE"
    });
    $.__views.formWrap.add($.__views.messageCustomerService);
    $.__views.attachmentView = Ti.UI.createView({
        height: 40,
        width: Titanium.UI.FILL,
        top: 10,
        left: 10,
        id: "attachmentView"
    });
    $.__views.formWrap.add($.__views.attachmentView);
    $.__views.__alloyId8 = Ti.UI.createView({
        width: 200,
        left: 0,
        id: "__alloyId8"
    });
    $.__views.attachmentView.add($.__views.__alloyId8);
    $.__views.__alloyId9 = Ti.UI.createImageView({
        left: 0,
        image: "/images/icons/camera.png",
        id: "__alloyId9"
    });
    $.__views.__alloyId8.add($.__views.__alloyId9);
    openAttachmentSelector ? $.__views.__alloyId9.addEventListener("click", openAttachmentSelector) : __defers["$.__views.__alloyId9!click!openAttachmentSelector"] = true;
    $.__views.btnPhotoCustomerService = Ti.UI.createButton({
        borderColor: "transparent",
        color: "#ff99cc",
        right: 0,
        borderRadius: 0,
        style: 0,
        font: {
            fontSize: 18
        },
        height: 35,
        opacity: .9,
        textAlign: Titanium.UI.TEXT_ALIGNMENT_CENTER,
        backgroundColor: "transparent",
        left: 50,
        id: "btnPhotoCustomerService",
        customTarget: "customerService",
        title: "ATTACH PHOTO"
    });
    $.__views.__alloyId8.add($.__views.btnPhotoCustomerService);
    openAttachmentSelector ? $.__views.btnPhotoCustomerService.addEventListener("click", openAttachmentSelector) : __defers["$.__views.btnPhotoCustomerService!click!openAttachmentSelector"] = true;
    $.__views.photo_thumbCustomerService = Ti.UI.createImageView({
        width: 40,
        right: 0,
        id: "photo_thumbCustomerService",
        customTarget: "customerService"
    });
    $.__views.attachmentView.add($.__views.photo_thumbCustomerService);
    openAttachmentSelector ? $.__views.photo_thumbCustomerService.addEventListener("click", openAttachmentSelector) : __defers["$.__views.photo_thumbCustomerService!click!openAttachmentSelector"] = true;
    $.__views.btnSendCustomService = Ti.UI.createButton({
        borderRadius: 0,
        borderColor: "transparent",
        style: 0,
        font: {
            fontSize: 18
        },
        color: "#999999",
        height: 30,
        backgroundColor: "#eeeeee",
        opacity: .9,
        textAlign: Titanium.UI.TEXT_ALIGNMENT_CENTER,
        top: 10,
        width: 80,
        id: "btnSendCustomService",
        title: "SEND"
    });
    $.__views.formWrap.add($.__views.btnSendCustomService);
    sendCustomerServiceForm ? $.__views.btnSendCustomService.addEventListener("click", sendCustomerServiceForm) : __defers["$.__views.btnSendCustomService!click!sendCustomerServiceForm"] = true;
    $.__views.bottomToolbar = Alloy.createWidget("toolbar", "widget", {
        id: "bottomToolbar",
        __parentSymbol: $.__views.content
    });
    $.__views.bottomToolbar.setParent($.__views.content);
    exports.destroy = function() {};
    _.extend($, $.__views);
    $.container.orientationModes = [ Ti.UI.PORTRAIT ];
    Titanium.UI.orientation = Ti.UI.PORTRAIT;
    var pages = require("/pageutils");
    Alloy.Globals.activeWindows["contact"] = $.container;
    Alloy.Globals.currentWindow = $.container;
    $.statusBar.visible = Alloy.Globals.isiOS7Plus() ? true : false;
    $.wrapper.top = Alloy.Globals.isiOS7Plus() ? 20 : 0;
    Alloy.Globals.setFlashSaleTimer("contact", $.navTray.updateTimer);
    var attachment = null;
    var target = "";
    var actInd = Titanium.UI.createActivityIndicator({
        width: 50,
        height: 50
    });
    $.container.add(actInd);
    $.container.addEventListener("load", function() {
        $.navTray.navTray.visible = true;
    });
    $.bottomToolbar.setCurrentView("contact");
    __defers["$.__views.container!swipe!swipeListener"] && $.__views.container.addEventListener("swipe", swipeListener);
    __defers["$.__views.btn_menu!click!openNavTray"] && $.__views.btn_menu.addEventListener("click", openNavTray);
    __defers["$.__views.marketingTab!click!switchTabs"] && $.__views.marketingTab.addEventListener("click", switchTabs);
    __defers["$.__views.customerServiceTab!click!switchTabs"] && $.__views.customerServiceTab.addEventListener("click", switchTabs);
    __defers["$.__views.btnPhotoMarketing!click!openAttachmentSelector"] && $.__views.btnPhotoMarketing.addEventListener("click", openAttachmentSelector);
    __defers["$.__views.photo_thumbMarketing!click!openAttachmentSelector"] && $.__views.photo_thumbMarketing.addEventListener("click", openAttachmentSelector);
    __defers["$.__views.btnSendMarketing!click!sendMarketingForm"] && $.__views.btnSendMarketing.addEventListener("click", sendMarketingForm);
    __defers["$.__views.__alloyId9!click!openAttachmentSelector"] && $.__views.__alloyId9.addEventListener("click", openAttachmentSelector);
    __defers["$.__views.btnPhotoCustomerService!click!openAttachmentSelector"] && $.__views.btnPhotoCustomerService.addEventListener("click", openAttachmentSelector);
    __defers["$.__views.photo_thumbCustomerService!click!openAttachmentSelector"] && $.__views.photo_thumbCustomerService.addEventListener("click", openAttachmentSelector);
    __defers["$.__views.btnSendCustomService!click!sendCustomerServiceForm"] && $.__views.btnSendCustomService.addEventListener("click", sendCustomerServiceForm);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;