function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    function copyToClipboard(e) {
        Titanium.UI.Clipboard.setText(e.row.couponCode);
        Titanium.UI.createAlertDialog({
            message: e.row.couponCode + " copied to clipboard",
            title: "Coupon Code"
        }).show();
    }
    function flashNoCoupons() {
        var notificationView = Titanium.UI.createView();
        var label = Titanium.UI.createLabel({
            text: "No Coupons Available"
        });
        notificationView.add(label);
        $.mainView.add(notificationView);
    }
    function swipeListener(e) {
        if ("left" == e.direction && !open_tray || "right" == e.direction && open_tray) {
            openNavTray(e);
            open_tray = open_tray ? false : true;
        }
    }
    function openNavTray() {
        $.navTray.toggle($.content);
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "coupons";
    if (arguments[0]) {
        {
            __processArg(arguments[0], "__parentSymbol");
        }
        {
            __processArg(arguments[0], "$model");
        }
        {
            __processArg(arguments[0], "__itemTemplate");
        }
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.container = Ti.UI.createWindow({
        backgroundColor: "#fa72c0",
        navBarHidden: "true",
        id: "container"
    });
    $.__views.container && $.addTopLevelView($.__views.container);
    swipeListener ? $.__views.container.addEventListener("swipe", swipeListener) : __defers["$.__views.container!swipe!swipeListener"] = true;
    $.__views.statusBar = Ti.UI.createView({
        top: 0,
        height: 20,
        backgroundColor: "#88fcf9f9",
        id: "statusBar"
    });
    $.__views.container.add($.__views.statusBar);
    $.__views.wrapper = Ti.UI.createView({
        id: "wrapper"
    });
    $.__views.container.add($.__views.wrapper);
    $.__views.navTray = Alloy.createWidget("navtray", "widget", {
        id: "navTray",
        __parentSymbol: $.__views.wrapper
    });
    $.__views.navTray.setParent($.__views.wrapper);
    $.__views.content = Ti.UI.createView({
        height: Titanium.UI.FILL,
        backgroundColor: "white",
        id: "content"
    });
    $.__views.wrapper.add($.__views.content);
    $.__views.topNavbar = Ti.UI.createView({
        backgroundColor: "white",
        top: 0,
        height: 45,
        id: "topNavbar"
    });
    $.__views.content.add($.__views.topNavbar);
    $.__views.pageTitle = Ti.UI.createLabel({
        color: "#ff99cc",
        font: {
            fontSize: 16,
            fontFamily: "HelveticaNeue-Medium"
        },
        text: "Coupons",
        id: "pageTitle"
    });
    $.__views.topNavbar.add($.__views.pageTitle);
    $.__views.btn_menu = Ti.UI.createImageView({
        right: 15,
        top: 5,
        height: 30,
        width: 30,
        backgroundColor: "transparent",
        title: "Menu",
        id: "btn_menu",
        image: "/images/icons/menu.png"
    });
    $.__views.topNavbar.add($.__views.btn_menu);
    openNavTray ? $.__views.btn_menu.addEventListener("click", openNavTray) : __defers["$.__views.btn_menu!click!openNavTray"] = true;
    $.__views.header = Ti.UI.createView({
        backgroundColor: "#eeeeee",
        height: 25,
        width: Titanium.UI.FILL,
        top: 46,
        id: "header"
    });
    $.__views.content.add($.__views.header);
    $.__views.header_label = Ti.UI.createLabel({
        left: 15,
        color: "#666666",
        font: {
            fontSize: 12
        },
        text: "CURRENT COUPON CODES",
        id: "header_label"
    });
    $.__views.header.add($.__views.header_label);
    $.__views.mainView = Ti.UI.createView({
        top: 73,
        bottom: 0,
        id: "mainView"
    });
    $.__views.content.add($.__views.mainView);
    $.__views.topNavbar_separator = Ti.UI.createView({
        id: "topNavbar_separator"
    });
    $.__views.mainView.add($.__views.topNavbar_separator);
    $.__views.bottomToolbar = Alloy.createWidget("toolbar", "widget", {
        id: "bottomToolbar",
        __parentSymbol: $.__views.content
    });
    $.__views.bottomToolbar.setParent($.__views.content);
    exports.destroy = function() {};
    _.extend($, $.__views);
    $.container.orientationModes = [ Ti.UI.PORTRAIT ];
    Titanium.UI.orientation = Ti.UI.PORTRAIT;
    var pages = require("/pageutils");
    Alloy.Globals.activeWindows["coupons"] = $.container;
    Alloy.Globals.currentWindow = $.container;
    Alloy.Globals.setFlashSaleTimer("coupons", $.navTray.updateTimer);
    var open_tray = false;
    $.statusBar.visible = Alloy.Globals.isiOS7Plus() ? true : false;
    $.wrapper.top = Alloy.Globals.isiOS7Plus() ? 20 : 0;
    $.container.addEventListener("load", function() {
        $.navTray.navTray.visible = true;
    });
    $.bottomToolbar.setCurrentView("coupons");
    Alloy.Globals.get_remote_file("coupons.xml", Alloy.Globals.ADMIN_SERVER_URL + "coupons/feed", true, function() {
        pages.log("There was an error dowloading the content.list file");
    }, function() {}, function() {
        pages.log("coupons.xml was successfully downloaded.");
        var file = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, "coupons.xml");
        if (file.exists()) {
            var table = Titanium.UI.createTableView({
                footerTitle: null
            });
            var xmltext = file.read().text;
            var doc = Titanium.XML.parseString(xmltext);
            var coupons = doc.getElementsByTagName("coupon");
            if (coupons.length > 0) {
                for (var i = 0; i < coupons.length; i++) {
                    var code = coupons.item(i).getElementsByTagName("code").item(0).text;
                    var description = coupons.item(i).getElementsByTagName("description").item(0).text;
                    var tableRow = Titanium.UI.createTableViewRow({
                        className: "couponRow",
                        couponCode: code,
                        rowID: i,
                        height: 70,
                        color: "#999999",
                        left: 15,
                        selectionStyle: null
                    });
                    var label = Titanium.UI.createLabel({
                        text: description + " - " + code,
                        font: {
                            fontSize: 16,
                            fontFamily: "Helvetica Neue"
                        },
                        textAlign: Titanium.UI.TEXT_ALIGNMENT_LEFT,
                        left: 20,
                        right: 20,
                        height: Titanium.UI.FILL,
                        color: "#999999",
                        wordWrap: true
                    });
                    tableRow.add(label);
                    tableRow.addEventListener("click", copyToClipboard);
                    table.appendRow(tableRow);
                }
                $.mainView.add(table);
            } else flashNoCoupons();
        } else flashNoCoupons();
    });
    __defers["$.__views.container!swipe!swipeListener"] && $.__views.container.addEventListener("swipe", swipeListener);
    __defers["$.__views.btn_menu!click!openNavTray"] && $.__views.btn_menu.addEventListener("click", openNavTray);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;