function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    function openWallpaper() {
        switch (wallpaper_button_state) {
          case 1:
            pages.open({
                type: "controller",
                name: "wallpaper"
            });
            break;

          case 2:
            $.btn_wallpaper_label_notice.visible = false;
            processQueue();
            break;

          case 3:
            alert("Please wait for content to finish loading");
            break;

          case 4:
            $.btn_wallpaper_label_notice.visible = false;
            current_fetch_attempts = 0;
            checkForContent();
        }
    }
    function openShopping() {
        pages.open({
            type: "web",
            name: "shop",
            title: Alloy.Globals.landingButtons["shop"].title,
            url: Alloy.Globals.landingButtons["shop"].link
        });
    }
    function openFlashSales() {
        pages.open({
            type: "web",
            name: "flashsales",
            title: Alloy.Globals.landingButtons["flashsales"].title,
            url: Alloy.Globals.landingButtons["flashsales"].link
        });
    }
    function openDeals() {
        pages.open({
            type: "controller",
            name: "deals"
        });
    }
    function openBlog() {
        pages.open({
            type: "web",
            name: "blog",
            title: Alloy.Globals.landingButtons["blog"].title,
            url: Alloy.Globals.landingButtons["blog"].link
        });
    }
    function openContact() {
        pages.open({
            type: "controller",
            name: "contact"
        });
    }
    function openNewProducts() {
        pages.open({
            type: "web",
            name: "newproducts",
            title: Alloy.Globals.landingButtons["newproducts"].title,
            url: Alloy.Globals.landingButtons["newproducts"].link
        });
    }
    function openFAQ() {
        pages.open({
            type: "web",
            name: "faq",
            title: Alloy.Globals.landingButtons["faq"].title,
            url: Alloy.Globals.landingButtons["faq"].link
        });
    }
    function openSettings() {
        pages.toggle({
            type: "controller",
            name: "settings"
        });
    }
    function fetchNewContent(files) {
        for (var i = 0; i < files.length; i++) files[i].url = "stamps" == files[i].type ? Alloy.Globals.CONFIG_SERVER_URL + files[i].filename.replace("stamps/", "content/stamps/android/") : Alloy.Globals.CONFIG_SERVER_URL + files[i].filename.replace("backgrounds/", "content/backgrounds/thumbs/");
        var progressBar = Titanium.UI.createProgressBar({
            width: 140,
            height: 25,
            bottom: 0,
            min: 0,
            max: files.length,
            font: {
                fontSize: 12
            },
            style: Titanium.UI.iPhone.ProgressBarStyle.PLAIN
        });
        $.btn_wallpaper.add(progressBar);
        $.btn_wallpaper_label.visible = false;
        processQueue = function() {
            wallpaper_button_state = 3;
            progressBar.show();
            download_helper.fetch_queued_files(files, function(e) {
                pages.log("Error downloading file " + e.filename + ". ERROR: " + e.error);
                alert("We are unable to download your new content at this time. Check your Internet connectivity and try again.");
                progressBar.hide();
                $.btn_wallpaper_label_notice.text = "Paused...";
                $.btn_wallpaper_label_notice.visible = true;
                wallpaper_button_state = 2;
            }, function(e) {
                progressBar.value = e.index;
            }, function() {
                content_fetch_attempts++;
                pages.log("Finished downloading remote content");
                Titanium.App.Properties.setString("content.token", content_token);
                Titanium.App.Properties.setString("contentLoaded" + Titanium.App.version, "true");
                progressBar.hide();
                var verified = verifyContent();
                if (verified) {
                    $.btn_wallpaper_label_notice.visible = false;
                    $.btn_wallpaper_label.visible = true;
                    wallpaper_button_state = 1;
                } else if (content_fetch_attempts >= 2) {
                    pages.log("Setting the Retry Event State");
                    $.btn_wallpaper_label_notice.text = "Retry download...";
                    $.btn_wallpaper_label_notice.visible = true;
                    wallpaper_button_state = 4;
                }
            });
        };
        processQueue();
    }
    function checkForContent() {
        var xhr = Titanium.Network.createHTTPClient();
        var remote_source = Alloy.Globals.CONFIG_SERVER_URL + "content.token";
        pages.log("FORCE_CONTENTREFRESH = " + Alloy.Globals.appConfigArray["force_contentrefresh"]);
        content_timestamp = Titanium.App.Properties.getString("content.timestamp", "00000000000000");
        var db = Titanium.Database.open("messages");
        var result = db.execute("SELECT count(*) AS missing FROM file_assets WHERE downloaded = ?", false);
        var missingFiles = result.fieldByName("missing");
        db.close();
        xhr.open("GET", remote_source);
        xhr.onload = function() {
            if (200 == xhr.status) {
                var data = this.responseText;
                var remoteToken = JSON.parse(data);
                var forceRefresh = Alloy.Globals.appConfigArray["force_contentrefresh"] > content_timestamp ? true : false;
                pages.log("CHECKING FOR NEW CONTENT: content_timestamp = " + content_timestamp + " | force_contentrefresh = " + Alloy.Globals.appConfigArray["force_contentrefresh"]);
                pages.log("CHECKING FOR NEW CONTENT: remote token = " + remoteToken.checksum + "|" + remoteToken.timestamp);
                pages.log("CHECKING FOR NEW CONTENT: local token = " + Titanium.App.Properties.getString("content.token") + "|" + Titanium.App.Properties.getString("content.timestamp"));
                if (Titanium.App.Properties.getString("content.token") !== remoteToken.checksum || forceRefresh || "false" == Titanium.App.Properties.getString("contentLoaded" + Titanium.App.version, "false") || missingFiles > 0) {
                    content_token = remoteToken.checksum;
                    content_timestamp = remoteToken.timestamp;
                    Titanium.App.Properties.setString("content.timestamp", content_timestamp);
                    if (forceRefresh) {
                        var folder = Titanium.Filesystem.applicationDataDirectory + Titanium.Filesystem.separator + "stamps";
                        var f = Titanium.Filesystem.getFile(folder);
                        f.deleteDirectory(true);
                        folder = Titanium.Filesystem.applicationDataDirectory + Titanium.Filesystem.separator + "backgrounds";
                        f = Titanium.Filesystem.getFile(folder);
                        f.deleteDirectory(true);
                    }
                    Alloy.Globals.get_remote_file("content-v2.list", Alloy.Globals.CONFIG_SERVER_URL + "content-v2.list", true, function() {
                        pages.log("There was an error dowloading the content-v2.list file");
                    }, function() {}, function() {
                        var file = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory + "content-v2.list");
                        var data_content_list = file.read().text;
                        JSON.parse(data_content_list);
                        data_content_list = findMissingFiles(JSON.parse(data_content_list), forceRefresh);
                        fetchNewContent(data_content_list);
                        cleanContent();
                    });
                } else wallpaper_button_state = 1;
            }
        };
        xhr.onerror = function(e) {
            pages.log("ERROR fetching the REMOTE content.token: " + e.error);
        };
        xhr.send();
    }
    function cleanContent() {
        var dt = new Date();
        var _date = dt.getFullYear() + "/" + (dt.getMonth() + 1) + "/" + dt.getDate();
        var db = Titanium.Database.open("messages");
        var result = [];
        var images = db.execute("SELECT filename as filename FROM file_assets WHERE lastupdate <> ?", _date);
        if (images.isValidRow()) while (images.isValidRow()) {
            var res = {
                filename: images.fieldByName("filename")
            };
            result.push(res);
            images.next();
        }
        for (var ii = 0; result.length > ii; ii++) {
            var deleteQuery = "DELETE FROM file_assets WHERE filename='" + result[ii].filename + "';";
            db.execute(deleteQuery);
            var file = Ti.Filesystem.getFile(Ti.Filesystem.applicationDataDirectory, result[ii].filename);
            file.exists() && file.deleteFile();
        }
        db.close();
    }
    function findMissingFiles(files, forceRefresh) {
        var downloadList = [];
        var db = Titanium.Database.open("messages");
        var dt = new Date();
        var _date = dt.getFullYear() + "/" + (dt.getMonth() + 1) + "/" + dt.getDate();
        forceRefresh && db.execute("DELETE FROM file_assets");
        for (var i = 0; i < files.length; i++) {
            var result = db.execute("SELECT * FROM file_assets WHERE filename = ?", files[i].filename);
            pages.log("findFiles.filename = " + files[i].filename);
            if (result.isValidRow()) {
                db.execute("UPDATE file_assets SET lastupdate = ? WHERE filename = ?", _date, files[i].filename);
                pages.log("findFiles.isValidRow = true");
                if (!result.fieldByName("downloaded")) {
                    pages.log("findFiles.downloaded = " + (result.fieldByName("downloaded") ? "true" : "false") + " | localchecksum = " + result.fieldByName("localchecksum") + " | remotechecksum = " + files[i].checksum);
                    downloadList.push(files[i]);
                }
            } else {
                pages.log("findMissingFiles.isValidRow = false");
                db.execute("INSERT INTO file_assets (filename, type, remotechecksum, downloaded,lastupdate) VALUES (?, ?, ?, ?,?)", files[i].filename, files[i].type, files[i].checksum, false, _date);
                downloadList.push(files[i]);
            }
        }
        db.close();
        for (var n = 0; n < downloadList.length; n++) pages.log("MISSING FILE: " + downloadList[n].filename + " | localchecksum = " + downloadList[n].localchecksum + " | remotechecksum = " + downloadList[n].checksum);
        return downloadList;
    }
    function verifyContent() {
        var db = Titanium.Database.open("messages");
        var file_assets = db.execute("SELECT * FROM file_assets");
        var all_verified = true;
        var downloadList = [];
        $.btn_wallpaper_label_notice.text = "Verifying...";
        $.btn_wallpaper_label_notice.visible = true;
        while (file_assets.isValidRow()) {
            var filename = file_assets.fieldByName("filename");
            var type = file_assets.fieldByName("type");
            var localchecksum = file_assets.fieldByName("localchecksum");
            var remotechecksum = file_assets.fieldByName("remotechecksum");
            var downloaded = file_assets.fieldByName("downloaded");
            {
                file_assets.fieldByName("lastUpdate");
            }
            var obj;
            pages.log("verifyContent:: {" + filename + ", " + type + ", " + checksum + ", " + downloaded + "}");
            var file_obj = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, filename);
            pages.log("verifyContent:: " + (file_obj.isFile() ? "FILE EXISTS" : "FILE DOES NOT EXIST"));
            if (file_obj.isFile()) {
                var file_blob = file_obj.read();
                var checksum = Titanium.Utils.md5HexDigest(file_blob);
                Titanium.API.info("FILE: " + filename + " | LOCAL CHECKSUM: " + checksum + " | REMOTE CHECKSUM: " + remotechecksum);
                if (checksum == remotechecksum) {
                    db.execute("UPDATE file_assets SET downloaded = ?, localchecksum = ? WHERE filename = ?", true, checksum, filename);
                    Titanium.API.info("FILE :" + filename + " recorded as DOWNLOADED");
                    pages.log("verifyContent:: " + [ Titanium.Filesystem.applicationDataDirectory, filename ].join(Titanium.Filesystem.separator) + " VERIFIED");
                } else {
                    db.execute("UPDATE file_assets SET downloaded = ?, localchecksum = ? WHERE filename = ?", false, checksum, filename);
                    Titanium.API.info("FILE: " + filename + " recorded as NOT DOWNLOADED");
                    pages.log("verifyContent:: " + [ Titanium.Filesystem.applicationDataDirectory, filename ].join(Titanium.Filesystem.separator) + " NOT VERIFIED");
                    obj = {
                        filename: filename,
                        type: type,
                        checksum: remotechecksum,
                        localchecksum: checksum
                    };
                    downloadList.push(obj);
                    all_verified = false;
                }
            } else {
                pages.log("verifyContent:: " + [ Titanium.Filesystem.applicationDataDirectory, filename ].join(Titanium.Filesystem.separator) + " NOT VERIFIED");
                db.execute("UPDATE file_assets SET downloaded = ? WHERE filename = ?", false, filename);
                obj = {
                    filename: filename,
                    type: type,
                    checksum: remotechecksum,
                    localchecksum: localchecksum
                };
                downloadList.push(obj);
                all_verified = false;
            }
            file_assets.next();
        }
        db.close();
        for (var i = 0; i < downloadList.length; i++) pages.log("UNVERIFIED FILE: " + downloadList[i].filename + " | localchecksum = " + downloadList[i].localchecksum + " | remotechecksum = " + downloadList[i].checksum);
        if (!all_verified && 2 > content_fetch_attempts) {
            pages.log("ATTEMPTING TO FETCH UNVERIFIED FILES...ATTEMPT " + content_fetch_attempts);
            fetchNewContent(downloadList);
        } else if (!all_verified && content_fetch_attempts >= 2) {
            pages.log("MAX ATTEMPTS REACHED AND UNVERIFIED FILES REMAIN. POST NOTICE TO SERVER.");
            alert("Some of the files from the content package were not downloaded correctly from the server. The support department has been notified. Please check your internet connection and click the Wallaper icon to try again.\n\nIf the problem persists, please send a note to customer service through the contact area.");
            postFailedContentNotification(downloadList);
        } else all_verified && pages.log("ALL FILES VERIFIED.");
        $.btn_wallpaper_label_notice.text = "";
        return all_verified;
    }
    function postFailedContentNotification(files) {
        var url = Alloy.Globals.ADMIN_SERVER_URL + "/failed_content_log";
        var xhr = Ti.Network.createHTTPClient({
            onload: function() {
                Ti.API.info(this.responseText);
            },
            onerror: function(e) {
                Ti.API.error(e);
            },
            timeout: 1e4
        });
        xhr.open("POST", url);
        xhr.setRequestHeader("Content-Type", "application/json; charset=utf-8");
        var data = {
            files: files
        };
        xhr.send(JSON.stringify(data));
    }
    function formatTime(milliseconds) {
        var temp = milliseconds / 1e3;
        var years = Math.floor(temp / 31536e3);
        var days = Math.floor((temp %= 31536e3) / 86400);
        var hours = Math.floor((temp %= 86400) / 3600);
        var minutes = Math.floor((temp %= 3600) / 60);
        var seconds = Math.floor(temp % 60);
        var currentTimeString = days > 0 ? days + " day" : "";
        currentTimeString += "" === currentTimeString ? pad(hours, 2) + ":" + pad(minutes, 2) + ":" + pad(seconds, 2) : days > 1 ? "s" : "";
        pages.log("years = " + years + ", days = " + days + ", hours = " + hours + ", minutes = " + minutes + ", seconds = " + seconds);
        pages.log("currentTimeString = " + currentTimeString);
        return currentTimeString;
    }
    function getTimerVal() {
        var timeVal;
        if (Alloy.Globals.flashSaleInfo.started) {
            timeVal = Math.abs(Alloy.Globals.flashSaleInfo.stop - moment());
            if (moment() > Alloy.Globals.flashSaleInfo.stop) {
                Alloy.Globals.flashSaleInfo.stopped = true;
                Alloy.Globals.flashSaleInfo.started = false;
                Alloy.Globals.flashSaleInfo.scheduled = false;
            }
            pages.log("We're counting down to the end of the flash sale");
        } else if (Alloy.Globals.flashSaleInfo.scheduled) {
            timeVal = Math.abs(moment() - Alloy.Globals.flashSaleInfo.start);
            moment() > Alloy.Globals.flashSaleInfo.start && (Alloy.Globals.flashSaleInfo.started = true);
            pages.log("We're counting down to the start of the flash sale");
        }
        return formatTime(timeVal);
    }
    function getFlashSaleInfo(info) {
        var flashStartTime = moment(info.start, "YYYY-MM-DD HH:mm:ss Z");
        var flashStopTime = moment(info.stop, "YYYY-MM-DD HH:mm:ss Z");
        var currentTime = moment();
        var scheduled = flashStartTime > currentTime || flashStopTime > currentTime ? true : false;
        return {
            scheduled: scheduled,
            start: flashStartTime,
            stop: flashStopTime
        };
    }
    function setupFlashSaletimer() {
        var url = Alloy.Globals.ADMIN_SERVER_URL + "/flashsales/feed";
        Alloy.Globals.flashSaleInfo = getFlashSaleInfo({
            start: "",
            stop: ""
        });
        Alloy.Globals.timerUpdaters = [];
        if (true === Titanium.Network.online) {
            var c = Titanium.Network.createHTTPClient();
            c.setTimeout(2e4);
            c.onload = function(e) {
                if (200 == c.status) {
                    Alloy.Globals.timerUpdaters = [];
                    pages.log("FLASH SALE TIMER response from server: " + this.responseText);
                    Alloy.Globals.flashSaleInfo = getFlashSaleInfo(JSON.parse(this.responseText));
                    var currentTime = moment();
                    var updateTimer = function() {
                        for (var i = 0; i < Alloy.Globals.timerUpdaters.length; i++) Alloy.Globals.timerUpdaters[i].callback(getTimerVal());
                        toggleFlashSaleButton();
                    };
                    pages.log("Current Time = " + currentTime + " AND flashSaleInfo.start = " + Alloy.Globals.flashSaleInfo.start + " AND flashSaleInfo.stop = " + Alloy.Globals.flashSaleInfo.stop);
                    if (Alloy.Globals.flashSaleInfo.start < currentTime && currentTime < Alloy.Globals.flashSaleInfo.stop) {
                        pages.log("DETECTED THE START OF THE FLASH SALE");
                        Alloy.Globals.flashSaleInfo.started = true;
                    }
                    (Alloy.Globals.flashSaleInfo.started || Alloy.Globals.flashSaleInfo.scheduled) && setInterval(updateTimer, 1e3);
                } else {
                    e.error = "file not found";
                    pages.log("ERROR FETCHING REMOTE FILE FROM SERVER: " + url + " ERROR: " + e.error);
                }
            };
            c.ondatastream = function() {};
            c.onerror = function(e) {
                pages.log("ERROR FETCHING REMOTE FILE FROM SERVER: " + url + " ERROR: " + e.error);
            };
            c.open("GET", url);
            c.send();
        } else alert("No Internet connectivity...");
    }
    function pad(num, size) {
        var s = num + "";
        while (s.length < size) s = "0" + s;
        return s;
    }
    function toggleFlashSaleButton() {
        if (Alloy.Globals.flashSaleInfo.started) {
            flashSaleState = flashSaleState ? false : true;
            if (!btnFlashSaleAnimating) {
                btnFlashSaleAnimating = true;
                $.btn_flash_sales_img.animate(flashOn);
            }
        }
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "index";
    if (arguments[0]) {
        {
            __processArg(arguments[0], "__parentSymbol");
        }
        {
            __processArg(arguments[0], "$model");
        }
        {
            __processArg(arguments[0], "__itemTemplate");
        }
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.mainWin = Ti.UI.createWindow({
        backgroundImage: "/images/bg_landing-circles.png",
        exitOnClose: true,
        navBarHidden: true,
        id: "mainWin"
    });
    $.__views.mainWin && $.addTopLevelView($.__views.mainWin);
    $.__views.statusBar = Ti.UI.createView({
        top: 0,
        height: 20,
        backgroundColor: "#88fcf9f9",
        id: "statusBar"
    });
    $.__views.mainWin.add($.__views.statusBar);
    $.__views.topBanner = Ti.UI.createView(function() {
        var o = {};
        _.extend(o, {
            backgroundColor: "transparent",
            top: 20,
            height: 150
        });
        Alloy.isTablet && _.extend(o, {
            top: 80,
            height: 300
        });
        _.extend(o, {
            id: "topBanner"
        });
        return o;
    }());
    $.__views.mainWin.add($.__views.topBanner);
    $.__views.logo = Ti.UI.createImageView(function() {
        var o = {};
        _.extend(o, {
            top: -110,
            height: 110,
            width: 110,
            opacity: "0.2"
        });
        Alloy.isTablet && _.extend(o, {
            top: -110,
            height: 220,
            width: 220,
            opacity: "0.2"
        });
        _.extend(o, {
            id: "logo",
            image: "/images/logo.png"
        });
        return o;
    }());
    $.__views.topBanner.add($.__views.logo);
    var __alloyId23 = [];
    if (!Alloy.isTablet) {
        $.__views.page1 = Ti.UI.createView({
            id: "page1"
        });
        __alloyId23.push($.__views.page1);
        $.__views.__alloyId24 = Ti.UI.createView(function() {
            var o = {};
            _.extend(o, {
                height: Titanium.UI.SIZE
            });
            Alloy.isTablet && _.extend(o, {
                width: Titanium.UI.SIZE
            });
            _.extend(o, {
                id: "__alloyId24"
            });
            return o;
        }());
        $.__views.page1.add($.__views.__alloyId24);
        $.__views.btn_wallpaper = Ti.UI.createView(function() {
            var o = {};
            _.extend(o, {
                top: 0,
                left: 50,
                opacity: "1",
                width: 100,
                height: 100
            });
            Alloy.isTablet && _.extend(o, {
                width: 150,
                height: 150
            });
            _.extend(o, {
                id: "btn_wallpaper"
            });
            return o;
        }());
        $.__views.__alloyId24.add($.__views.btn_wallpaper);
        openWallpaper ? $.__views.btn_wallpaper.addEventListener("click", openWallpaper) : __defers["$.__views.btn_wallpaper!click!openWallpaper"] = true;
        $.__views.__alloyId25 = Ti.UI.createImageView(function() {
            var o = {};
            _.extend(o, {
                width: 77,
                height: 77,
                top: 0
            });
            Alloy.isTablet && _.extend(o, {
                width: 100,
                height: 100,
                top: 0
            });
            _.extend(o, {
                image: "/images/buttons/wallpaper.png",
                id: "__alloyId25"
            });
            return o;
        }());
        $.__views.btn_wallpaper.add($.__views.__alloyId25);
        $.__views.btn_wallpaper_label = Ti.UI.createLabel(function() {
            var o = {};
            _.extend(o, {
                height: 20,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 12
                },
                color: "white"
            });
            Alloy.isTablet && _.extend(o, {
                height: 40,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 16
                },
                color: "white"
            });
            _.extend(o, {
                text: "WALLPAPER",
                id: "btn_wallpaper_label"
            });
            return o;
        }());
        $.__views.btn_wallpaper.add($.__views.btn_wallpaper_label);
        $.__views.btn_wallpaper_label_notice = Ti.UI.createLabel(function() {
            var o = {};
            _.extend(o, {
                height: 20,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 12
                },
                color: "white"
            });
            Alloy.isTablet && _.extend(o, {
                height: 40,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 16
                },
                color: "white"
            });
            _.extend(o, {
                visible: false,
                text: "Paused...",
                id: "btn_wallpaper_label_notice"
            });
            return o;
        }());
        $.__views.btn_wallpaper.add($.__views.btn_wallpaper_label_notice);
        $.__views.btn_shop = Ti.UI.createView(function() {
            var o = {};
            _.extend(o, {
                top: 0,
                right: 50,
                opacity: "1",
                width: 100,
                height: 100
            });
            Alloy.isTablet && _.extend(o, {
                width: 150,
                height: 150
            });
            _.extend(o, {
                id: "btn_shop"
            });
            return o;
        }());
        $.__views.__alloyId24.add($.__views.btn_shop);
        openShopping ? $.__views.btn_shop.addEventListener("click", openShopping) : __defers["$.__views.btn_shop!click!openShopping"] = true;
        $.__views.__alloyId26 = Ti.UI.createImageView(function() {
            var o = {};
            _.extend(o, {
                width: 77,
                height: 77,
                top: 0
            });
            Alloy.isTablet && _.extend(o, {
                width: 100,
                height: 100,
                top: 0
            });
            _.extend(o, {
                image: "/images/buttons/shop.png",
                id: "__alloyId26"
            });
            return o;
        }());
        $.__views.btn_shop.add($.__views.__alloyId26);
        $.__views.btn_shop_label = Ti.UI.createLabel(function() {
            var o = {};
            _.extend(o, {
                height: 20,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 12
                },
                color: "white"
            });
            Alloy.isTablet && _.extend(o, {
                height: 40,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 16
                },
                color: "white"
            });
            _.extend(o, {
                text: "SHOP",
                id: "btn_shop_label"
            });
            return o;
        }());
        $.__views.btn_shop.add($.__views.btn_shop_label);
        $.__views.btn_flash_sales = Ti.UI.createView(function() {
            var o = {};
            _.extend(o, {
                top: 120,
                left: 50,
                opacity: "1",
                width: 100,
                height: 100
            });
            Alloy.isTablet && _.extend(o, {
                top: 340
            });
            Alloy.isTablet && _.extend(o, {
                width: 150,
                height: 150
            });
            _.extend(o, {
                id: "btn_flash_sales"
            });
            return o;
        }());
        $.__views.__alloyId24.add($.__views.btn_flash_sales);
        openFlashSales ? $.__views.btn_flash_sales.addEventListener("click", openFlashSales) : __defers["$.__views.btn_flash_sales!click!openFlashSales"] = true;
        $.__views.__alloyId27 = Ti.UI.createImageView(function() {
            var o = {};
            _.extend(o, {
                width: 77,
                height: 77,
                top: 0
            });
            Alloy.isTablet && _.extend(o, {
                width: 100,
                height: 100,
                top: 0
            });
            _.extend(o, {
                image: "/images/buttons/flash_sales.png",
                id: "__alloyId27"
            });
            return o;
        }());
        $.__views.btn_flash_sales.add($.__views.__alloyId27);
        $.__views.btn_flash_sales_img = Ti.UI.createImageView(function() {
            var o = {};
            _.extend(o, {
                width: 77,
                height: 77,
                top: 0
            });
            Alloy.isTablet && _.extend(o, {
                width: 100,
                height: 100,
                top: 0
            });
            _.extend(o, {
                opacity: 0,
                id: "btn_flash_sales_img",
                image: "/images/buttons/flash_sales_green.png"
            });
            return o;
        }());
        $.__views.btn_flash_sales.add($.__views.btn_flash_sales_img);
        $.__views.btn_flash_sales_label = Ti.UI.createLabel(function() {
            var o = {};
            _.extend(o, {
                height: 20,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 12
                },
                color: "white"
            });
            Alloy.isTablet && _.extend(o, {
                height: 40,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 16
                },
                color: "white"
            });
            _.extend(o, {
                text: "FLASH SALES",
                id: "btn_flash_sales_label"
            });
            return o;
        }());
        $.__views.btn_flash_sales.add($.__views.btn_flash_sales_label);
        $.__views.btn_deals = Ti.UI.createView(function() {
            var o = {};
            _.extend(o, {
                top: 120,
                right: 50,
                opacity: "1",
                width: 100,
                height: 100
            });
            Alloy.isTablet && _.extend(o, {
                top: 340
            });
            Alloy.isTablet && _.extend(o, {
                width: 150,
                height: 150
            });
            _.extend(o, {
                id: "btn_deals"
            });
            return o;
        }());
        $.__views.__alloyId24.add($.__views.btn_deals);
        openDeals ? $.__views.btn_deals.addEventListener("click", openDeals) : __defers["$.__views.btn_deals!click!openDeals"] = true;
        $.__views.__alloyId28 = Ti.UI.createImageView(function() {
            var o = {};
            _.extend(o, {
                width: 77,
                height: 77,
                top: 0
            });
            Alloy.isTablet && _.extend(o, {
                width: 100,
                height: 100,
                top: 0
            });
            _.extend(o, {
                image: "/images/buttons/deals.png",
                id: "__alloyId28"
            });
            return o;
        }());
        $.__views.btn_deals.add($.__views.__alloyId28);
        $.__views.btn_deals_label = Ti.UI.createLabel(function() {
            var o = {};
            _.extend(o, {
                height: 20,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 12
                },
                color: "white"
            });
            Alloy.isTablet && _.extend(o, {
                height: 40,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 16
                },
                color: "white"
            });
            _.extend(o, {
                text: "DEALS",
                id: "btn_deals_label"
            });
            return o;
        }());
        $.__views.btn_deals.add($.__views.btn_deals_label);
    }
    if (!Alloy.isTablet) {
        $.__views.page2 = Ti.UI.createView({
            id: "page2"
        });
        __alloyId23.push($.__views.page2);
        $.__views.__alloyId29 = Ti.UI.createView(function() {
            var o = {};
            _.extend(o, {
                height: Titanium.UI.SIZE
            });
            Alloy.isTablet && _.extend(o, {
                width: Titanium.UI.SIZE
            });
            _.extend(o, {
                id: "__alloyId29"
            });
            return o;
        }());
        $.__views.page2.add($.__views.__alloyId29);
        $.__views.btn_blog = Ti.UI.createView(function() {
            var o = {};
            _.extend(o, {
                top: 0,
                left: 50,
                opacity: "1",
                width: 100,
                height: 100
            });
            Alloy.isTablet && _.extend(o, {
                width: 150,
                height: 150
            });
            _.extend(o, {
                title: "Blog",
                id: "btn_blog"
            });
            return o;
        }());
        $.__views.__alloyId29.add($.__views.btn_blog);
        openBlog ? $.__views.btn_blog.addEventListener("click", openBlog) : __defers["$.__views.btn_blog!click!openBlog"] = true;
        $.__views.__alloyId30 = Ti.UI.createImageView(function() {
            var o = {};
            _.extend(o, {
                width: 77,
                height: 77,
                top: 0
            });
            Alloy.isTablet && _.extend(o, {
                width: 100,
                height: 100,
                top: 0
            });
            _.extend(o, {
                image: "/images/buttons/blog.png",
                id: "__alloyId30"
            });
            return o;
        }());
        $.__views.btn_blog.add($.__views.__alloyId30);
        $.__views.btn_blog_label = Ti.UI.createLabel(function() {
            var o = {};
            _.extend(o, {
                height: 20,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 12
                },
                color: "white"
            });
            Alloy.isTablet && _.extend(o, {
                height: 40,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 16
                },
                color: "white"
            });
            _.extend(o, {
                text: "BLOG",
                id: "btn_blog_label"
            });
            return o;
        }());
        $.__views.btn_blog.add($.__views.btn_blog_label);
        $.__views.btn_support = Ti.UI.createView(function() {
            var o = {};
            _.extend(o, {
                top: 0,
                right: 50,
                opacity: "1",
                width: 100,
                height: 100
            });
            Alloy.isTablet && _.extend(o, {
                width: 150,
                height: 150
            });
            _.extend(o, {
                title: "Contact",
                id: "btn_support"
            });
            return o;
        }());
        $.__views.__alloyId29.add($.__views.btn_support);
        openContact ? $.__views.btn_support.addEventListener("click", openContact) : __defers["$.__views.btn_support!click!openContact"] = true;
        $.__views.__alloyId31 = Ti.UI.createImageView(function() {
            var o = {};
            _.extend(o, {
                width: 77,
                height: 77,
                top: 0
            });
            Alloy.isTablet && _.extend(o, {
                width: 100,
                height: 100,
                top: 0
            });
            _.extend(o, {
                image: "/images/buttons/support.png",
                id: "__alloyId31"
            });
            return o;
        }());
        $.__views.btn_support.add($.__views.__alloyId31);
        $.__views.btn_contact_label = Ti.UI.createLabel(function() {
            var o = {};
            _.extend(o, {
                height: 20,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 12
                },
                color: "white"
            });
            Alloy.isTablet && _.extend(o, {
                height: 40,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 16
                },
                color: "white"
            });
            _.extend(o, {
                text: "CONTACT",
                id: "btn_contact_label"
            });
            return o;
        }());
        $.__views.btn_support.add($.__views.btn_contact_label);
        $.__views.btn_new_products = Ti.UI.createView(function() {
            var o = {};
            _.extend(o, {
                top: 120,
                left: 50,
                opacity: "1",
                width: 100,
                height: 100
            });
            Alloy.isTablet && _.extend(o, {
                top: 340
            });
            Alloy.isTablet && _.extend(o, {
                width: 150,
                height: 150
            });
            _.extend(o, {
                title: "New Products",
                id: "btn_new_products"
            });
            return o;
        }());
        $.__views.__alloyId29.add($.__views.btn_new_products);
        openNewProducts ? $.__views.btn_new_products.addEventListener("click", openNewProducts) : __defers["$.__views.btn_new_products!click!openNewProducts"] = true;
        $.__views.__alloyId32 = Ti.UI.createImageView(function() {
            var o = {};
            _.extend(o, {
                width: 77,
                height: 77,
                top: 0
            });
            Alloy.isTablet && _.extend(o, {
                width: 100,
                height: 100,
                top: 0
            });
            _.extend(o, {
                image: "/images/buttons/new_products.png",
                id: "__alloyId32"
            });
            return o;
        }());
        $.__views.btn_new_products.add($.__views.__alloyId32);
        $.__views.btn_new_products_label = Ti.UI.createLabel(function() {
            var o = {};
            _.extend(o, {
                height: 20,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 12
                },
                color: "white"
            });
            Alloy.isTablet && _.extend(o, {
                height: 40,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 16
                },
                color: "white"
            });
            _.extend(o, {
                text: "NEW PRODUCTS",
                id: "btn_new_products_label"
            });
            return o;
        }());
        $.__views.btn_new_products.add($.__views.btn_new_products_label);
        $.__views.btn_faq = Ti.UI.createView(function() {
            var o = {};
            _.extend(o, {
                top: 120,
                right: 50,
                opacity: "1",
                width: 100,
                height: 100
            });
            Alloy.isTablet && _.extend(o, {
                top: 340
            });
            Alloy.isTablet && _.extend(o, {
                width: 150,
                height: 150
            });
            _.extend(o, {
                title: "Settings",
                id: "btn_faq"
            });
            return o;
        }());
        $.__views.__alloyId29.add($.__views.btn_faq);
        openFAQ ? $.__views.btn_faq.addEventListener("click", openFAQ) : __defers["$.__views.btn_faq!click!openFAQ"] = true;
        $.__views.__alloyId33 = Ti.UI.createImageView(function() {
            var o = {};
            _.extend(o, {
                width: 77,
                height: 77,
                top: 0
            });
            Alloy.isTablet && _.extend(o, {
                width: 100,
                height: 100,
                top: 0
            });
            _.extend(o, {
                image: "/images/buttons/faq.png",
                id: "__alloyId33"
            });
            return o;
        }());
        $.__views.btn_faq.add($.__views.__alloyId33);
        $.__views.btn_faq_label = Ti.UI.createLabel(function() {
            var o = {};
            _.extend(o, {
                height: 20,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 12
                },
                color: "white"
            });
            Alloy.isTablet && _.extend(o, {
                height: 40,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 16
                },
                color: "white"
            });
            _.extend(o, {
                text: "FAQ",
                id: "btn_faq_label"
            });
            return o;
        }());
        $.__views.btn_faq.add($.__views.btn_faq_label);
    }
    if (Alloy.isTablet) {
        $.__views.page = Ti.UI.createView({
            id: "page"
        });
        __alloyId23.push($.__views.page);
        $.__views.__alloyId34 = Ti.UI.createView(function() {
            var o = {};
            _.extend(o, {
                height: Titanium.UI.SIZE
            });
            Alloy.isTablet && _.extend(o, {
                width: Titanium.UI.SIZE
            });
            _.extend(o, {
                id: "__alloyId34"
            });
            return o;
        }());
        $.__views.page.add($.__views.__alloyId34);
        $.__views.btn_wallpaper = Ti.UI.createView(function() {
            var o = {};
            _.extend(o, {
                top: 0,
                width: 100,
                height: 100
            });
            Alloy.isTablet && _.extend(o, {
                left: 25,
                opacity: "1"
            });
            Alloy.isTablet && _.extend(o, {
                width: 150,
                height: 150
            });
            _.extend(o, {
                title: "Wallpaper",
                id: "btn_wallpaper"
            });
            return o;
        }());
        $.__views.__alloyId34.add($.__views.btn_wallpaper);
        openWallpaper ? $.__views.btn_wallpaper.addEventListener("click", openWallpaper) : __defers["$.__views.btn_wallpaper!click!openWallpaper"] = true;
        $.__views.__alloyId35 = Ti.UI.createImageView(function() {
            var o = {};
            _.extend(o, {
                width: 77,
                height: 77,
                top: 0
            });
            Alloy.isTablet && _.extend(o, {
                width: 100,
                height: 100,
                top: 0
            });
            _.extend(o, {
                image: "/images/buttons/wallpaper.png",
                id: "__alloyId35"
            });
            return o;
        }());
        $.__views.btn_wallpaper.add($.__views.__alloyId35);
        $.__views.btn_wallpaper_label = Ti.UI.createLabel(function() {
            var o = {};
            _.extend(o, {
                height: 20,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 12
                },
                color: "white"
            });
            Alloy.isTablet && _.extend(o, {
                height: 40,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 16
                },
                color: "white"
            });
            _.extend(o, {
                text: "WALLPAPER",
                id: "btn_wallpaper_label"
            });
            return o;
        }());
        $.__views.btn_wallpaper.add($.__views.btn_wallpaper_label);
        $.__views.btn_wallpaper_label_notice = Ti.UI.createLabel(function() {
            var o = {};
            _.extend(o, {
                height: 20,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 12
                },
                color: "white"
            });
            Alloy.isTablet && _.extend(o, {
                height: 40,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 16
                },
                color: "white"
            });
            _.extend(o, {
                visible: false,
                text: "Paused...",
                id: "btn_wallpaper_label_notice"
            });
            return o;
        }());
        $.__views.btn_wallpaper.add($.__views.btn_wallpaper_label_notice);
        $.__views.btn_shop = Ti.UI.createView(function() {
            var o = {};
            _.extend(o, {
                top: 0,
                width: 100,
                height: 100
            });
            Alloy.isTablet && _.extend(o, {
                left: 225,
                opacity: "1"
            });
            Alloy.isTablet && _.extend(o, {
                width: 150,
                height: 150
            });
            _.extend(o, {
                title: "Shopping",
                id: "btn_shop"
            });
            return o;
        }());
        $.__views.__alloyId34.add($.__views.btn_shop);
        openShopping ? $.__views.btn_shop.addEventListener("click", openShopping) : __defers["$.__views.btn_shop!click!openShopping"] = true;
        $.__views.__alloyId36 = Ti.UI.createImageView(function() {
            var o = {};
            _.extend(o, {
                width: 77,
                height: 77,
                top: 0
            });
            Alloy.isTablet && _.extend(o, {
                width: 100,
                height: 100,
                top: 0
            });
            _.extend(o, {
                image: "/images/buttons/shop.png",
                id: "__alloyId36"
            });
            return o;
        }());
        $.__views.btn_shop.add($.__views.__alloyId36);
        $.__views.btn_shop_label = Ti.UI.createLabel(function() {
            var o = {};
            _.extend(o, {
                height: 20,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 12
                },
                color: "white"
            });
            Alloy.isTablet && _.extend(o, {
                height: 40,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 16
                },
                color: "white"
            });
            _.extend(o, {
                text: "SHOP",
                id: "btn_shop_label"
            });
            return o;
        }());
        $.__views.btn_shop.add($.__views.btn_shop_label);
        $.__views.btn_flash_sales = Ti.UI.createView(function() {
            var o = {};
            _.extend(o, {
                width: 100,
                height: 100
            });
            Alloy.isTablet && _.extend(o, {
                top: 170
            });
            Alloy.isTablet && _.extend(o, {
                left: 25,
                opacity: "1"
            });
            Alloy.isTablet && _.extend(o, {
                width: 150,
                height: 150
            });
            _.extend(o, {
                title: "Flash Sales",
                id: "btn_flash_sales"
            });
            return o;
        }());
        $.__views.__alloyId34.add($.__views.btn_flash_sales);
        openFlashSales ? $.__views.btn_flash_sales.addEventListener("click", openFlashSales) : __defers["$.__views.btn_flash_sales!click!openFlashSales"] = true;
        $.__views.__alloyId37 = Ti.UI.createImageView(function() {
            var o = {};
            _.extend(o, {
                width: 77,
                height: 77,
                top: 0
            });
            Alloy.isTablet && _.extend(o, {
                width: 100,
                height: 100,
                top: 0
            });
            _.extend(o, {
                image: "/images/buttons/flash_sales.png",
                id: "__alloyId37"
            });
            return o;
        }());
        $.__views.btn_flash_sales.add($.__views.__alloyId37);
        $.__views.btn_flash_sales_img = Ti.UI.createImageView(function() {
            var o = {};
            _.extend(o, {
                width: 77,
                height: 77,
                top: 0
            });
            Alloy.isTablet && _.extend(o, {
                width: 100,
                height: 100,
                top: 0
            });
            _.extend(o, {
                opacity: 0,
                id: "btn_flash_sales_img",
                image: "/images/buttons/flash_sales_green.png"
            });
            return o;
        }());
        $.__views.btn_flash_sales.add($.__views.btn_flash_sales_img);
        $.__views.btn_flash_sales_label = Ti.UI.createLabel(function() {
            var o = {};
            _.extend(o, {
                height: 20,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 12
                },
                color: "white"
            });
            Alloy.isTablet && _.extend(o, {
                height: 40,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 16
                },
                color: "white"
            });
            _.extend(o, {
                text: "FLASH SALES",
                id: "btn_flash_sales_label"
            });
            return o;
        }());
        $.__views.btn_flash_sales.add($.__views.btn_flash_sales_label);
        $.__views.btn_deals = Ti.UI.createView(function() {
            var o = {};
            _.extend(o, {
                width: 100,
                height: 100
            });
            Alloy.isTablet && _.extend(o, {
                top: 170
            });
            Alloy.isTablet && _.extend(o, {
                left: 225,
                opacity: "1"
            });
            Alloy.isTablet && _.extend(o, {
                width: 150,
                height: 150
            });
            _.extend(o, {
                title: "Deals",
                id: "btn_deals"
            });
            return o;
        }());
        $.__views.__alloyId34.add($.__views.btn_deals);
        openDeals ? $.__views.btn_deals.addEventListener("click", openDeals) : __defers["$.__views.btn_deals!click!openDeals"] = true;
        $.__views.__alloyId38 = Ti.UI.createImageView(function() {
            var o = {};
            _.extend(o, {
                width: 77,
                height: 77,
                top: 0
            });
            Alloy.isTablet && _.extend(o, {
                width: 100,
                height: 100,
                top: 0
            });
            _.extend(o, {
                image: "/images/buttons/deals.png",
                id: "__alloyId38"
            });
            return o;
        }());
        $.__views.btn_deals.add($.__views.__alloyId38);
        $.__views.btn_deals_label = Ti.UI.createLabel(function() {
            var o = {};
            _.extend(o, {
                height: 20,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 12
                },
                color: "white"
            });
            Alloy.isTablet && _.extend(o, {
                height: 40,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 16
                },
                color: "white"
            });
            _.extend(o, {
                text: "DEALS",
                id: "btn_deals_label"
            });
            return o;
        }());
        $.__views.btn_deals.add($.__views.btn_deals_label);
        $.__views.btn_blog = Ti.UI.createView(function() {
            var o = {};
            _.extend(o, {
                top: 0,
                width: 100,
                height: 100
            });
            Alloy.isTablet && _.extend(o, {
                left: 425,
                opacity: "1"
            });
            Alloy.isTablet && _.extend(o, {
                width: 150,
                height: 150
            });
            _.extend(o, {
                title: "Blog",
                id: "btn_blog"
            });
            return o;
        }());
        $.__views.__alloyId34.add($.__views.btn_blog);
        openBlog ? $.__views.btn_blog.addEventListener("click", openBlog) : __defers["$.__views.btn_blog!click!openBlog"] = true;
        $.__views.__alloyId39 = Ti.UI.createImageView(function() {
            var o = {};
            _.extend(o, {
                width: 77,
                height: 77,
                top: 0
            });
            Alloy.isTablet && _.extend(o, {
                width: 100,
                height: 100,
                top: 0
            });
            _.extend(o, {
                image: "/images/buttons/blog.png",
                id: "__alloyId39"
            });
            return o;
        }());
        $.__views.btn_blog.add($.__views.__alloyId39);
        $.__views.btn_blog_label = Ti.UI.createLabel(function() {
            var o = {};
            _.extend(o, {
                height: 20,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 12
                },
                color: "white"
            });
            Alloy.isTablet && _.extend(o, {
                height: 40,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 16
                },
                color: "white"
            });
            _.extend(o, {
                text: "BLOG",
                id: "btn_blog_label"
            });
            return o;
        }());
        $.__views.btn_blog.add($.__views.btn_blog_label);
        $.__views.btn_support = Ti.UI.createView(function() {
            var o = {};
            _.extend(o, {
                top: 120,
                width: 100,
                height: 100
            });
            Alloy.isTablet && _.extend(o, {
                top: 340
            });
            Alloy.isTablet && _.extend(o, {
                left: 25,
                opacity: "1"
            });
            Alloy.isTablet && _.extend(o, {
                width: 150,
                height: 150
            });
            _.extend(o, {
                title: "Contact",
                id: "btn_support"
            });
            return o;
        }());
        $.__views.__alloyId34.add($.__views.btn_support);
        openContact ? $.__views.btn_support.addEventListener("click", openContact) : __defers["$.__views.btn_support!click!openContact"] = true;
        $.__views.__alloyId40 = Ti.UI.createImageView(function() {
            var o = {};
            _.extend(o, {
                width: 77,
                height: 77,
                top: 0
            });
            Alloy.isTablet && _.extend(o, {
                width: 100,
                height: 100,
                top: 0
            });
            _.extend(o, {
                image: "/images/buttons/support.png",
                id: "__alloyId40"
            });
            return o;
        }());
        $.__views.btn_support.add($.__views.__alloyId40);
        $.__views.btn_contact_label = Ti.UI.createLabel(function() {
            var o = {};
            _.extend(o, {
                height: 20,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 12
                },
                color: "white"
            });
            Alloy.isTablet && _.extend(o, {
                height: 40,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 16
                },
                color: "white"
            });
            _.extend(o, {
                text: "CONTACT",
                id: "btn_contact_label"
            });
            return o;
        }());
        $.__views.btn_support.add($.__views.btn_contact_label);
        $.__views.btn_new_products = Ti.UI.createView(function() {
            var o = {};
            _.extend(o, {
                width: 100,
                height: 100
            });
            Alloy.isTablet && _.extend(o, {
                top: 170
            });
            Alloy.isTablet && _.extend(o, {
                left: 425,
                opacity: "1"
            });
            Alloy.isTablet && _.extend(o, {
                width: 150,
                height: 150
            });
            _.extend(o, {
                title: "New Products",
                id: "btn_new_products"
            });
            return o;
        }());
        $.__views.__alloyId34.add($.__views.btn_new_products);
        openNewProducts ? $.__views.btn_new_products.addEventListener("click", openNewProducts) : __defers["$.__views.btn_new_products!click!openNewProducts"] = true;
        $.__views.__alloyId41 = Ti.UI.createImageView(function() {
            var o = {};
            _.extend(o, {
                width: 77,
                height: 77,
                top: 0
            });
            Alloy.isTablet && _.extend(o, {
                width: 100,
                height: 100,
                top: 0
            });
            _.extend(o, {
                image: "/images/buttons/new_products.png",
                id: "__alloyId41"
            });
            return o;
        }());
        $.__views.btn_new_products.add($.__views.__alloyId41);
        $.__views.btn_new_products_label = Ti.UI.createLabel(function() {
            var o = {};
            _.extend(o, {
                height: 20,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 12
                },
                color: "white"
            });
            Alloy.isTablet && _.extend(o, {
                height: 40,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 16
                },
                color: "white"
            });
            _.extend(o, {
                text: "NEW PRODUCTS",
                id: "btn_new_products_label"
            });
            return o;
        }());
        $.__views.btn_new_products.add($.__views.btn_new_products_label);
        $.__views.btn_faq = Ti.UI.createView(function() {
            var o = {};
            _.extend(o, {
                top: 120,
                width: 100,
                height: 100
            });
            Alloy.isTablet && _.extend(o, {
                top: 340
            });
            Alloy.isTablet && _.extend(o, {
                left: 225,
                opacity: "1"
            });
            Alloy.isTablet && _.extend(o, {
                width: 150,
                height: 150
            });
            _.extend(o, {
                title: "FAQ",
                id: "btn_faq"
            });
            return o;
        }());
        $.__views.__alloyId34.add($.__views.btn_faq);
        openFAQ ? $.__views.btn_faq.addEventListener("click", openFAQ) : __defers["$.__views.btn_faq!click!openFAQ"] = true;
        $.__views.__alloyId42 = Ti.UI.createImageView(function() {
            var o = {};
            _.extend(o, {
                width: 77,
                height: 77,
                top: 0
            });
            Alloy.isTablet && _.extend(o, {
                width: 100,
                height: 100,
                top: 0
            });
            _.extend(o, {
                image: "/images/buttons/faq.png",
                id: "__alloyId42"
            });
            return o;
        }());
        $.__views.btn_faq.add($.__views.__alloyId42);
        $.__views.btn_faq_label = Ti.UI.createLabel(function() {
            var o = {};
            _.extend(o, {
                height: 20,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 12
                },
                color: "white"
            });
            Alloy.isTablet && _.extend(o, {
                height: 40,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 16
                },
                color: "white"
            });
            _.extend(o, {
                text: "FAQ",
                id: "btn_faq_label"
            });
            return o;
        }());
        $.__views.btn_faq.add($.__views.btn_faq_label);
        $.__views.btn_settings = Ti.UI.createView(function() {
            var o = {};
            _.extend(o, {
                top: 120,
                width: 100,
                height: 100
            });
            Alloy.isTablet && _.extend(o, {
                top: 340
            });
            Alloy.isTablet && _.extend(o, {
                left: 425,
                opacity: "1"
            });
            Alloy.isTablet && _.extend(o, {
                width: 150,
                height: 150
            });
            _.extend(o, {
                title: "Settings",
                id: "btn_settings"
            });
            return o;
        }());
        $.__views.__alloyId34.add($.__views.btn_settings);
        openSettings ? $.__views.btn_settings.addEventListener("click", openSettings) : __defers["$.__views.btn_settings!click!openSettings"] = true;
        $.__views.__alloyId43 = Ti.UI.createImageView(function() {
            var o = {};
            _.extend(o, {
                width: 77,
                height: 77,
                top: 0
            });
            Alloy.isTablet && _.extend(o, {
                width: 100,
                height: 100,
                top: 0
            });
            _.extend(o, {
                image: "/images/buttons/settings.png",
                id: "__alloyId43"
            });
            return o;
        }());
        $.__views.btn_settings.add($.__views.__alloyId43);
        $.__views.btn_settings_label = Ti.UI.createLabel(function() {
            var o = {};
            _.extend(o, {
                height: 20,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 12
                },
                color: "white"
            });
            Alloy.isTablet && _.extend(o, {
                height: 40,
                width: Titanium.UI.FILL,
                textAlign: "center",
                bottom: 0,
                font: {
                    fontSize: 16
                },
                color: "white"
            });
            _.extend(o, {
                text: "SETTINGS",
                id: "btn_settings_label"
            });
            return o;
        }());
        $.__views.btn_settings.add($.__views.btn_settings_label);
    }
    $.__views.scrollableView = Ti.UI.createScrollableView(function() {
        var o = {};
        _.extend(o, {
            top: 171,
            bottom: 41,
            pagingControlColor: "transparent"
        });
        Alloy.isTablet && _.extend(o, {
            top: 300
        });
        _.extend(o, {
            views: __alloyId23,
            id: "scrollableView",
            showPagingControl: "true"
        });
        return o;
    }());
    $.__views.mainWin.add($.__views.scrollableView);
    $.__views.bottomToolbar = Alloy.createWidget("toolbar", "widget", {
        id: "bottomToolbar",
        __parentSymbol: $.__views.mainWin
    });
    $.__views.bottomToolbar.setParent($.__views.mainWin);
    exports.destroy = function() {};
    _.extend($, $.__views);
    var TF = require("/testflightjs");
    var moment = require("alloy/moment");
    var pages = require("/pageutils");
    var download_helper = require("/download_helper");
    var content_token = "";
    var content_timestamp = "";
    var content_fetch_attempts = 0;
    var wallpaper_button_state = 0;
    var flashSaleState = false;
    var btnFlashSaleAnimating = false;
    setupFlashSaletimer();
    $.mainWin.orientationModes = [ Ti.UI.PORTRAIT ];
    Titanium.UI.orientation = Ti.UI.PORTRAIT;
    if ("true" !== Titanium.App.Properties.getString("runonce", "false")) {
        var dialog = Ti.UI.createAlertDialog({
            buttonNames: [ "SHOP", "CLOSE" ],
            message: "Welcome to the Marley Lilly App!\n\nShop our store and build your own wallpaper.  We’re downloading some cool stuff for you to build your wallpaper so make sure you are on a WIFI connection your first time!\n\nPeace, Love & Monograms!",
            title: "Welcome"
        });
        dialog.addEventListener("click", function(e) {
            switch (e.index) {
              case 0:
                pages.open({
                    type: "web",
                    name: "shop",
                    title: Alloy.Globals.landingButtons["shop"].title,
                    url: Alloy.Globals.landingButtons["shop"].link
                });
                break;

              case 1:            }
            Titanium.App.Properties.setString("runonce", "true");
        });
        dialog.show();
    }
    Alloy.Globals.fetchMessages();
    checkForContent();
    Titanium.App.addEventListener("resumed", function() {
        Alloy.Globals.fetchMessages();
        setupFlashSaletimer();
    });
    Alloy.Globals.isIphone5 && ($.scrollableView.top = 151);
    $.statusBar.visible = Alloy.Globals.isiOS7Plus() ? true : false;
    $.scrollableView.setOpacity(0);
    $.bottomToolbar.hideBack();
    $.bottomToolbar.showSettings();
    $.btn_shop_label.setText(Alloy.Globals.landingButtons["shop"].title);
    $.btn_flash_sales_label.setText(Alloy.Globals.landingButtons["flashsales"].title);
    $.btn_blog_label.setText(Alloy.Globals.landingButtons["blog"].title);
    $.btn_new_products_label.setText(Alloy.Globals.landingButtons["newproducts"].title);
    $.bottomToolbar.bottomToolbar.setOpacity("0.0");
    $.mainWin.addEventListener("focus", function() {
        $.mainWin.backgroundImage = "images/" + Titanium.App.Properties.getString("backgroundImage", "bg_landing-circles.png");
        Titanium.App.fireEvent("app:updateMessagesBadge");
    });
    $.mainWin.addEventListener("load", function() {
        Titanium.UI.createAnimation({
            left: 50,
            opacity: "1.0",
            curve: Titanium.UI.ANIMATION_CURVE_EASE_IN_OUT,
            duration: 1e3
        });
        Titanium.UI.createAnimation({
            right: 50,
            opacity: "1.0",
            curve: Titanium.UI.ANIMATION_CURVE_EASE_IN_OUT,
            duration: 1e3
        });
        var fadeIn = Titanium.UI.createAnimation({
            opacity: "1.0",
            curve: Titanium.UI.ANIMATION_CURVE_EASE_IN_OUT,
            duration: 2e3
        });
        $.bottomToolbar.bottomToolbar.animate(fadeIn);
        $.scrollableView.animate(fadeIn);
        $.logo.animate({
            top: 20,
            opacity: "1.0",
            curve: Titanium.UI.ANIMATION_CURVE_EASE_IN_OUT,
            duration: 1500
        });
        TF.passCheckpoint("Passed the Landing page load checkpoint");
    });
    var processQueue;
    $.mainWin.open();
    Alloy.Globals.setFlashSaleTimer = function(pageName, callback) {
        var found = false;
        for (var i = 0; i < Alloy.Globals.timerUpdaters.length; i++) if (Alloy.Globals.timerUpdaters[i].page == pageName) {
            found = true;
            Alloy.Globals.timerUpdaters[i].callback = callback;
        }
        found || Alloy.Globals.timerUpdaters.push({
            page: pageName,
            callback: callback
        });
    };
    var flashOn = Titanium.UI.createAnimation({
        opacity: 1,
        duration: 1e3,
        curve: Titanium.UI.ANIMATION_CURVE_EASE_IN
    });
    flashOn.addEventListener("complete", function() {
        $.btn_flash_sales_img.animate(flashOff);
    });
    var flashOff = Titanium.UI.createAnimation({
        opacity: 0,
        duration: 1e3,
        curve: Titanium.UI.ANIMATION_CURVE_EASE_IN
    });
    flashOff.addEventListener("complete", function() {
        btnFlashSaleAnimating = false;
    });
    Alloy.isTablet || __defers["$.__views.btn_wallpaper!click!openWallpaper"] && $.__views.btn_wallpaper.addEventListener("click", openWallpaper);
    Alloy.isTablet || __defers["$.__views.btn_shop!click!openShopping"] && $.__views.btn_shop.addEventListener("click", openShopping);
    Alloy.isTablet || __defers["$.__views.btn_flash_sales!click!openFlashSales"] && $.__views.btn_flash_sales.addEventListener("click", openFlashSales);
    Alloy.isTablet || __defers["$.__views.btn_deals!click!openDeals"] && $.__views.btn_deals.addEventListener("click", openDeals);
    Alloy.isTablet || __defers["$.__views.btn_blog!click!openBlog"] && $.__views.btn_blog.addEventListener("click", openBlog);
    Alloy.isTablet || __defers["$.__views.btn_support!click!openContact"] && $.__views.btn_support.addEventListener("click", openContact);
    Alloy.isTablet || __defers["$.__views.btn_new_products!click!openNewProducts"] && $.__views.btn_new_products.addEventListener("click", openNewProducts);
    Alloy.isTablet || __defers["$.__views.btn_faq!click!openFAQ"] && $.__views.btn_faq.addEventListener("click", openFAQ);
    Alloy.isTablet && __defers["$.__views.btn_wallpaper!click!openWallpaper"] && $.__views.btn_wallpaper.addEventListener("click", openWallpaper);
    Alloy.isTablet && __defers["$.__views.btn_shop!click!openShopping"] && $.__views.btn_shop.addEventListener("click", openShopping);
    Alloy.isTablet && __defers["$.__views.btn_flash_sales!click!openFlashSales"] && $.__views.btn_flash_sales.addEventListener("click", openFlashSales);
    Alloy.isTablet && __defers["$.__views.btn_deals!click!openDeals"] && $.__views.btn_deals.addEventListener("click", openDeals);
    Alloy.isTablet && __defers["$.__views.btn_blog!click!openBlog"] && $.__views.btn_blog.addEventListener("click", openBlog);
    Alloy.isTablet && __defers["$.__views.btn_support!click!openContact"] && $.__views.btn_support.addEventListener("click", openContact);
    Alloy.isTablet && __defers["$.__views.btn_new_products!click!openNewProducts"] && $.__views.btn_new_products.addEventListener("click", openNewProducts);
    Alloy.isTablet && __defers["$.__views.btn_faq!click!openFAQ"] && $.__views.btn_faq.addEventListener("click", openFAQ);
    Alloy.isTablet && __defers["$.__views.btn_settings!click!openSettings"] && $.__views.btn_settings.addEventListener("click", openSettings);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;