function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    function openNavTray() {
        $.navTray.toggle($.content);
    }
    function loadMessages() {
        var db = Titanium.Database.open("messages");
        var result = db.execute("SELECT id, timestamp, message_id, category, subject, body, status, link, reminder, eventdate FROM messages WHERE status != " + MESSAGE_DELETED + " ORDER BY timestamp DESC");
        var table = Titanium.UI.createTableView({
            editable: true,
            footerTitle: ""
        });
        table.addEventListener("delete", function(e) {
            var db = Titanium.Database.open("messages");
            db.execute("UPDATE messages SET status = " + MESSAGE_DELETED + " WHERE id = " + e.rowData.rowID);
            db.close();
            Alloy.Globals.setAppBadge(Alloy.Globals.getMessageCount());
        });
        table.addEventListener("click", goLink);
        while (result.isValidRow()) {
            var id = result.fieldByName("id");
            var messageID = result.fieldByName("message_id");
            {
                result.fieldByName("timestamp");
            }
            {
                result.fieldByName("category");
            }
            var subject = result.fieldByName("subject");
            var body = result.fieldByName("body");
            var link = result.fieldByName("link");
            {
                result.fieldByName("reminder");
            }
            {
                result.fieldByName("eventdate");
            }
            var status = result.fieldByName("status");
            var rowContent = Titanium.UI.createView({
                height: Titanium.UI.FILL,
                width: Titanium.UI.FILL,
                backgroundColor: "#FFFFFF"
            });
            var rowBody = Titanium.UI.createView({
                left: 30,
                layout: "vertical"
            });
            var subjectLabel = Titanium.UI.createLabel({
                text: subject,
                font: {
                    fontSize: 18,
                    fontFamily: "Helvetica Neue"
                },
                left: 20,
                top: 10,
                color: "#999999",
                wordWrap: true
            });
            var bodyLabel = Titanium.UI.createLabel({
                text: body,
                font: {
                    fontSize: 10,
                    fontFamily: "Helvetica Neue"
                },
                textAlign: Titanium.UI.TEXT_ALIGNMENT_LEFT,
                left: 20,
                top: 0,
                right: 35,
                color: "#999999",
                wordWrap: true
            });
            var indicator = Titanium.UI.createImageView({
                image: 0 === status ? "images/icons/indicator_new.png" : "images/icons/indicator_old.png",
                left: 20,
                height: 10,
                width: 10
            });
            var rightArrow = Titanium.UI.createImageView({
                image: "images/icons/arrow_right.png",
                right: 15,
                height: 50,
                width: 20
            });
            var tableRow = Titanium.UI.createTableViewRow({
                rowID: id,
                messageID: messageID,
                customLink: link,
                height: 80,
                selectionStyle: Titanium.UI.iPhone.TableViewCellSelectionStyle.GRAY
            });
            row_indicators.push(indicator);
            rowBody.add(subjectLabel);
            rowBody.add(bodyLabel);
            rowContent.add(indicator);
            rowContent.add(rowBody);
            rowContent.add(rightArrow);
            tableRow.add(rowContent);
            table.appendRow(tableRow);
            result.next();
        }
        $.mainView.add(table);
        result.close();
        db.close();
    }
    function markRead(id, index) {
        var db = Titanium.Database.open("messages");
        db.execute("UPDATE messages SET status = " + MESSAGE_READ + " WHERE id = " + id);
        db.close();
        row_indicators[index].image = "images/icons/indicator_old.png";
        Alloy.Globals.setAppBadge(Alloy.Globals.getMessageCount());
    }
    function goLink(e) {
        var db = Titanium.Database.open("messages");
        var result = db.execute("SELECT id, timestamp, message_id, category, subject, body, status, link, reminder, eventdate FROM messages WHERE status != " + MESSAGE_DELETED + " AND id = " + e.row.rowID);
        var event = {
            id: e.row.rowID,
            message_id: result.fieldByName("message_id"),
            subject: result.fieldByName("subject"),
            body: result.fieldByName("body"),
            link: result.fieldByName("link"),
            reminder: result.fieldByName("reminder"),
            eventdate: result.fieldByName("eventdate")
        };
        db.close();
        event.reminder && setupReminder(event);
        markRead(e.row.rowID, e.index);
        switch (e.row.customLink) {
          case "flashsales":
            pages.open({
                type: "web",
                name: "flashsales",
                title: Alloy.Globals.landingButtons["flashsales"].title,
                url: Alloy.Globals.landingButtons["flashsales"].link
            });
            break;

          case "dailydeals":
            pages.open({
                type: "controller",
                name: "dailydeal"
            });
            break;

          case "coupons":
            pages.open({
                type: "controller",
                name: "coupons"
            });
            break;

          case "newproducts":
            pages.open({
                type: "web",
                name: "newproducts",
                title: Alloy.Globals.landingButtons["newproducts"].title,
                url: Alloy.Globals.landingButtons["newproducts"].link
            });
            break;

          case "wallpaper":
            pages.open({
                type: "controller",
                name: "wallpaper"
            });
            break;

          case "giveaways":
            var giveawayMenu = utility.getMenuItem("giveaway");
            pages.log("Deals::Alloy.Globals.menuItems[giveaway]: " + JSON.stringify(giveawayMenu));
            pages.open({
                type: "web",
                name: "giveaway",
                title: giveawayMenu.title,
                url: giveawayMenu.link
            });
            break;

          case "settings":
            pages.toggle({
                type: "controller",
                name: "settings"
            });
            break;

          case "messages":
            pages.toggle({
                type: "controller",
                name: "messages"
            });
            break;

          case "shop":
            pages.open({
                type: "web",
                name: "shop",
                title: Alloy.Globals.landingButtons["shop"].title,
                url: Alloy.Globals.landingButtons["shop"].link
            });
            break;

          case "contact":
            pages.open({
                type: "controller",
                name: "contact"
            });
            break;

          case "faq":
            pages.open({
                type: "web",
                name: "faq",
                title: Alloy.Globals.landingButtons["faq"].title,
                url: Alloy.Globals.landingButtons["faq"].link
            });
        }
    }
    function setupReminder(event) {
        var dialog = Ti.UI.createAlertDialog({
            cancel: 1,
            buttonNames: [ "Yes", "No" ],
            message: "Would you like to setup an event reminder for this item?",
            title: "Create a reminder"
        });
        dialog.addEventListener("click", function(e) {
            switch (e.index) {
              case 0:
                Ti.Calendar.eventsAuthorization == Ti.Calendar.AUTHORIZATION_AUTHORIZED ? writeReminderEvent(event) : Ti.Calendar.requestEventsAuthorization(function(e) {
                    e.success ? writeReminderEvent(event) : alert("Access to calendar is not allowed");
                });
                break;

              case 1:            }
        });
        dialog.show();
    }
    function writeReminderEvent(event) {
        var defCalendar = Titanium.Calendar.defaultCalendar;
        dateStr = event.eventdate.split("|");
        var start = new Date(moment(dateStr[0]));
        var end = new Date(moment(dateStr[1]));
        var reminderOffset = Titanium.App.Properties.getString("reminderTime", "15 minutes").split(/[, ]+/);
        var event1 = defCalendar.createEvent({
            title: event.subject,
            notes: event.body,
            location: "Marley Lilly",
            begin: start,
            end: end,
            availability: Ti.Calendar.AVAILABILITY_FREE,
            allDay: false
        });
        var alertDate = moment(dateStr[0]).subtract(Number(reminderOffset[0]), reminderOffset[1]);
        var alert1 = event1.createAlert({
            absoluteDate: new Date(alertDate)
        });
        var allAlerts = new Array(alert1);
        event1.alerts = allAlerts;
        event1.save();
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "messages";
    if (arguments[0]) {
        {
            __processArg(arguments[0], "__parentSymbol");
        }
        {
            __processArg(arguments[0], "$model");
        }
        {
            __processArg(arguments[0], "__itemTemplate");
        }
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.container = Ti.UI.createWindow({
        backgroundColor: "#fa72c0",
        navBarHidden: "true",
        id: "container"
    });
    $.__views.container && $.addTopLevelView($.__views.container);
    $.__views.statusBar = Ti.UI.createView({
        top: 0,
        height: 20,
        backgroundColor: "#88fcf9f9",
        id: "statusBar"
    });
    $.__views.container.add($.__views.statusBar);
    $.__views.wrapper = Ti.UI.createView({
        id: "wrapper"
    });
    $.__views.container.add($.__views.wrapper);
    $.__views.navTray = Alloy.createWidget("navtray", "widget", {
        id: "navTray",
        __parentSymbol: $.__views.wrapper
    });
    $.__views.navTray.setParent($.__views.wrapper);
    $.__views.content = Ti.UI.createView({
        height: Titanium.UI.FILL,
        backgroundColor: "white",
        id: "content"
    });
    $.__views.wrapper.add($.__views.content);
    $.__views.topNavbar = Ti.UI.createView({
        backgroundColor: "white",
        top: 0,
        height: 45,
        id: "topNavbar"
    });
    $.__views.content.add($.__views.topNavbar);
    $.__views.pageTitle = Ti.UI.createLabel({
        color: "#ff99cc",
        font: {
            fontSize: 18,
            fontFamily: "HelveticaNeue-Medium"
        },
        text: "Messages",
        id: "pageTitle"
    });
    $.__views.topNavbar.add($.__views.pageTitle);
    $.__views.btn_menu = Ti.UI.createImageView({
        right: 15,
        top: 5,
        height: 30,
        width: 30,
        backgroundColor: "transparent",
        title: "Menu",
        id: "btn_menu",
        image: "/images/icons/menu.png"
    });
    $.__views.topNavbar.add($.__views.btn_menu);
    openNavTray ? $.__views.btn_menu.addEventListener("click", openNavTray) : __defers["$.__views.btn_menu!click!openNavTray"] = true;
    $.__views.header = Ti.UI.createView({
        backgroundColor: "#eeeeee",
        height: 25,
        width: Titanium.UI.FILL,
        top: 46,
        id: "header"
    });
    $.__views.content.add($.__views.header);
    $.__views.header_label = Ti.UI.createLabel({
        left: 15,
        color: "#666666",
        font: {
            fontSize: 12
        },
        text: "CURRENT MESSAGES",
        id: "header_label"
    });
    $.__views.header.add($.__views.header_label);
    $.__views.mainView = Ti.UI.createView({
        top: 71,
        bottom: 52,
        id: "mainView"
    });
    $.__views.content.add($.__views.mainView);
    $.__views.topNavbar_separator = Ti.UI.createView({
        id: "topNavbar_separator"
    });
    $.__views.mainView.add($.__views.topNavbar_separator);
    $.__views.bottomToolbar = Alloy.createWidget("toolbar", "widget", {
        id: "bottomToolbar",
        __parentSymbol: $.__views.content
    });
    $.__views.bottomToolbar.setParent($.__views.content);
    exports.destroy = function() {};
    _.extend($, $.__views);
    $.container.orientationModes = [ Ti.UI.PORTRAIT ];
    Titanium.UI.orientation = Ti.UI.PORTRAIT;
    var pages = require("/pageutils");
    var utility = require("/utility");
    Alloy.Globals.activeWindows["messages"] = $.container;
    Alloy.Globals.currentWindow = $.container;
    var MESSAGE_READ = 1;
    var MESSAGE_DELETED = 2;
    var row_indicators = [];
    $.statusBar.visible = Alloy.Globals.isiOS7Plus() ? true : false;
    $.wrapper.top = Alloy.Globals.isiOS7Plus() ? 20 : 0;
    Alloy.Globals.setFlashSaleTimer("messages", $.navTray.updateTimer);
    $.container.addEventListener("load", function() {
        $.navTray.navTray.visible = true;
    });
    $.bottomToolbar.setCurrentView("messages");
    Alloy.Globals.fetchMessages(function() {
        loadMessages();
    });
    __defers["$.__views.btn_menu!click!openNavTray"] && $.__views.btn_menu.addEventListener("click", openNavTray);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;