function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    function Initialize() {
        monogram = {
            initials: "",
            background: "",
            stamp: {
                file: Titanium.Filesystem.applicationDataDirectory + "stamps/circle/phone_circle_navy.png",
                color: "navy"
            },
            font: {
                id: 0,
                name: "",
                color: "#FFFFFF"
            },
            background_category: "",
            background_colors: [],
            stamp_category: "circle",
            views: [],
            trays: [],
            preview: false
        };
        previewMode = false;
        fontStatus = {
            firedOnce: false,
            selected: false,
            colored: false
        };
        stampStatus = {
            firedOnce: false,
            selected: false,
            colored: false
        };
        backgroundStatus = {
            firedOnce: false
        };
        open_tray = "";
        $.initialsLabel.text = "First, Last, Middle";
        $.previewBackground.backgroundImage = "blank.png";
        $.previewStamp.image = Titanium.Filesystem.applicationDataDirectory + "stamps/circle/phone_circle_navy.png";
        $.previewInitialsFirst.text = "";
        $.previewInitialsMiddle.text = "";
        $.previewInitialsLast.text = "";
        hide($.finalButtons);
        $.theInitials.applyProperties({
            value: "",
            height: 50
        });
        setActivePage("initials");
    }
    function adjustCase(str, type) {
        var tmpStr;
        switch (type) {
          case "smallcaps":
          case "uppercase":
            return str.toUpperCase();

          case "mixed":
            tmpStr = str.substr(0, 1).toLowerCase();
            tmpStr += str.substr(1, 1).toUpperCase();
            tmpStr += str.substr(2, 1).toLowerCase();
            return tmpStr;

          case "lowercase":
            return str.toLowerCase();

          case "circleBlock":
            tmpStr = str.substr(0, 1).toLowerCase();
            tmpStr += str.substr(1, 1).toUpperCase();
            tmpStr += circleBlockTable[str.substr(2, 1).toLowerCase()];
            return tmpStr;

          default:
            return str;
        }
    }
    function setInitials(initials) {
        if ("mixed" == getType() || "circleBlock" == getType()) {
            $.previewInitialsFirst.visible = false;
            $.previewInitialsLast.visible = false;
            $.previewInitialsMiddle.text = initials;
        } else {
            $.previewInitialsFirst.visible = true;
            $.previewInitialsLast.visible = true;
            $.previewInitialsFirst.text = initials.substr(0, 1);
            $.previewInitialsMiddle.text = initials.substr(1, 1);
            $.previewInitialsLast.text = initials.substr(2, 1);
            positionInitials();
        }
    }
    function getType() {
        return fontInfo[Alloy.Globals.platformOS][monogram.font.id].type;
    }
    function positionInitials() {
        fontInfo[Alloy.Globals.platformOS][monogram.font.id].center_x > 0 && fontInfo[Alloy.Globals.platformOS][monogram.font.id].center_y > 0 && ($.previewInitialsView.center = Alloy.isTablet ? {
            x: fontInfo["tablet"][monogram.font.id].center_x,
            y: fontInfo["tablet"][monogram.font.id].center_y
        } : {
            x: fontInfo[Alloy.Globals.platformOS][monogram.font.id].center_x,
            y: fontInfo[Alloy.Globals.platformOS][monogram.font.id].center_y
        });
    }
    function buildFontList() {
        var fonts = fontInfo[Alloy.Globals.platformOS];
        for (i = 0; i < fonts.length; i++) {
            var offset = getOffsets(i, {
                width: 70,
                height: 50,
                columns: 1,
                h_space: 0,
                v_space: 0
            });
            var l = Titanium.UI.createLabel({
                textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
                selectedFont: fonts[i].name,
                selectedFontIndex: i,
                text: adjustCase(monogram.initials, fonts[i].type),
                font: {
                    fontSize: 25,
                    fontFamily: fonts[i].name
                },
                left: 5,
                top: offset.pushtop,
                height: 50,
                width: 55
            });
            l.addEventListener("click", fontClickListener);
            fontTrayLabels.push(l);
            $.fontListView.add(l);
        }
    }
    function fontClickListener(e) {
        monogram.font.name = e.source.selectedFont;
        monogram.font.id = e.source.selectedFontIndex;
        monogram.font.layout = true && Alloy.isTablet ? fontInfo["tablet"][monogram.font.id].layout[monogram.stamp_category] : fontInfo[Alloy.Globals.platformOS][monogram.font.id].layout[monogram.stamp_category];
        fontStatus.selected = true;
        setFont();
    }
    function setFont() {
        var currentPlatform = true && Alloy.isTablet ? "tablet" : Alloy.Globals.platformOS;
        setInitials(adjustCase(monogram.initials, fontInfo[currentPlatform][monogram.font.id].type));
        $.previewInitialsFirst.font = {
            fontSize: fontInfo[currentPlatform][monogram.font.id].layout[monogram.stamp_category].lower,
            fontFamily: fontInfo[Alloy.Globals.platformOS][monogram.font.id].name
        };
        $.previewInitialsMiddle.font = {
            fontSize: fontInfo[currentPlatform][monogram.font.id].layout[monogram.stamp_category].upper,
            fontFamily: fontInfo[Alloy.Globals.platformOS][monogram.font.id].name
        };
        $.previewInitialsLast.font = {
            fontSize: fontInfo[currentPlatform][monogram.font.id].layout[monogram.stamp_category].lower,
            fontFamily: fontInfo[Alloy.Globals.platformOS][monogram.font.id].name
        };
        positionInitials();
    }
    function setFontColor() {
        $.previewInitialsFirst.color = monogram.font.color;
        $.previewInitialsMiddle.color = monogram.font.color;
        $.previewInitialsLast.color = monogram.font.color;
    }
    function clearFontList() {
        for (var i = 0; i < fontTrayLabels.length; i++) $.fontListView.remove(fontTrayLabels[i]);
        while (fontTrayLabels.length > 0) fontTrayLabels.shift();
        $.font1.text = "";
        $.font2FirstInitial.text = "";
        $.font2MiddleInitial.text = "";
        $.font2LastInitial.text = "";
        $.font3.text = "";
        $.font4.text = "";
    }
    function selectFont(e) {
        $.theInitials.blur();
        $.theInitials.height = 0;
        monogram.font.name = e.source.selectedFont;
        monogram.font.id = e.source.selectedFontIndex;
        fontStatus.selected = true;
        if (monogram.initials !== $.theInitials.value) {
            monogram.initials = $.theInitials.value;
            setInitials(monogram.initials);
        }
        setFont();
        setActivePage("preview");
        $.bottomNavbar.visible = true;
        buildBackgroundCategoryView();
        hide($.initialsView);
        buildStampListView();
        toggleBackgroundTray();
    }
    function buildBackgroundCategoryView() {
        var backgroundCategoryThumbnails = getBackgroundCategoryThumbs();
        $.backgroundTrayListView.zIndex = 1;
        $.backgroundTrayCategoryListView.zIndex = 2;
        $.backgroundTrayCategoryListView.touchEnabled = true;
        displayThumbnails({
            images: backgroundCategoryThumbnails,
            view: $.backgroundTrayCategoryListView,
            height: 90,
            width: 90,
            columns: 1,
            event_listener: backgroundTrayCategoryClickListener,
            h_space: 5,
            v_space: 5,
            top: 0,
            bottom_spacer: 0
        });
    }
    function buildBackgroundTrayListView(category) {
        var backgroundThumbnails = getBackgroundImages(category);
        $.backgroundTrayCategoryListView.touchEnabled = false;
        $.backgroundTrayListView.removeAllChildren();
        displayThumbnails({
            images: backgroundThumbnails,
            view: $.backgroundTrayListView,
            height: 90,
            width: 90,
            columns: 1,
            event_listener: backgroundTrayClickListener,
            h_space: 5,
            v_space: 5,
            top: 0,
            bottom_spacer: 0
        });
        Ti.API.info("building");
        $.backgroundTrayListView.zIndex = 2;
        $.backgroundTrayCategoryListView.zIndex = 1;
    }
    function backgroundTrayCategoryClickListener(e) {
        monogram.background_category = e.source.category;
        hideTray($.backgroundTrayCategoryListView);
        buildBackgroundTrayListView(e.source.category);
    }
    function backgroundTrayClickListener(e) {
        monogram.background_category = e.source.category;
        setBackgroundImage(e.source.image);
        toggleBackgroundTray();
    }
    function setBackgroundImage(image) {
        var progressBar = Titanium.UI.createProgressBar({
            width: 200,
            height: 50,
            min: 0,
            max: 1,
            message: "Downloading your background...",
            font: {
                fontSize: 12
            },
            style: null,
            top: 70
        });
        $.previewView.add(progressBar);
        progressBar.show();
        var filename = getFilename(image);
        "ipad" == Alloy.Globals.platformOS && (filename = filename.replace("phone", "tablet"));
        var url;
        url = Alloy.Globals.CONFIG_SERVER_URL + "/content/backgrounds/" + getDensityPart() + "/" + getCategory(image) + "/" + filename;
        url = url.replace("phone_", "tablet_");
        Alloy.Globals.get_remote_file("currentBackground.png", url, true, function(e) {
            alert("Oops! We're sorry, but there was an error fetching your background image from the remote server.\n\nPlease make sure you have Internet access for your device.\n\nERROR: " + e.error);
        }, function(e) {
            progressBar.value = e;
            pages.log(e);
        }, function() {
            var filename = Titanium.Filesystem.applicationDataDirectory + Titanium.Filesystem.separator + "currentBackground.png";
            $.previewBackground.backgroundImage = filename;
            monogram.background = filename;
            progressBar.hide();
        });
    }
    function getDensityPart() {
        var dpi = Ti.Platform.DisplayCaps.dpi;
        return 120 >= dpi ? "ldpi" : 160 >= dpi ? "mdpi" : 240 >= dpi ? "hdpi" : "xhdpi";
    }
    function buildStampListView() {
        displayThumbnails({
            images: getStampThumbs(),
            view: $.stampListView,
            height: 50,
            width: 50,
            columns: 1,
            event_listener: stampClickListener,
            h_space: 10,
            v_space: 5
        });
    }
    function stampClickListener(e) {
        setStamp(e.source.image, true);
    }
    function setStamp(image, status) {
        var category = getCategory(image);
        monogram.stamp_category = category;
        if (stampStatus.colored || stampStatus.firedOnce && "" !== monogram.stamp.file) monogram.stamp.file = Array(Titanium.Filesystem.applicationDataDirectory, "stamps", category, stamps[category].stub + "_" + monogram.stamp.color + ".png").join(Titanium.Filesystem.separator); else {
            monogram.stamp.file = Array(Titanium.Filesystem.applicationDataDirectory, "stamps", category, stamps[category].default).join(Titanium.Filesystem.separator);
            monogram.stamp.color = getColor(image);
        }
        status && (stampStatus.selected = true);
        $.previewStamp.image = monogram.stamp.file;
        setFont();
        $.previewInitialsView.visible = true;
        positionInitials();
    }
    function goInitials() {
        if ("initials" == active_page || "background" == active_page) return;
        closeOpenTray();
        setActivePage("initials_popup");
        hide($.finalButtons);
        var popup = Titanium.UI.createView({
            top: 0,
            bottom: 0,
            left: 0,
            right: 0,
            backgroundColor: "#88000000",
            opacity: void 0
        });
        var popup_box = Titanium.UI.createView({
            borderRadius: 10,
            backgroundColor: "white",
            width: 300,
            height: 120,
            opacity: void 0
        });
        var initials = Titanium.UI.createTextField({
            hintText: "Enter your initials",
            maxLength: 3,
            height: 50,
            top: 10,
            font: {
                fontFamily: "Futura Medium Condensed",
                fontSize: "30dp"
            },
            color: "#999999",
            backgroundColor: "white",
            textAlign: "center",
            autocapitalization: Titanium.UI.TEXT_AUTOCAPITALIZATION_ALL,
            autocorrect: false,
            returnKeyType: Titanium.UI.RETURNKEY_RETURN
        });
        var separator = Titanium.UI.createView({
            top: 70,
            height: 1,
            width: Titanium.UI.FILL,
            backgroundColor: "#eeeeee"
        });
        var doneButton = Titanium.UI.createButton({
            borderRadius: 0,
            borderColor: "transparent",
            style: 0,
            bottom: 0,
            title: "Done",
            font: {
                fontSize: 20
            },
            color: "#ff99cc",
            backgroundColor: "white"
        });
        initials.addEventListener("return", function(e) {
            "" !== e.source.value && (monogram.initials = e.source.value);
        });
        initials.addEventListener("change", function(e) {
            if (e.source.value.length >= 3) {
                initials.blur();
                monogram.initials = e.source.value;
            }
        });
        doneButton.addEventListener("click", function() {
            var animation = require("alloy/animation");
            animation.fadeOut(popup_box, 800);
            animation.fadeOut(popup, 200);
            $.container.remove(popup);
            initials.blur();
            setInitials(adjustCase(monogram.initials, fontInfo[Alloy.Globals.platformOS][monogram.font.id].type));
            show($.finalButtons);
            clearFontList();
        });
        popup_box.add(initials);
        popup_box.add(separator);
        popup_box.add(doneButton);
        $.container.add(popup);
        var animation = require("alloy/animation");
        animation.fadeIn(popup, 200);
        popup.add(popup_box);
        animation.fadeIn(popup_box, 800);
        popup_box.animate({
            opacity: 1,
            duration: 800,
            curve: Titanium.UI.ANIMATION_CURVE_EASE_IN
        });
    }
    function goBackground() {
        if ("initials" == active_page) return;
        if ("backgroundtray" !== open_tray) {
            closeOpenTray();
            $.backgroundTrayListView.zIndex = 1;
            $.backgroundTrayCategoryListView.zIndex = 2;
            $.backgroundTrayCategoryListView.touchEnabled = true;
        }
        setActivePage("backgroundtray");
        toggleBackgroundTray();
    }
    function goStamp() {
        "stamptray" !== open_tray && closeOpenTray();
        setActivePage("stamp");
        toggleStampTray();
    }
    function goFont() {
        if ("background" == active_page || "initials" == active_page) return;
        "fonttray" !== open_tray && closeOpenTray();
        setActivePage("font");
        toggleFontTray();
    }
    function goTrash() {
        closeOpenTray();
        setActivePage("trash");
        var dialog = Ti.UI.createAlertDialog({
            cancel: 1,
            buttonNames: [ "Yes", "No" ],
            message: "Would you like to clear the current design and start over?",
            title: "Trash"
        });
        dialog.addEventListener("click", function(e) {
            setActivePage("preview");
            switch (e.index) {
              case 0:
                reset();
                break;

              case 1:            }
        });
        dialog.show();
    }
    function goClose(e) {
        e.cancelBubble = true;
        var dialog = Ti.UI.createAlertDialog({
            cancel: 1,
            buttonNames: [ "Yes", "Cancel" ],
            message: "Do you want to stop building your wallpaper? Your design will not be saved!",
            title: "Close"
        });
        dialog.addEventListener("click", function(e) {
            switch (e.index) {
              case 0:
                close();
                break;

              case 1:            }
        });
        dialog.show();
    }
    function close() {
        pages.close({
            type: "controller",
            name: "wallpaper"
        });
    }
    function createPreviewWindow() {
        var fontIndex = monogram.font.id;
        var stampSize;
        var initials_wrapSize;
        if ("ipad" == getDensityPart() || "xhdpi" == getDensityPart() || Alloy.isTablet) {
            stampSize = 300;
            initials_wrapSize = 400;
        } else {
            stampSize = 150;
            initials_wrapSize = 200;
        }
        var winWidth;
        var winHeight = Titanium.Platform.displayCaps.platformHeight;
        var fontPlatform;
        if ("ipad" == getDensityPart()) {
            winWidth = Titanium.Platform.displayCaps.platformHeight;
            fontPlatform = "ipad";
        } else if ("iphone" == getDensityPart()) {
            winWidth = Titanium.Platform.displayCaps.platformWidth;
            fontPlatform = "iphone";
        } else {
            winWidth = 2 * Titanium.Platform.displayCaps.platformWidth;
            winHeight = winWidth;
            fontPlatform = "android";
            ("xhdpi" == getDensityPart() || "hdpi" == getDensityPart() || isTablet) && (fontPlatform = "tablet");
        }
        var previewWin = Titanium.UI.createWindow({
            fullscreen: true,
            backgroundColor: "white",
            backgroundImage: Titanium.Filesystem.applicationDataDirectory + Titanium.Filesystem.separator + "currentBackground.png",
            width: winWidth,
            height: winHeight
        });
        var stamp = Titanium.UI.createView({
            width: stampSize,
            height: stampSize,
            backgroundImage: $.previewStamp.image
        });
        var initials_wrap = Titanium.UI.createView({
            height: initials_wrapSize,
            width: initials_wrapSize
        });
        var initials = Titanium.UI.createView({
            height: Titanium.UI.SIZE,
            width: Titanium.UI.SIZE,
            verticalAlign: Titanium.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
            layout: "horizontal"
        });
        if ("uppercase" == fontInfo[fontPlatform][monogram.font.id].type) {
            var first = Titanium.UI.createLabel({
                font: {
                    fontSize: fontInfo[fontPlatform][fontIndex].layout[monogram.stamp_category].lower,
                    fontFamily: fontInfo[fontPlatform][fontIndex].name
                },
                color: monogram.font.color,
                height: Titanium.UI.SIZE,
                width: Titanium.UI.SIZE,
                textAlign: Titanium.UI.TEXT_ALIGNMENT_CENTER,
                verticalAlign: Titanium.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
                text: $.previewInitialsFirst.text
            });
            initials.add(first);
        }
        var middle = Titanium.UI.createLabel({
            font: {
                fontSize: fontInfo[fontPlatform][monogram.font.id].layout[monogram.stamp_category].upper,
                fontFamily: fontInfo[fontPlatform][fontIndex].name
            },
            color: monogram.font.color,
            height: Titanium.UI.SIZE,
            width: Titanium.UI.SIZE,
            textAlign: Titanium.UI.TEXT_ALIGNMENT_CENTER,
            verticalAlign: Titanium.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
            text: $.previewInitialsMiddle.text
        });
        initials.add(middle);
        if ("uppercase" == fontInfo[fontPlatform][monogram.font.id].type) {
            var last = Titanium.UI.createLabel({
                font: {
                    fontSize: fontInfo[fontPlatform][fontIndex].layout[monogram.stamp_category].lower,
                    fontFamily: fontInfo[fontPlatform][fontIndex].name
                },
                color: monogram.font.color,
                height: Titanium.UI.SIZE,
                width: Titanium.UI.SIZE,
                textAlign: Titanium.UI.TEXT_ALIGNMENT_CENTER,
                verticalAlign: Titanium.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
                text: $.previewInitialsLast.text
            });
            initials.add(last);
        }
        initials_wrap.add(initials);
        previewWin.add(stamp);
        previewWin.add(initials_wrap);
        fontInfo[fontPlatform][monogram.font.id].center_x > 0 && fontInfo[fontPlatform][monogram.font.id].center_y > 0 && (initials.center = {
            x: fontInfo[fontPlatform][monogram.font.id].center_x,
            y: fontInfo[fontPlatform][monogram.font.id].center_y
        });
        return previewWin;
    }
    function saveWallpaper(e) {
        e && (e.cancelBubble = true);
        var wallpaperImage;
        var installDir = "";
        if (Ti.Filesystem.isExternalStoragePresent()) installDir = Ti.Filesystem.externalStorageDirectory; else {
            Ti.API.info("Writing to app data");
            installDir = Ti.Filesystem.applicationDataDirectory;
        }
        $.saveButton.applyProperties({
            enabled: false,
            title: "Saving..."
        });
        var win = $.previewView;
        var temp_target;
        setTimeout(function() {
            $.saveButton.applyProperties({
                enabled: true,
                title: "Save"
            });
            wallpaperImage = win.toImage(null, true).media;
            temp_target = Titanium.Filesystem.getFile(installDir + Titanium.Filesystem.separator + "My_Wallpaper" + randomXToY(0, 1e8) + ".png");
            temp_target.write(wallpaperImage);
            Ti.Media.Android.scanMediaFiles([ temp_target.nativePath ], null, function() {});
            Ti.UI.createAlertDialog({
                ok: "Ok",
                message: "Your wallpaper has been saved to your photo gallery. Click the back button to return to the wallpaper tool.",
                title: "Wallpaper Saved"
            }).show();
        }, 2e3);
    }
    function randomXToY(minVal, maxVal) {
        var randVal = minVal + Math.random() * (maxVal - minVal);
        return Math.round(randVal);
    }
    function shareWallpaper(e) {
        e.cancelBubble = true;
        var win = createPreviewWindow();
        image = win.toImage(null, true);
        var dialog = Ti.UI.createOptionDialog({
            title: "Share",
            options: [ "Facebook", "Twitter", "Instagram", "Pinterest", "Mail", "Cancel" ],
            cancel: 5
        });
        dialog.addEventListener("click", function(e) {
            if (5 == e.index) return;
            var sharer = null;
            var title = "Check out my new #monogrammed wallpaper from the marleylilly.com app! " + Alloy.Globals.appConfigArray["share_hash_tags"];
            Titanium.UI.Clipboard.clearText();
            Titanium.UI.Clipboard.setText(title);
            var toast = Ti.UI.createNotification({
                message: "We've added a caption to your clipboard. Just paste and share!",
                duration: Ti.UI.NOTIFICATION_DURATION_LONG
            });
            toast.show();
            switch (e.index) {
              case 0:
                sharer = "Facebook";
                break;

              case 1:
                sharer = "Twitter";
                break;

              case 2:
                sharer = "Instagram";
                break;

              case 3:
                sharer = "Pinterest";
                break;

              case 4:
                sharer = "Mail";
            }
            var shared = false;
            if ("Twitter" === sharer) {
                var Twitter = require("twitter2").Twitter;
                var client = Twitter({
                    consumerKey: "CTex7t3SHvTopz8RHPW0A",
                    consumerSecret: "7novehFUNQUCyuAjPX482Gj7pPXxB6Wh1wjKMDvZE",
                    accessTokenKey: Ti.App.Properties.getString("twitterAccessTokenKey", ""),
                    accessTokenSecret: Ti.App.Properties.getString("twitterAccessTokenSecret", "")
                });
                var blob;
                client.addEventListener("login", function(e22) {
                    Ti.App.Properties.setString("twitterAccessTokenKey", e22.accessTokenKey);
                    Ti.App.Properties.setString("twitterAccessTokenSecret", e22.accessTokenSecret);
                    if (e22.success && !shared) {
                        var progressIndicator = Ti.UI.Android.createProgressIndicator({
                            message: "Uploading...",
                            location: Ti.UI.Android.PROGRESS_INDICATOR_DIALOG
                        });
                        progressIndicator.show();
                        var params = {};
                        Ti.API.info("Trying to upload");
                        shared = true;
                        path = "https://api.twitter.com/1.1/statuses/update_with_media.json";
                        params["media[]"] = $.previewView.toImage(null, true).media;
                        params.status = title;
                        headers = {
                            "Content-Type": "multipart/form-data"
                        };
                        try {
                            client.request(path, params, headers, "POST", function(e) {
                                progressIndicator.hide();
                                if (e.success) {
                                    {
                                        Ti.UI.createAlertDialog({});
                                    }
                                    Ti.API.info("Success uploading !");
                                } else Ti.API.info("No success");
                            });
                        } catch (exe) {
                            progressIndicator.hide();
                        }
                    } else alert(e.error);
                });
                client.authorize();
            } else if ("Facebook" === sharer) {
                Ti.API.info("Sharer facebook");
                var fb = require("facebook");
                fb.appid = "630313837036575";
                fb.permissions = [ "publish_stream" ];
                fb.addEventListener("login", function(fe) {
                    if (fe.success) {
                        var blob = $.previewView.toImage(null, true).media;
                        var data = {
                            message: title,
                            picture: blob
                        };
                        var progressIndicator = Ti.UI.Android.createProgressIndicator({
                            message: "Uploading...",
                            location: Ti.UI.Android.PROGRESS_INDICATOR_DIALOG
                        });
                        progressIndicator.show();
                        fb.requestWithGraphPath("me/photos", data, "POST", function(fe1) {
                            progressIndicator.hide();
                            alert(fe1.success ? "Success!  From FB: " + fe1.result : fe1.error ? fe1.error : "Unkown result");
                        });
                    } else Ti.API.info("login unsuccessful");
                });
                if (fb.loggedIn) {
                    Ti.API.info("Already logged in ");
                    var blob = $.previewView.toImage(null, true).media;
                    var data = {
                        message: title,
                        picture: blob
                    };
                    var progressIndicator = Ti.UI.Android.createProgressIndicator({
                        message: "Uploading...",
                        location: Ti.UI.Android.PROGRESS_INDICATOR_DIALOG
                    });
                    progressIndicator.show();
                    fb.requestWithGraphPath("me/photos", data, "POST", function(fe1) {
                        progressIndicator.hide();
                        alert(fe1.success ? "Image uploaded !" : fe1.error ? "An error occurred" : "Unkown result");
                    });
                } else fb.authorize();
            } else saveWallpaper(null, function(path) {
                Ti.API.info("The path is " + path);
                var file = Titanium.Filesystem.getFile(path);
                var shareIntent = Ti.Android.createIntent({
                    action: Ti.Android.ACTION_SEND,
                    type: "image/png"
                });
                shareIntent.putExtra(Ti.Android.EXTRA_TITLE, "Share Wallpaper");
                shareIntent.putExtra(Ti.Android.EXTRA_TEXT, title);
                shareIntent.putExtraUri(Ti.Android.EXTRA_STREAM, file.nativePath);
                Ti.Android.currentActivity.startActivity(Ti.Android.createIntentChooser(shareIntent, "Share image"));
            });
        });
        dialog.show();
    }
    function swipeListener(e) {
        switch (open_tray) {
          case "navtray":
            "right" == e.direction && toggleNavTray(e);
            break;

          case "fonttray":
            "left" == e.direction;
            break;

          case "stamptray":
            "left" == e.direction;
            break;

          case "backgroundtray":
            "left" == e.direction;
            break;

          default:
            "left" == e.direction ? toggleNavTray(e) : "right" == e.direction;
        }
    }
    function closeOpenTray() {
        switch (open_tray) {
          case "navtray":
            toggleNavTray();
            break;

          case "fonttray":
            toggleFontTray();
            break;

          case "stamptray":
            toggleStampTray();
            break;

          case "backgroundtray":
            toggleBackgroundTray();
        }
        "background" == active_page && setActivePage("preview");
        open_tray = "";
    }
    function toggleNavTray() {
        $.theInitials.blur();
        $.navTray.toggle($.content);
        open_tray = "navtray" == open_tray ? "" : "navtray";
    }
    function toggleFontTray() {
        fontStatus.firedOnce ? false : true;
        if ("fonttray" == open_tray) {
            $.fontTray.animate(LEFTTRAY_SLIDE_LEFT);
            open_tray = "";
            show($.finalButtons);
        } else {
            if (fontStatus.firedOnce) {
                fontStatus.selected = false;
                fontStatus.colored = false;
            }
            fontStatus.firedOnce = true;
            buildFontList();
            $.fontTray.animate(LEFTTRAY_SLIDE_RIGHT);
            open_tray = "fonttray";
            hide($.finalButtons);
        }
    }
    function toggleStampTray() {
        stampStatus.firedOnce ? false : true;
        stampStatus.firedOnce = true;
        if ("stamptray" == open_tray) {
            $.stampTray.animate(LEFTTRAY_SLIDE_LEFT);
            open_tray = "";
            show($.finalButtons);
        } else {
            stampStatus.selected = false;
            stampStatus.colored = false;
            $.stampTray.animate(LEFTTRAY_SLIDE_RIGHT);
            open_tray = "stamptray";
            hide($.finalButtons);
        }
    }
    function toggleBackgroundTray() {
        backgroundStatus.firedOnce ? false : true;
        backgroundStatus.firedOnce = true;
        if ("backgroundtray" == open_tray) {
            $.backgroundTray.animate(LEFTTRAY_SLIDE_LEFT);
            open_tray = "";
            show($.finalButtons);
        } else {
            showTray($.backgroundTrayCategoryListView);
            $.backgroundTrayListView.removeAllChildren();
            $.backgroundTray.animate(LEFTTRAY_SLIDE_RIGHT);
            open_tray = "backgroundtray";
            setActivePage("backgroundtray");
            hide($.finalButtons);
        }
    }
    function setActivePage(page) {
        switch (active_page) {
          case "initials":
          case "initials_popup":
            $.btn_initials.image = "/images/icons/initials.png";
            break;

          case "font":
            $.btn_font.image = "/images/icons/fonts.png";
            break;

          case "background":
          case "backgroundtray":
            $.btn_background.image = "/images/icons/backgrounds.png";
            break;

          case "stamp":
            $.btn_stamp.image = "/images/icons/stamps.png";
            break;

          case "trash":
            $.btn_trash.image = "/images/icons/trash.png";
        }
        active_page = page;
        switch (page) {
          case "initials":
          case "initials_popup":
            $.btn_initials.image = "/images/icons/initials-active.png";
            break;

          case "font":
            $.btn_font.image = "/images/icons/fonts-active.png";
            break;

          case "background":
          case "backgroundtray":
            $.btn_background.image = "/images/icons/backgrounds-active.png";
            break;

          case "stamp":
            $.btn_stamp.image = "/images/icons/stamps-active.png";
            break;

          case "trash":
            $.btn_trash.image = "/images/icons/trash-active.png";
        }
    }
    function reset() {
        clearFontList();
        Initialize();
        var showInitials = Titanium.UI.createAnimation({
            opacity: 1,
            duration: 200,
            curve: null
        });
        $.initialsView.animate(showInitials);
    }
    function hideTray(v) {
        hide(v);
    }
    function showTray(v) {
        show(v);
    }
    function hide(v) {
        var animation = require("alloy/animation");
        animation.fadeOut(v, 200);
    }
    function show(v) {
        var animation = require("alloy/animation");
        animation.fadeIn(v, 200);
    }
    function getBackgroundCategoryThumbs() {
        var images = [];
        var categories = [];
        var file_obj = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, "backgrounds");
        var bkg_dir_list = file_obj.getDirectoryListing();
        for (var i = 0; i < bkg_dir_list.length; i++) {
            file_obj = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, "backgrounds", bkg_dir_list[i]);
            pages.log("BACKGROUND CATEGORY THUMBS  at " + Titanium.Filesystem.applicationDataDirectory + "/backgrounds/" + bkg_dir_list[i]);
            if (file_obj.isDirectory()) {
                categories.push(bkg_dir_list[i]);
                images.push(Array(Titanium.Filesystem.applicationDataDirectory, "backgrounds", bkg_dir_list[i], "thumb.png").join(Titanium.Filesystem.separator));
            }
        }
        background_categories = categories;
        return images;
    }
    function getBackgroundImages(category) {
        var images = [];
        var path_stub = Array("backgrounds", category).join(Titanium.Filesystem.separator);
        var file_obj = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, path_stub);
        var file_list = file_obj.getDirectoryListing();
        for (var i = 0; i < file_list.length; i++) {
            file_obj = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, path_stub, file_list[i]);
            file_obj.isFile() && "thumb.png" !== file_list[i] && images.push(Array(Titanium.Filesystem.applicationDataDirectory, path_stub, file_list[i]).join(Titanium.Filesystem.separator));
        }
        pages.log(images);
        return images;
    }
    function getStampThumbs() {
        var images = [];
        var categories = [];
        var file;
        var file_obj = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, "stamps");
        var dir_list = file_obj.getDirectoryListing();
        for (var i = 0; i < dir_list.length; i++) {
            file_obj = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, "stamps", dir_list[i]);
            if (file_obj.isDirectory()) {
                categories.push(dir_list[i]);
                pages.log("dir_list[" + i + "] = " + dir_list[i]);
                images.push(Array(Titanium.Filesystem.applicationDataDirectory, "stamps", dir_list[i], stamps[dir_list[i]].default).join(Titanium.Filesystem.separator));
                file = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, "stamps", dir_list[i], stamps[dir_list[i]].default);
                pages.log(file.exists() ? Array("stamps", dir_list[i], stamps[dir_list[i]].default).join(Titanium.Filesystem.separator) + " was FOUND" : Array("stamps", dir_list[i], stamps[dir_list[i]].default).join(Titanium.Filesystem.separator) + " was NOT FOUND");
            }
        }
        return images;
    }
    function displayThumbnails(args) {
        var offset;
        for (var i = 0; i < args.images.length; i++) {
            offset = getOffsets(i, args);
            var iv = Titanium.UI.createImageView({
                image: args.images[i],
                width: args.width,
                height: args.height,
                left: offset.pushleft + args.h_space,
                top: offset.pushtop,
                category: getCategory(args.images[i])
            });
            iv.addEventListener("click", args.event_listener);
            args.view.add(iv);
        }
        if ("undefined" != typeof args.bottom_spacer && null !== args.bottom_spacer && args.bottom_spacer > 0) {
            var row = Math.floor(i / args.columns);
            offset = getOffsets(args.columns * (row + 1), args);
            args.view.add(Titanium.UI.createView({
                height: args.bottom_spacer,
                top: offset.pushtop
            }));
        }
    }
    function getOffsets(index, args) {
        var top = "undefined" != typeof args.top && null !== args.top ? args.top : 0;
        var vertical_index = Math.floor(index / args.columns);
        var vertical_offset;
        vertical_offset = vertical_index > 0 ? vertical_index * args.v_space + top : vertical_index + top;
        var offset = {};
        offset.pushleft = index % args.columns * args.width + index % args.columns * args.h_space;
        offset.pushtop = vertical_index * args.height + vertical_offset;
        return offset;
    }
    function getColor(filename) {
        var str = filename.split(".");
        str = str[0].split("_");
        return str[2];
    }
    function getFilename(filepath) {
        var fileArray = filepath.split(Titanium.Filesystem.getSeparator());
        return fileArray.slice(-1).toString();
    }
    function getCategory(filepath) {
        var fileArray = filepath.split(Titanium.Filesystem.getSeparator());
        return fileArray.slice(-2, -1);
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "wallpaper";
    if (arguments[0]) {
        {
            __processArg(arguments[0], "__parentSymbol");
        }
        {
            __processArg(arguments[0], "$model");
        }
        {
            __processArg(arguments[0], "__itemTemplate");
        }
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.container = Ti.UI.createWindow({
        backgroundColor: "#fa72c0",
        navBarHidden: "true",
        id: "container"
    });
    $.__views.container && $.addTopLevelView($.__views.container);
    swipeListener ? $.__views.container.addEventListener("swipe", swipeListener) : __defers["$.__views.container!swipe!swipeListener"] = true;
    $.__views.statusBar = Ti.UI.createView({
        top: 0,
        height: 20,
        backgroundColor: "#88fcf9f9",
        id: "statusBar"
    });
    $.__views.container.add($.__views.statusBar);
    $.__views.navTray = Alloy.createWidget("navtray", "widget", {
        id: "navTray",
        __parentSymbol: $.__views.container
    });
    $.__views.navTray.setParent($.__views.container);
    $.__views.content = Ti.UI.createView({
        height: Titanium.UI.FILL,
        backgroundColor: "white",
        id: "content"
    });
    $.__views.container.add($.__views.content);
    $.__views.mainView = Ti.UI.createView({
        top: 0,
        bottom: 0,
        id: "mainView"
    });
    $.__views.content.add($.__views.mainView);
    $.__views.previewView = Ti.UI.createView({
        width: Titanium.UI.FILL,
        height: Titanium.UI.FILL,
        left: 0,
        top: 0,
        id: "previewView"
    });
    $.__views.mainView.add($.__views.previewView);
    $.__views.previewBackground = Ti.UI.createImageView(function() {
        var o = {};
        Alloy.isHandheld && _.extend(o, {
            width: Ti.UI.FILL,
            height: Ti.UI.FILL,
            left: 0,
            top: 0
        });
        _.extend(o, {
            width: Ti.UI.FILL,
            height: Ti.UI.FILL
        });
        Alloy.isTablet && _.extend(o, {
            width: Ti.UI.FILL,
            height: Ti.UI.FILL,
            left: 0,
            top: 0
        });
        _.extend(o, {
            id: "previewBackground"
        });
        return o;
    }());
    $.__views.previewView.add($.__views.previewBackground);
    $.__views.previewStamp = Ti.UI.createImageView(function() {
        var o = {};
        _.extend(o, {
            height: 150,
            width: 150
        });
        Alloy.isTablet && _.extend(o, {
            height: 300,
            width: 300
        });
        _.extend(o, {
            id: "previewStamp"
        });
        return o;
    }());
    $.__views.previewView.add($.__views.previewStamp);
    $.__views.previewInitialsWrap = Ti.UI.createView(function() {
        var o = {};
        _.extend(o, {
            height: 200,
            width: 200
        });
        Alloy.isTablet && _.extend(o, {
            width: 400,
            height: 400
        });
        _.extend(o, {
            id: "previewInitialsWrap"
        });
        return o;
    }());
    $.__views.previewView.add($.__views.previewInitialsWrap);
    $.__views.previewInitialsView = Ti.UI.createView({
        height: Titanium.UI.SIZE,
        width: Titanium.UI.SIZE,
        verticalAlign: Titanium.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
        layout: "horizontal",
        id: "previewInitialsView"
    });
    $.__views.previewInitialsWrap.add($.__views.previewInitialsView);
    $.__views.previewInitialsFirst = Ti.UI.createLabel({
        font: {
            fontSize: 40,
            fontFamily: "Futura Medium Condensed"
        },
        color: "#ffffff",
        height: Titanium.UI.SIZE,
        width: Titanium.UI.SIZE,
        textAlign: Titanium.UI.TEXT_ALIGNMENT_CENTER,
        verticalAlign: Titanium.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
        id: "previewInitialsFirst"
    });
    $.__views.previewInitialsView.add($.__views.previewInitialsFirst);
    $.__views.previewInitialsMiddle = Ti.UI.createLabel({
        font: {
            fontSize: 70,
            fontFamily: "Futura Medium Condensed"
        },
        color: "#ffffff",
        height: Titanium.UI.SIZE,
        width: Titanium.UI.SIZE,
        textAlign: Titanium.UI.TEXT_ALIGNMENT_CENTER,
        verticalAlign: Titanium.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
        id: "previewInitialsMiddle"
    });
    $.__views.previewInitialsView.add($.__views.previewInitialsMiddle);
    $.__views.previewInitialsLast = Ti.UI.createLabel({
        font: {
            fontSize: 40,
            fontFamily: "Futura Medium Condensed"
        },
        color: "#ffffff",
        height: Titanium.UI.SIZE,
        width: Titanium.UI.SIZE,
        textAlign: Titanium.UI.TEXT_ALIGNMENT_CENTER,
        verticalAlign: Titanium.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
        id: "previewInitialsLast"
    });
    $.__views.previewInitialsView.add($.__views.previewInitialsLast);
    $.__views.initialsView = Ti.UI.createView({
        top: 0,
        bottom: 0,
        left: 0,
        right: 0,
        backgroundColor: "white",
        id: "initialsView"
    });
    $.__views.mainView.add($.__views.initialsView);
    $.__views.initialsPreview = Ti.UI.createView(function() {
        var o = {};
        _.extend(o, {
            width: Titanium.UI.FILL,
            height: 120,
            top: 70
        });
        Alloy.isTablet && _.extend(o, {
            height: 300
        });
        _.extend(o, {
            top: 100,
            layout: "vertical",
            id: "initialsPreview"
        });
        return o;
    }());
    $.__views.initialsView.add($.__views.initialsPreview);
    $.__views.row1 = Ti.UI.createView(function() {
        var o = {};
        Alloy.isHandheld && _.extend(o, {
            width: 200,
            height: "50%"
        });
        Alloy.isTablet && _.extend(o, {
            width: 300,
            height: "50%"
        });
        _.extend(o, {
            id: "row1"
        });
        return o;
    }());
    $.__views.initialsPreview.add($.__views.row1);
    $.__views.font1 = Ti.UI.createLabel(function() {
        var o = {};
        Alloy.isHandheld && _.extend(o, {
            font: {
                fontSize: 40,
                fontFamily: "monogram kk sc"
            },
            left: 0
        });
        Alloy.isTablet && _.extend(o, {
            font: {
                fontSize: 80,
                fontFamily: "monogram kk sc"
            },
            left: 0
        });
        _.extend(o, {
            id: "font1",
            selectedFontIndex: "2",
            selectedFont: "monogram kk sc"
        });
        return o;
    }());
    $.__views.row1.add($.__views.font1);
    selectFont ? $.__views.font1.addEventListener("click", selectFont) : __defers["$.__views.font1!click!selectFont"] = true;
    $.__views.font2 = Ti.UI.createView(function() {
        var o = {};
        _.extend(o, {
            layout: "horizontal",
            width: Titanium.UI.SIZE,
            height: Titanium.UI.SIZE,
            right: 0
        });
        Alloy.isTablet && _.extend(o, {
            right: 0
        });
        _.extend(o, {
            id: "font2",
            selectedFontIndex: "0",
            selectedFont: "HelveticaNeue"
        });
        return o;
    }());
    $.__views.row1.add($.__views.font2);
    selectFont ? $.__views.font2.addEventListener("click", selectFont) : __defers["$.__views.font2!click!selectFont"] = true;
    $.__views.font2FirstInitial = Ti.UI.createLabel(function() {
        var o = {};
        Alloy.isHandheld && _.extend(o, {
            font: {
                fontSize: 30,
                fontFamily: "HelveticaNeue"
            }
        });
        Alloy.isTablet && _.extend(o, {
            font: {
                fontSize: 50,
                fontFamily: "HelveticaNeue"
            }
        });
        _.extend(o, {
            id: "font2FirstInitial",
            selectedFontIndex: "0",
            selectedFont: "HelveticaNeue"
        });
        return o;
    }());
    $.__views.font2.add($.__views.font2FirstInitial);
    $.__views.font2MiddleInitial = Ti.UI.createLabel(function() {
        var o = {};
        Alloy.isHandheld && _.extend(o, {
            font: {
                fontSize: 40,
                fontFamily: "HelveticaNeue"
            }
        });
        Alloy.isTablet && _.extend(o, {
            font: {
                fontSize: 80,
                fontFamily: "HelveticaNeue"
            }
        });
        _.extend(o, {
            id: "font2MiddleInitial",
            selectedFontIndex: "0",
            selectedFont: "HelveticaNeue"
        });
        return o;
    }());
    $.__views.font2.add($.__views.font2MiddleInitial);
    $.__views.font2LastInitial = Ti.UI.createLabel(function() {
        var o = {};
        Alloy.isHandheld && _.extend(o, {
            font: {
                fontSize: 30,
                fontFamily: "HelveticaNeue"
            }
        });
        Alloy.isTablet && _.extend(o, {
            font: {
                fontSize: 50,
                fontFamily: "HelveticaNeue"
            }
        });
        _.extend(o, {
            id: "font2LastInitial",
            selectedFontIndex: "0",
            selectedFont: "HelveticaNeue"
        });
        return o;
    }());
    $.__views.font2.add($.__views.font2LastInitial);
    $.__views.row2 = Ti.UI.createView(function() {
        var o = {};
        Alloy.isHandheld && _.extend(o, {
            width: 200,
            height: "50%"
        });
        Alloy.isTablet && _.extend(o, {
            width: 300,
            height: "50%"
        });
        _.extend(o, {
            id: "row2"
        });
        return o;
    }());
    $.__views.initialsPreview.add($.__views.row2);
    $.__views.font3 = Ti.UI.createLabel(function() {
        var o = {};
        Alloy.isHandheld && _.extend(o, {
            selectedFont: "Vine Monograms Solid Bold",
            font: {
                fontSize: 40,
                fontFamily: "Vine Monograms Solid Bold"
            },
            left: 0
        });
        Alloy.isTablet && _.extend(o, {
            font: {
                fontSize: 80,
                fontFamily: "Vine Monograms Solid Bold"
            },
            left: 0
        });
        _.extend(o, {
            id: "font3",
            selectedFontIndex: "1"
        });
        return o;
    }());
    $.__views.row2.add($.__views.font3);
    selectFont ? $.__views.font3.addEventListener("click", selectFont) : __defers["$.__views.font3!click!selectFont"] = true;
    $.__views.font4 = Ti.UI.createLabel(function() {
        var o = {};
        _.extend(o, {
            font: {
                fontSize: 60,
                fontFamily: "Circle Monograms Three White Alt"
            },
            selectedFont: "Circle Monograms Three White Alt",
            right: 0
        });
        Alloy.isTablet && _.extend(o, {
            font: {
                fontSize: 120,
                fontFamily: "Circle Monograms Three White Alt"
            },
            right: 0
        });
        _.extend(o, {
            id: "font4",
            selectedFontIndex: "3"
        });
        return o;
    }());
    $.__views.row2.add($.__views.font4);
    selectFont ? $.__views.font4.addEventListener("click", selectFont) : __defers["$.__views.font4!click!selectFont"] = true;
    $.__views.initialsViewWrap = Ti.UI.createView({
        height: 80,
        id: "initialsViewWrap"
    });
    $.__views.initialsView.add($.__views.initialsViewWrap);
    $.__views.theInitials = Ti.UI.createTextField({
        top: 0,
        height: 50,
        font: {
            fontSize: "30dp"
        },
        color: "#999999",
        textAlign: "center",
        autocapitalization: Titanium.UI.TEXT_AUTOCAPITALIZATION_ALL,
        returnKeyType: Titanium.UI.RETURNKEY_NEXT,
        backgroundColor: "white",
        autocorrect: false,
        id: "theInitials",
        hintText: "Enter your initials",
        maxLength: "3"
    });
    $.__views.initialsViewWrap.add($.__views.theInitials);
    $.__views.initialsLabel = Ti.UI.createLabel({
        top: 51,
        font: {
            fontSize: "10dp"
        },
        text: "First, Last, Middle",
        id: "initialsLabel"
    });
    $.__views.initialsViewWrap.add($.__views.initialsLabel);
    $.__views.stampTray = Ti.UI.createView({
        top: 45,
        bottom: 40,
        width: 100,
        left: -100,
        backgroundColor: "#F0F0F0",
        id: "stampTray"
    });
    $.__views.mainView.add($.__views.stampTray);
    $.__views.stampColorPallete = Alloy.createWidget("colorpallete", "widget", {
        id: "stampColorPallete",
        customParent: "stamp",
        customCallback: "stampClick",
        __parentSymbol: $.__views.stampTray
    });
    $.__views.stampColorPallete.setParent($.__views.stampTray);
    $.__views.stampListView = Ti.UI.createScrollView({
        width: 60,
        right: 5,
        top: 5,
        id: "stampListView"
    });
    $.__views.stampTray.add($.__views.stampListView);
    $.__views.fontTray = Ti.UI.createView({
        top: 45,
        bottom: 40,
        width: 100,
        left: -100,
        backgroundColor: "#F0F0F0",
        id: "fontTray"
    });
    $.__views.mainView.add($.__views.fontTray);
    $.__views.fontColorPallete = Alloy.createWidget("colorpallete", "widget", {
        id: "fontColorPallete",
        customParent: "font",
        customCallback: "fontClick",
        __parentSymbol: $.__views.fontTray
    });
    $.__views.fontColorPallete.setParent($.__views.fontTray);
    $.__views.fontListView = Ti.UI.createScrollView({
        width: 60,
        right: 5,
        top: 5,
        id: "fontListView",
        scrollType: "vertical"
    });
    $.__views.fontTray.add($.__views.fontListView);
    $.__views.backgroundTray = Ti.UI.createView({
        top: 45,
        bottom: 40,
        width: 100,
        left: -100,
        backgroundColor: "#F0F0F0",
        id: "backgroundTray"
    });
    $.__views.mainView.add($.__views.backgroundTray);
    $.__views.backgroundTrayListView = Ti.UI.createScrollView({
        backgroundColor: "#F0F0F0",
        id: "backgroundTrayListView"
    });
    $.__views.backgroundTray.add($.__views.backgroundTrayListView);
    $.__views.backgroundTrayCategoryListView = Ti.UI.createScrollView({
        width: 100,
        height: Titanium.UI.FILL,
        backgroundColor: "#F0F0F0",
        left: 0,
        id: "backgroundTrayCategoryListView"
    });
    $.__views.backgroundTray.add($.__views.backgroundTrayCategoryListView);
    $.__views.topNavbar = Ti.UI.createView({
        backgroundColor: "#effdeaf4",
        top: 0,
        height: 45,
        width: Titanium.UI.FILL,
        id: "topNavbar"
    });
    $.__views.mainView.add($.__views.topNavbar);
    $.__views.btn_done = Ti.UI.createImageView({
        left: 15,
        top: 10,
        backgroundColor: "transparent",
        width: 25,
        id: "btn_done",
        image: "/images/icons/close.png"
    });
    $.__views.topNavbar.add($.__views.btn_done);
    goClose ? $.__views.btn_done.addEventListener("click", goClose) : __defers["$.__views.btn_done!click!goClose"] = true;
    $.__views.btn_menu = Ti.UI.createImageView({
        right: 15,
        top: 5,
        height: 30,
        width: 30,
        id: "btn_menu",
        image: "/images/icons/menu.png"
    });
    $.__views.topNavbar.add($.__views.btn_menu);
    toggleNavTray ? $.__views.btn_menu.addEventListener("click", toggleNavTray) : __defers["$.__views.btn_menu!click!toggleNavTray"] = true;
    if (true && !Alloy.isTablet) {
        $.__views.bottomNavbar = Ti.UI.createView({
            height: 40,
            width: Titanium.UI.FILL,
            bottom: 0,
            backgroundColor: "#effdeaf4",
            visible: false,
            id: "bottomNavbar"
        });
        $.__views.mainView.add($.__views.bottomNavbar);
        $.__views.btn_initials = Ti.UI.createImageView({
            height: 40,
            width: 40,
            left: 15,
            backgroundImage: "/images/icons/initials.png",
            id: "btn_initials"
        });
        $.__views.bottomNavbar.add($.__views.btn_initials);
        goInitials ? $.__views.btn_initials.addEventListener("click", goInitials) : __defers["$.__views.btn_initials!click!goInitials"] = true;
        $.__views.btn_background = Ti.UI.createImageView({
            height: 40,
            width: 40,
            left: 70,
            backgroundImage: "/images/icons/backgrounds.png",
            id: "btn_background"
        });
        $.__views.bottomNavbar.add($.__views.btn_background);
        goBackground ? $.__views.btn_background.addEventListener("click", goBackground) : __defers["$.__views.btn_background!click!goBackground"] = true;
        $.__views.btn_stamp = Ti.UI.createImageView({
            height: 40,
            width: 40,
            left: 125,
            backgroundImage: "/images/icons/stamps.png",
            id: "btn_stamp"
        });
        $.__views.bottomNavbar.add($.__views.btn_stamp);
        goStamp ? $.__views.btn_stamp.addEventListener("click", goStamp) : __defers["$.__views.btn_stamp!click!goStamp"] = true;
        $.__views.btn_font = Ti.UI.createImageView({
            height: 40,
            width: 60,
            left: 180,
            backgroundImage: "/images/icons/fonts.png",
            id: "btn_font"
        });
        $.__views.bottomNavbar.add($.__views.btn_font);
        goFont ? $.__views.btn_font.addEventListener("click", goFont) : __defers["$.__views.btn_font!click!goFont"] = true;
        $.__views.btn_trash = Ti.UI.createImageView({
            height: 40,
            width: 40,
            left: 255,
            backgroundImage: "/images/icons/trash.png",
            id: "btn_trash"
        });
        $.__views.bottomNavbar.add($.__views.btn_trash);
        goTrash ? $.__views.btn_trash.addEventListener("click", goTrash) : __defers["$.__views.btn_trash!click!goTrash"] = true;
    }
    if (true && Alloy.isTablet) {
        $.__views.bottomNavbar = Ti.UI.createView({
            height: 40,
            width: Titanium.UI.FILL,
            bottom: 0,
            backgroundColor: "#effdeaf4",
            visible: false,
            id: "bottomNavbar"
        });
        $.__views.mainView.add($.__views.bottomNavbar);
        $.__views.toolButtonWrap = Ti.UI.createView(function() {
            var o = {};
            Alloy.isTablet && _.extend(o, {
                width: 300
            });
            _.extend(o, {
                id: "toolButtonWrap"
            });
            return o;
        }());
        $.__views.bottomNavbar.add($.__views.toolButtonWrap);
        $.__views.btn_initials = Ti.UI.createImageView({
            height: 40,
            width: 40,
            left: 15,
            backgroundImage: "/images/icons/initials.png",
            id: "btn_initials"
        });
        $.__views.toolButtonWrap.add($.__views.btn_initials);
        goInitials ? $.__views.btn_initials.addEventListener("click", goInitials) : __defers["$.__views.btn_initials!click!goInitials"] = true;
        $.__views.btn_background = Ti.UI.createImageView({
            height: 40,
            width: 40,
            left: 70,
            backgroundImage: "/images/icons/backgrounds.png",
            id: "btn_background"
        });
        $.__views.toolButtonWrap.add($.__views.btn_background);
        goBackground ? $.__views.btn_background.addEventListener("click", goBackground) : __defers["$.__views.btn_background!click!goBackground"] = true;
        $.__views.btn_stamp = Ti.UI.createImageView({
            height: 40,
            width: 40,
            left: 125,
            backgroundImage: "/images/icons/stamps.png",
            id: "btn_stamp"
        });
        $.__views.toolButtonWrap.add($.__views.btn_stamp);
        goStamp ? $.__views.btn_stamp.addEventListener("click", goStamp) : __defers["$.__views.btn_stamp!click!goStamp"] = true;
        $.__views.btn_font = Ti.UI.createImageView({
            height: 40,
            width: 60,
            left: 180,
            backgroundImage: "/images/icons/fonts.png",
            id: "btn_font"
        });
        $.__views.toolButtonWrap.add($.__views.btn_font);
        goFont ? $.__views.btn_font.addEventListener("click", goFont) : __defers["$.__views.btn_font!click!goFont"] = true;
        $.__views.btn_trash = Ti.UI.createImageView({
            height: 40,
            width: 40,
            left: 255,
            backgroundImage: "/images/icons/trash.png",
            id: "btn_trash"
        });
        $.__views.toolButtonWrap.add($.__views.btn_trash);
        goTrash ? $.__views.btn_trash.addEventListener("click", goTrash) : __defers["$.__views.btn_trash!click!goTrash"] = true;
    }
    $.__views.backgroundInstructions = Ti.UI.createView({
        backgroundColor: "#f8f8f8",
        borderRadius: 5,
        opacity: 0,
        width: 175,
        height: 70,
        bottom: 60,
        left: 120,
        visible: false,
        id: "backgroundInstructions"
    });
    $.__views.content.add($.__views.backgroundInstructions);
    $.__views.__alloyId65 = Ti.UI.createLabel({
        font: {
            fontSize: 10,
            fontFamily: "Helvetica Neue"
        },
        color: "#555555",
        wordWrap: true,
        height: "85%",
        width: "85%",
        text: "You can complete your wallpaper by selecting a background from the tray on the left.",
        id: "__alloyId65"
    });
    $.__views.backgroundInstructions.add($.__views.__alloyId65);
    $.__views.stampInstructions = Ti.UI.createView({
        backgroundColor: "#f8f8f8",
        borderRadius: 5,
        opacity: 0,
        width: 175,
        height: 70,
        bottom: 60,
        left: 120,
        visible: false,
        id: "stampInstructions"
    });
    $.__views.content.add($.__views.stampInstructions);
    $.__views.__alloyId66 = Ti.UI.createLabel({
        font: {
            fontSize: 10,
            fontFamily: "Helvetica Neue"
        },
        color: "#555555",
        wordWrap: true,
        height: "85%",
        width: "85%",
        text: "Now that you've selected your wallpaper, continue by changing your center shape options. Just click the center shape icon.",
        id: "__alloyId66"
    });
    $.__views.stampInstructions.add($.__views.__alloyId66);
    $.__views.fontInstructions = Ti.UI.createView({
        backgroundColor: "#f8f8f8",
        borderRadius: 5,
        opacity: 0,
        width: 175,
        height: 70,
        bottom: 60,
        left: 120,
        visible: false,
        id: "fontInstructions"
    });
    $.__views.content.add($.__views.fontInstructions);
    $.__views.__alloyId67 = Ti.UI.createLabel({
        font: {
            fontSize: 10,
            fontFamily: "Helvetica Neue"
        },
        color: "#555555",
        wordWrap: true,
        height: "85%",
        width: "85%",
        text: "You've already selected a font, but you can change it now if you want by clicking the font icon.",
        id: "__alloyId67"
    });
    $.__views.fontInstructions.add($.__views.__alloyId67);
    $.__views.initialsInstructions = Ti.UI.createView({
        backgroundColor: "#f8f8f8",
        borderRadius: 5,
        opacity: 0,
        width: 175,
        height: 70,
        bottom: 60,
        left: 120,
        visible: false,
        id: "initialsInstructions"
    });
    $.__views.content.add($.__views.initialsInstructions);
    $.__views.__alloyId68 = Ti.UI.createLabel({
        font: {
            fontSize: 10,
            fontFamily: "Helvetica Neue"
        },
        color: "#555555",
        wordWrap: true,
        height: "85%",
        width: "85%",
        text: "Feel free to play around and change your settings. You can click the initials icon to change your initials withouth starting over.",
        id: "__alloyId68"
    });
    $.__views.initialsInstructions.add($.__views.__alloyId68);
    $.__views.finalInstructions = Ti.UI.createView({
        backgroundColor: "#f8f8f8",
        borderRadius: 5,
        opacity: 0,
        width: 175,
        height: 70,
        bottom: 60,
        left: 120,
        visible: false,
        id: "finalInstructions"
    });
    $.__views.content.add($.__views.finalInstructions);
    $.__views.__alloyId69 = Ti.UI.createLabel({
        font: {
            fontSize: 10,
            fontFamily: "Helvetica Neue"
        },
        color: "#555555",
        wordWrap: true,
        height: "85%",
        width: "85%",
        text: "Don't forget to share your wallpaper when you're done. You will need to save it to your Photo Album in order to use it as a wallpaper for your device.",
        id: "__alloyId69"
    });
    $.__views.finalInstructions.add($.__views.__alloyId69);
    $.__views.finalButtons = Ti.UI.createView({
        bottom: 51,
        height: 30,
        width: Titanium.UI.SIZE,
        opacity: 0,
        layout: "horizontal",
        id: "finalButtons"
    });
    $.__views.content.add($.__views.finalButtons);
    $.__views.shareButton = Ti.UI.createButton({
        borderRadius: 0,
        font: {
            fontSize: 18
        },
        color: "#ff99cc",
        height: 30,
        backgroundColor: "#ffffff",
        opacity: .9,
        textAlign: Titanium.UI.TEXT_ALIGNMENT_CENTER,
        borderColor: "transparent",
        width: 100,
        title: "Share",
        id: "shareButton"
    });
    $.__views.finalButtons.add($.__views.shareButton);
    shareWallpaper ? $.__views.shareButton.addEventListener("click", shareWallpaper) : __defers["$.__views.shareButton!click!shareWallpaper"] = true;
    $.__views.saveButton = Ti.UI.createButton({
        borderRadius: 0,
        font: {
            fontSize: 18
        },
        color: "#ff99cc",
        height: 30,
        backgroundColor: "#ffffff",
        opacity: .9,
        textAlign: Titanium.UI.TEXT_ALIGNMENT_CENTER,
        borderColor: "transparent",
        left: 20,
        width: 100,
        title: "Save",
        id: "saveButton"
    });
    $.__views.finalButtons.add($.__views.saveButton);
    saveWallpaper ? $.__views.saveButton.addEventListener("click", saveWallpaper) : __defers["$.__views.saveButton!click!saveWallpaper"] = true;
    exports.destroy = function() {};
    _.extend($, $.__views);
    $.container.orientationModes = [ Ti.UI.PORTRAIT ];
    Titanium.UI.orientation = Ti.UI.PORTRAIT;
    require("/testflightjs");
    var pages = require("/pageutils");
    pages.log("platformOS = " + Alloy.Globals.platformOS);
    Alloy.Globals.activeWindows["wallpaper"] = $.container;
    Alloy.Globals.currentWindow = $.container;
    $.statusBar.visible = Alloy.Globals.isiOS7Plus() ? true : false;
    $.navTray.navTray.top = Alloy.Globals.isiOS7Plus() ? 20 : 0;
    $.content.top = Alloy.Globals.isiOS7Plus() ? 20 : 0;
    Alloy.Globals.setFlashSaleTimer("wallpaper", $.navTray.updateTimer);
    var background_categories = [];
    var monogram = {};
    var fontTrayLabels = [];
    var previewMode = false;
    var fontStatus = {};
    var stampStatus = {};
    var backgroundStatus = {};
    var open_tray = "";
    var active_page = "";
    Initialize();
    var stamps = [];
    stamps["circle"] = {
        "default": "phone_circle_thumb.png",
        category: "circle",
        stub: "phone_circle"
    };
    stamps["doublecircle"] = {
        "default": "phone_doublecircle_thumb.png",
        category: "doublecircle",
        stub: "phone_doublecircle"
    };
    stamps["jaggedcircle"] = {
        "default": "phone_jaggedcircle_thumb.png",
        category: "jaggedcircle",
        stub: "phone_jaggedcircle"
    };
    stamps["quatrefoil"] = {
        "default": "phone_quatrefoil_thumb.png",
        category: "quatrefoil",
        stub: "phone_quatrefoil"
    };
    stamps["scallop"] = {
        "default": "phone_scallop_thumb.png",
        category: "scallop",
        stub: "phone_scallop"
    };
    stamps["square"] = {
        "default": "phone_square_thumb.png",
        category: "square",
        stub: "phone_square"
    };
    stamps["square2"] = {
        "default": "phone_square2_thumb.png",
        category: "square2",
        stub: "phone_square2"
    };
    stamps["doublequatrefoil"] = {
        "default": "phone_doublequatrefoil_thumb.png",
        category: "doublequatrefoil",
        stub: "phone_doublequatrefoil"
    };
    stamps["weirdcircle"] = {
        "default": "phone_weirdcircle_thumb.png",
        category: "weirdcircle",
        stub: "phone_weirdcircle"
    };
    var fontInfo = [];
    fontInfo["iphone"] = [ {
        name: "HelveticaNeue",
        type: "uppercase",
        center_x: 100,
        center_y: 100,
        layout: {
            quatrefoil: {
                lower: 40,
                upper: 70,
                left: 45,
                right: 45
            },
            doublecircle: {
                lower: 40,
                upper: 70,
                left: 48,
                right: 45
            },
            circle: {
                lower: 50,
                upper: 90,
                left: 35,
                right: 30
            },
            jaggedcircle: {
                lower: 40,
                upper: 70,
                left: 45,
                right: 40
            },
            scallop: {
                lower: 50,
                upper: 90,
                left: 45,
                right: 45
            },
            square: {
                lower: 40,
                upper: 80,
                left: 45,
                right: 45
            },
            doublequatrefoil: {
                lower: 40,
                upper: 70,
                left: 55,
                right: 53
            },
            square2: {
                lower: 50,
                upper: 90,
                left: 45,
                right: 45
            },
            weirdcircle: {
                lower: 50,
                upper: 80,
                left: 45,
                right: 45
            }
        }
    }, {
        name: "Vine MonogramsSolid Bold",
        type: "mixed",
        center_x: 105,
        center_y: 100,
        layout: {
            quatrefoil: {
                upper: 65
            },
            doublecircle: {
                upper: 75
            },
            circle: {
                upper: 90
            },
            jaggedcircle: {
                upper: 80
            },
            scallop: {
                upper: 85
            },
            square: {
                upper: 85
            },
            doublequatrefoil: {
                upper: 65
            },
            square2: {
                upper: 85
            },
            weirdcircle: {
                upper: 65
            }
        }
    }, {
        name: "monogram kk sc",
        type: "mixed",
        center_x: 100,
        center_y: Alloy.Globals.isiOS7Plus() ? 102 : 109,
        layout: {
            quatrefoil: {
                lower: 40,
                upper: 70,
                left: 20,
                right: 20
            },
            doublecircle: {
                lower: 40,
                upper: 70,
                left: 20,
                right: 20
            },
            circle: {
                lower: 40,
                upper: 90,
                left: 20,
                right: 20
            },
            jaggedcircle: {
                lower: 40,
                upper: 70,
                left: 20,
                right: 20
            },
            scallop: {
                lower: 40,
                upper: 80,
                left: 20,
                right: 20
            },
            square: {
                lower: 40,
                upper: 80,
                left: 20,
                right: 20
            },
            doublequatrefoil: {
                lower: 30,
                upper: 70,
                left: 20,
                right: 20
            },
            square2: {
                lower: 40,
                upper: 80,
                left: 20,
                right: 20
            },
            weirdcircle: {
                lower: 40,
                upper: 75,
                left: 20,
                right: 20
            }
        }
    }, {
        name: "Circle Monograms Three White",
        type: "circleBlock",
        center_x: 97,
        center_y: 100,
        layout: {
            quatrefoil: {
                upper: 120
            },
            doublecircle: {
                upper: 140
            },
            circle: {
                upper: 150
            },
            jaggedcircle: {
                upper: 140
            },
            scallop: {
                upper: 140
            },
            square: {
                upper: 140
            },
            doublequatrefoil: {
                upper: 120
            },
            square2: {
                upper: 140
            },
            weirdcircle: {
                upper: 120
            }
        }
    } ];
    fontInfo["android"] = [ {
        name: "HelveticaNeue",
        type: "uppercase",
        center_x: 100,
        center_y: 100,
        layout: {
            quatrefoil: {
                lower: 40,
                upper: 70,
                left: 45,
                right: 45
            },
            doublecircle: {
                lower: 40,
                upper: 70,
                left: 48,
                right: 45
            },
            circle: {
                lower: 50,
                upper: 90,
                left: 35,
                right: 30
            },
            jaggedcircle: {
                lower: 40,
                upper: 70,
                left: 45,
                right: 40
            },
            scallop: {
                lower: 50,
                upper: 90,
                left: 45,
                right: 45
            },
            square: {
                lower: 40,
                upper: 80,
                left: 45,
                right: 45
            },
            doublequatrefoil: {
                lower: 40,
                upper: 70,
                left: 55,
                right: 53
            },
            square2: {
                lower: 50,
                upper: 90,
                left: 45,
                right: 45
            },
            weirdcircle: {
                lower: 50,
                upper: 80,
                left: 45,
                right: 45
            }
        }
    }, {
        name: "Vine Monograms Solid Bold",
        type: "mixed",
        center_x: 105,
        center_y: 100,
        layout: {
            quatrefoil: {
                upper: 65
            },
            doublecircle: {
                upper: 75
            },
            circle: {
                upper: 90
            },
            jaggedcircle: {
                upper: 80
            },
            scallop: {
                upper: 85
            },
            square: {
                upper: 85
            },
            doublequatrefoil: {
                upper: 65
            },
            square2: {
                upper: 85
            },
            weirdcircle: {
                upper: 65
            }
        }
    }, {
        name: "monogram kk sc",
        type: "mixed",
        center_x: 100,
        center_y: 94,
        layout: {
            quatrefoil: {
                lower: 40,
                upper: 70,
                left: 20,
                right: 20
            },
            doublecircle: {
                lower: 40,
                upper: 70,
                left: 20,
                right: 20
            },
            circle: {
                lower: 40,
                upper: 90,
                left: 20,
                right: 20
            },
            jaggedcircle: {
                lower: 40,
                upper: 70,
                left: 20,
                right: 20
            },
            scallop: {
                lower: 40,
                upper: 80,
                left: 20,
                right: 20
            },
            square: {
                lower: 40,
                upper: 80,
                left: 20,
                right: 20
            },
            doublequatrefoil: {
                lower: 30,
                upper: 70,
                left: 20,
                right: 20
            },
            square2: {
                lower: 40,
                upper: 80,
                left: 20,
                right: 20
            },
            weirdcircle: {
                lower: 40,
                upper: 75,
                left: 20,
                right: 20
            }
        }
    }, {
        name: "Circle Monograms Three White Alt",
        type: "circleBlock",
        center_x: 97,
        center_y: 100,
        layout: {
            quatrefoil: {
                upper: 120
            },
            doublecircle: {
                upper: 140
            },
            circle: {
                upper: 150
            },
            jaggedcircle: {
                upper: 140
            },
            scallop: {
                upper: 140
            },
            square: {
                upper: 140
            },
            doublequatrefoil: {
                upper: 120
            },
            square2: {
                upper: 140
            },
            weirdcircle: {
                upper: 120
            }
        }
    } ];
    fontInfo["ipad"] = [ {
        name: "HelveticaNeue",
        type: "uppercase",
        center_x: 200,
        center_y: 200,
        layout: {
            quatrefoil: {
                lower: 80,
                upper: 140,
                left: 45,
                right: 45
            },
            doublecircle: {
                lower: 80,
                upper: 140,
                left: 48,
                right: 45
            },
            circle: {
                lower: 100,
                upper: 180,
                left: 35,
                right: 30
            },
            jaggedcircle: {
                lower: 100,
                upper: 180,
                left: 45,
                right: 40
            },
            scallop: {
                lower: 100,
                upper: 180,
                left: 45,
                right: 45
            },
            square: {
                lower: 100,
                upper: 180,
                left: 45,
                right: 45
            },
            doublequatrefoil: {
                lower: 80,
                upper: 140,
                left: 55,
                right: 53
            },
            square2: {
                lower: 100,
                upper: 180,
                left: 45,
                right: 45
            },
            weirdcircle: {
                lower: 100,
                upper: 160,
                left: 45,
                right: 45
            }
        }
    }, {
        name: "Vine MonogramsSolid Bold",
        type: "mixed",
        center_x: 205,
        center_y: 200,
        layout: {
            quatrefoil: {
                upper: 120
            },
            doublecircle: {
                upper: 140
            },
            circle: {
                upper: 170
            },
            jaggedcircle: {
                upper: 150
            },
            scallop: {
                upper: 150
            },
            square: {
                upper: 160
            },
            doublequatrefoil: {
                upper: 120
            },
            square2: {
                upper: 160
            },
            weirdcircle: {
                upper: 140
            }
        }
    }, {
        name: "monogram kk sc",
        type: "mixed",
        center_x: 200,
        center_y: Alloy.Globals.isiOS7Plus() ? 202 : 209,
        layout: {
            quatrefoil: {
                lower: 80,
                upper: 140,
                left: 20,
                right: 20
            },
            doublecircle: {
                lower: 80,
                upper: 140,
                left: 20,
                right: 20
            },
            circle: {
                lower: 80,
                upper: 180,
                left: 20,
                right: 20
            },
            jaggedcircle: {
                lower: 80,
                upper: 140,
                left: 20,
                right: 20
            },
            scallop: {
                lower: 80,
                upper: 160,
                left: 20,
                right: 20
            },
            square: {
                lower: 80,
                upper: 160,
                left: 20,
                right: 20
            },
            doublequatrefoil: {
                lower: 50,
                upper: 130,
                left: 20,
                right: 20
            },
            square2: {
                lower: 80,
                upper: 160,
                left: 20,
                right: 20
            },
            weirdcircle: {
                lower: 80,
                upper: 150,
                left: 20,
                right: 20
            }
        }
    }, {
        name: "Circle Monograms Three White",
        type: "circleBlock",
        center_x: 193,
        center_y: 200,
        layout: {
            quatrefoil: {
                upper: 240
            },
            doublecircle: {
                upper: 280
            },
            circle: {
                upper: 300
            },
            jaggedcircle: {
                upper: 280
            },
            scallop: {
                upper: 280
            },
            square: {
                upper: 280
            },
            doublequatrefoil: {
                upper: 240
            },
            square2: {
                upper: 280
            },
            weirdcircle: {
                upper: 240
            }
        }
    } ];
    fontInfo["tablet"] = [ {
        name: "HelveticaNeue",
        type: "uppercase",
        center_x: 200,
        center_y: 190,
        layout: {
            quatrefoil: {
                lower: 80,
                upper: 140,
                left: 45,
                right: 45
            },
            doublecircle: {
                lower: 80,
                upper: 140,
                left: 48,
                right: 45
            },
            circle: {
                lower: 100,
                upper: 180,
                left: 35,
                right: 30
            },
            jaggedcircle: {
                lower: 100,
                upper: 180,
                left: 45,
                right: 40
            },
            scallop: {
                lower: 100,
                upper: 180,
                left: 45,
                right: 45
            },
            square: {
                lower: 100,
                upper: 180,
                left: 45,
                right: 45
            },
            doublequatrefoil: {
                lower: 80,
                upper: 140,
                left: 55,
                right: 53
            },
            square2: {
                lower: 100,
                upper: 180,
                left: 45,
                right: 45
            },
            weirdcircle: {
                lower: 100,
                upper: 160,
                left: 45,
                right: 45
            }
        }
    }, {
        name: "Vine Monograms Solid Bold",
        type: "mixed",
        center_x: 205,
        center_y: 200,
        layout: {
            quatrefoil: {
                upper: 120
            },
            doublecircle: {
                upper: 140
            },
            circle: {
                upper: 170
            },
            jaggedcircle: {
                upper: 150
            },
            scallop: {
                upper: 150
            },
            square: {
                upper: 160
            },
            doublequatrefoil: {
                upper: 120
            },
            square2: {
                upper: 160
            },
            weirdcircle: {
                upper: 140
            }
        }
    }, {
        name: "monogram kk sc",
        type: "mixed",
        center_x: 200,
        center_y: 200,
        layout: {
            quatrefoil: {
                lower: 80,
                upper: 140,
                left: 20,
                right: 20
            },
            doublecircle: {
                lower: 80,
                upper: 140,
                left: 20,
                right: 20
            },
            circle: {
                lower: 80,
                upper: 180,
                left: 20,
                right: 20
            },
            jaggedcircle: {
                lower: 80,
                upper: 140,
                left: 20,
                right: 20
            },
            scallop: {
                lower: 80,
                upper: 160,
                left: 20,
                right: 20
            },
            square: {
                lower: 80,
                upper: 160,
                left: 20,
                right: 20
            },
            doublequatrefoil: {
                lower: 50,
                upper: 130,
                left: 20,
                right: 20
            },
            square2: {
                lower: 80,
                upper: 160,
                left: 20,
                right: 20
            },
            weirdcircle: {
                lower: 80,
                upper: 150,
                left: 20,
                right: 20
            }
        }
    }, {
        name: "Circle Monograms Three White Alt",
        type: "circleBlock",
        center_x: 193,
        center_y: 195,
        layout: {
            quatrefoil: {
                upper: 240
            },
            doublecircle: {
                upper: 280
            },
            circle: {
                upper: 300
            },
            jaggedcircle: {
                upper: 280
            },
            scallop: {
                upper: 280
            },
            square: {
                upper: 280
            },
            doublequatrefoil: {
                upper: 240
            },
            square2: {
                upper: 280
            },
            weirdcircle: {
                upper: 240
            }
        }
    } ];
    var circleBlockTable = [];
    circleBlockTable["a"] = "1";
    circleBlockTable["b"] = "2";
    circleBlockTable["c"] = "3";
    circleBlockTable["d"] = "4";
    circleBlockTable["e"] = "5";
    circleBlockTable["f"] = "6";
    circleBlockTable["g"] = "7";
    circleBlockTable["h"] = "8";
    circleBlockTable["i"] = "9";
    circleBlockTable["j"] = "0";
    circleBlockTable["k"] = "!";
    circleBlockTable["l"] = "@";
    circleBlockTable["m"] = "#";
    circleBlockTable["n"] = "$";
    circleBlockTable["o"] = "%";
    circleBlockTable["p"] = "^";
    circleBlockTable["q"] = "&";
    circleBlockTable["r"] = "*";
    circleBlockTable["s"] = "(";
    circleBlockTable["t"] = ")";
    circleBlockTable["u"] = "-";
    circleBlockTable["v"] = "=";
    circleBlockTable["w"] = "[";
    circleBlockTable["x"] = "]";
    circleBlockTable["y"] = "|";
    circleBlockTable["z"] = ";";
    var actInd = Titanium.UI.createActivityIndicator({
        width: 50,
        height: 50
    });
    $.container.add(actInd);
    actInd.show();
    $.fontColorPallete.container.left = 0;
    $.stampColorPallete.container.left = 0;
    var LEFTTRAY_SLIDE_LEFT = Titanium.UI.createAnimation({
        left: -100,
        duration: 200,
        curve: null
    });
    var LEFTTRAY_SLIDE_RIGHT = Titanium.UI.createAnimation({
        left: 0,
        duration: 200,
        curve: null
    });
    Titanium.UI.createAnimation({
        duration: 200
    });
    Titanium.UI.createAnimation({
        opacity: 1,
        duration: 200,
        curve: null
    });
    $.container.addEventListener("load", function() {
        $.navTray.navTray.visible = true;
        actInd.hide();
    });
    Titanium.App.addEventListener("app:colorpallete_clicked", function(e) {
        Ti.API.info("Palette clicked ");
        switch (e.data.parent) {
          case "font":
            fontStatus.colored = true;
            monogram.font.color = e.data.color;
            setFontColor();
            break;

          case "stamp":
            monogram.stamp.color = e.data.colorname;
            stampStatus.colored = true;
            setStamp(monogram.stamp.file, false);
        }
    });
    $.theInitials.addEventListener("return", function(e) {
        monogram.initials = e.source.value;
        setInitials(monogram.initials);
        $.initialsLabel.text = "Tap your font to continue!";
    });
    $.theInitials.addEventListener("change", function(e) {
        $.font1.text = adjustCase(e.value, "mixed");
        var str = e.value.toUpperCase();
        $.font2FirstInitial.text = str.substr(0, 1);
        $.font2MiddleInitial.text = str.substr(1, 1);
        $.font2LastInitial.text = str.substr(2, 1);
        $.font3.text = adjustCase(e.value, "mixed");
        $.font4.text = adjustCase(e.value, "circleBlock");
        if (e.source.value.length >= 3) {
            $.theInitials.blur();
            $.initialsLabel.text = "Tap your font to continue!";
        }
    });
    $.previewView.addEventListener("click", function() {
        switch (active_page) {
          case "font":
            toggleFontTray();
            break;

          case "stamp":
            toggleStampTray();
            break;

          case "backgroundtray":
            toggleBackgroundTray();
        }
    });
    __defers["$.__views.container!swipe!swipeListener"] && $.__views.container.addEventListener("swipe", swipeListener);
    __defers["$.__views.font1!click!selectFont"] && $.__views.font1.addEventListener("click", selectFont);
    __defers["$.__views.font2!click!selectFont"] && $.__views.font2.addEventListener("click", selectFont);
    __defers["$.__views.font3!click!selectFont"] && $.__views.font3.addEventListener("click", selectFont);
    __defers["$.__views.font4!click!selectFont"] && $.__views.font4.addEventListener("click", selectFont);
    __defers["$.__views.btn_done!click!goClose"] && $.__views.btn_done.addEventListener("click", goClose);
    __defers["$.__views.btn_menu!click!toggleNavTray"] && $.__views.btn_menu.addEventListener("click", toggleNavTray);
    true && !Alloy.isTablet && __defers["$.__views.btn_initials!click!goInitials"] && $.__views.btn_initials.addEventListener("click", goInitials);
    true && !Alloy.isTablet && __defers["$.__views.btn_background!click!goBackground"] && $.__views.btn_background.addEventListener("click", goBackground);
    true && !Alloy.isTablet && __defers["$.__views.btn_stamp!click!goStamp"] && $.__views.btn_stamp.addEventListener("click", goStamp);
    true && !Alloy.isTablet && __defers["$.__views.btn_font!click!goFont"] && $.__views.btn_font.addEventListener("click", goFont);
    true && !Alloy.isTablet && __defers["$.__views.btn_trash!click!goTrash"] && $.__views.btn_trash.addEventListener("click", goTrash);
    true && Alloy.isTablet && __defers["$.__views.btn_initials!click!goInitials"] && $.__views.btn_initials.addEventListener("click", goInitials);
    true && Alloy.isTablet && __defers["$.__views.btn_background!click!goBackground"] && $.__views.btn_background.addEventListener("click", goBackground);
    true && Alloy.isTablet && __defers["$.__views.btn_stamp!click!goStamp"] && $.__views.btn_stamp.addEventListener("click", goStamp);
    true && Alloy.isTablet && __defers["$.__views.btn_font!click!goFont"] && $.__views.btn_font.addEventListener("click", goFont);
    true && Alloy.isTablet && __defers["$.__views.btn_trash!click!goTrash"] && $.__views.btn_trash.addEventListener("click", goTrash);
    __defers["$.__views.shareButton!click!shareWallpaper"] && $.__views.shareButton.addEventListener("click", shareWallpaper);
    __defers["$.__views.saveButton!click!saveWallpaper"] && $.__views.saveButton.addEventListener("click", saveWallpaper);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;