function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "navtray/" + s : s.substring(0, index) + "/navtray/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    function clickMenuItem(e) {
        toggle(current_view);
        menuRow = e.row;
        openWindow();
    }
    function toggle(view) {
        pages.log("TOGGLE NAVTRY CALLED: menuToggle = " + menuToggle + " AND animating =" + animating);
        menuToggle && !animating ? close(view) : open(view);
    }
    function open(view) {
        current_view = view;
        view.animate(openAnimation);
    }
    function close(view) {
        current_view = view;
        view.animate(closeAnimation);
    }
    function openWindow() {
        "app" == menuRow.type ? pages.open({
            type: "controller",
            name: menuRow.menuCategory
        }) : "url" == menuRow.type && pages.open({
            type: "web",
            name: menuRow.menuName,
            url: menuRow.menuLink,
            title: menuRow.menuTitle
        });
        toggle(current_view);
    }
    function goHome() {
        pages.log("NAVTRAY: Clicked Home.");
        pages.closeAll();
    }
    function goStore() {
        toggle(current_view);
        pages.open({
            type: "web",
            name: "shop",
            title: Alloy.Globals.landingButtons["shop"].title,
            url: Alloy.Globals.landingButtons["shop"].link
        });
    }
    function showClock() {
        $.noFlashSale.visible = false;
        $.flashSaleScheduled.visible = true;
    }
    function hideClock() {
        $.noFlashSale.visible = true;
        $.flashSaleScheduled.visible = false;
    }
    function updateTimer(txt) {
        $.flashSaleScheduledLabel.text = Alloy.Globals.flashSaleInfo.started ? "FLASH SALE ENDS IN" : "FLASH SALE STARTS IN";
        Alloy.Globals.flashSaleInfo.stopped && hideClock();
        $.flashSaleClock.text = txt;
    }
    new (require("alloy/widget"))("navtray");
    this.__widgetId = "navtray";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        __processArg(arguments[0], "__parentSymbol");
        __processArg(arguments[0], "$model");
        __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.navTray = Ti.UI.createView({
        width: 200,
        right: 0,
        backgroundColor: "#fa72c0",
        visible: false,
        id: "navTray"
    });
    $.__views.navTray && $.addTopLevelView($.__views.navTray);
    var __alloyId0 = [];
    $.__views.__alloyId1 = Ti.UI.createTableViewRow({
        height: 30,
        color: "#ffffff",
        id: "__alloyId1"
    });
    __alloyId0.push($.__views.__alloyId1);
    goHome ? $.__views.__alloyId1.addEventListener("click", goHome) : __defers["$.__views.__alloyId1!click!goHome"] = true;
    $.__views.menu_home_icon = Ti.UI.createImageView({
        height: 20,
        width: 20,
        left: 20,
        image: "/images/icons/menu_home.png",
        id: "menu_home_icon"
    });
    $.__views.__alloyId1.add($.__views.menu_home_icon);
    $.__views.menu_home = Ti.UI.createLabel({
        left: 50,
        color: "#ffffff",
        id: "menu_home",
        text: "Home"
    });
    $.__views.__alloyId1.add($.__views.menu_home);
    $.__views.menu = Ti.UI.createTableView({
        top: 10,
        bottom: 100,
        width: 200,
        backgroundColor: "transparent",
        data: __alloyId0,
        id: "menu"
    });
    $.__views.navTray.add($.__views.menu);
    $.__views.navTrayFooter = Ti.UI.createView({
        bottom: 0,
        height: 100,
        id: "navTrayFooter"
    });
    $.__views.navTray.add($.__views.navTrayFooter);
    $.__views.flashSaleBillboard = Ti.UI.createView({
        width: 200,
        right: 0,
        id: "flashSaleBillboard"
    });
    $.__views.navTrayFooter.add($.__views.flashSaleBillboard);
    goStore ? $.__views.flashSaleBillboard.addEventListener("click", goStore) : __defers["$.__views.flashSaleBillboard!click!goStore"] = true;
    $.__views.flashSaleScheduled = Ti.UI.createView({
        visible: false,
        id: "flashSaleScheduled"
    });
    $.__views.flashSaleBillboard.add($.__views.flashSaleScheduled);
    $.__views.flashSaleScheduledLabel = Ti.UI.createLabel({
        color: "#FFFFFF",
        font: {
            fontSize: 11
        },
        top: 15,
        text: "FLASH SALE STARTS IN:",
        id: "flashSaleScheduledLabel"
    });
    $.__views.flashSaleScheduled.add($.__views.flashSaleScheduledLabel);
    $.__views.flashSaleClock = Ti.UI.createLabel({
        color: "#FFFFFF",
        font: {
            fontSize: 30
        },
        bottom: 30,
        text: "03:14:20",
        id: "flashSaleClock"
    });
    $.__views.flashSaleScheduled.add($.__views.flashSaleClock);
    $.__views.noFlashSale = Ti.UI.createView({
        id: "noFlashSale"
    });
    $.__views.flashSaleBillboard.add($.__views.noFlashSale);
    goStore ? $.__views.noFlashSale.addEventListener("click", goStore) : __defers["$.__views.noFlashSale!click!goStore"] = true;
    $.__views.noFlashSaleLabel = Ti.UI.createLabel({
        color: "#FFFFFF",
        font: {
            fontSize: 11
        },
        top: 15,
        right: 10,
        text: "NO FLASH SALE SCHEDULED",
        id: "noFlashSaleLabel"
    });
    $.__views.noFlashSale.add($.__views.noFlashSaleLabel);
    $.__views.storeImage = Ti.UI.createImageView({
        top: 35,
        left: 40,
        height: 50,
        width: 50,
        id: "storeImage",
        image: "/images/icons/shopping_bag_white.png"
    });
    $.__views.noFlashSale.add($.__views.storeImage);
    $.__views.browseStoreLabel = Ti.UI.createLabel({
        color: "#FFFFFF",
        font: {
            fontSize: 11
        },
        right: 10,
        top: 55,
        text: "BROWSE STORE",
        id: "browseStoreLabel"
    });
    $.__views.noFlashSale.add($.__views.browseStoreLabel);
    exports.destroy = function() {};
    _.extend($, $.__views);
    var pages = require("pageutils");
    var menuToggle = false;
    var menuRow = {};
    var animating = false;
    var current_view = {};
    var menuItems = Alloy.Globals.menuItems;
    var row = {};
    for (var i = 0; i < menuItems.length; i++) {
        row = Titanium.UI.createTableViewRow({
            className: "menuRow",
            rowID: i,
            menuName: menuItems[i].category,
            menuLink: "url" == menuItems[i].type ? menuItems[i].link : "",
            menuTitle: menuItems[i].title,
            type: menuItems[i].type,
            menuCategory: menuItems[i].category,
            height: 40,
            color: "#ffffff",
            selectionStyle: null
        });
        var label = Titanium.UI.createLabel({
            text: menuItems[i].title,
            color: "#ffffff",
            left: 50
        });
        var filename = "menu_" + menuItems[i].category + ".png";
        var f = Titanium.Filesystem.getFile(Titanium.Filesystem.resourcesDirectory + "/images/icons/", filename);
        if (f.exists()) {
            var icon = Titanium.UI.createImageView({
                left: 20,
                height: 20,
                width: 20,
                image: "/images/icons/" + filename
            });
            row.add(icon);
        }
        row.add(label);
        row.addEventListener("click", clickMenuItem);
        $.menu.appendRow(row);
    }
    Alloy.Globals.flashSaleInfo && Alloy.Globals.flashSaleInfo.scheduled ? showClock() : hideClock();
    var closeAnimation = Titanium.UI.createAnimation({
        left: 0,
        right: 0,
        duration: 200,
        curve: void 0
    });
    closeAnimation.addEventListener("start", function() {
        animating = true;
    });
    closeAnimation.addEventListener("complete", function() {
        animating = false;
        menuToggle = false;
    });
    var openAnimation = Titanium.UI.createAnimation({
        left: -185,
        right: 185,
        duration: 200,
        curve: void 0
    });
    openAnimation.addEventListener("start", function() {
        animating = true;
    });
    openAnimation.addEventListener("complete", function() {
        animating = false;
        menuToggle = true;
    });
    exports.menuToggle = menuToggle;
    exports.close = close;
    exports.open = open;
    exports.toggle = toggle;
    exports.updateTimer = updateTimer;
    __defers["$.__views.__alloyId1!click!goHome"] && $.__views.__alloyId1.addEventListener("click", goHome);
    __defers["$.__views.flashSaleBillboard!click!goStore"] && $.__views.flashSaleBillboard.addEventListener("click", goStore);
    __defers["$.__views.noFlashSale!click!goStore"] && $.__views.noFlashSale.addEventListener("click", goStore);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;