function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "toolbar/" + s : s.substring(0, index) + "/toolbar/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    function checkMessages() {
        pages.toggle({
            type: "controller",
            name: "messages"
        });
    }
    function goBack() {
        pages.close({
            name: current_view
        });
    }
    function goRefresh() {
        Titanium.UI.fireEvent("app:refreshPage");
    }
    function goSettings() {
        pages.toggle({
            type: "controller",
            name: "settings"
        });
    }
    function hideBack() {
        $.btn_toolbar_back.visible = false;
    }
    function showBack() {
        $.btn_toolbar_back.visible = true;
    }
    function showSettings() {
        $.btn_toolbar_settings.visible = true;
    }
    function hideSettings() {
        $.btn_toolbar_settings.visible = false;
    }
    function showRefresh() {
        $.btn_toolbar_refresh.visible = true;
    }
    function hideRefresh() {
        $.btn_toolbar_refresh.visible = false;
    }
    function setCurrentView(str) {
        pages.log("TOOLBAR WIDGET: SETTING current_view to " + str);
        current_view = str;
    }
    new (require("alloy/widget"))("toolbar");
    this.__widgetId = "toolbar";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        __processArg(arguments[0], "__parentSymbol");
        __processArg(arguments[0], "$model");
        __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.bottomToolbar = Ti.UI.createView({
        bottom: 0,
        height: 40,
        width: Titanium.UI.FILL,
        backgroundColor: "#fdeaf4",
        id: "bottomToolbar"
    });
    $.__views.bottomToolbar && $.addTopLevelView($.__views.bottomToolbar);
    $.__views.btn_toolbar_settings = Ti.UI.createImageView({
        height: 27,
        width: 30,
        left: 10,
        visible: false,
        id: "btn_toolbar_settings",
        image: "/images/icons/gear.png"
    });
    $.__views.bottomToolbar.add($.__views.btn_toolbar_settings);
    goSettings ? $.__views.btn_toolbar_settings.addEventListener("click", goSettings) : __defers["$.__views.btn_toolbar_settings!click!goSettings"] = true;
    $.__views.btn_toolbar_back = Ti.UI.createImageView({
        height: 27,
        width: 30,
        left: 5,
        visible: true,
        id: "btn_toolbar_back",
        image: "/images/icons/back.png"
    });
    $.__views.bottomToolbar.add($.__views.btn_toolbar_back);
    goBack ? $.__views.btn_toolbar_back.addEventListener("click", goBack) : __defers["$.__views.btn_toolbar_back!click!goBack"] = true;
    $.__views.btn_toolbar_refresh = Ti.UI.createImageView({
        height: 27,
        width: 15,
        left: 10,
        visible: false,
        id: "btn_toolbar_refresh",
        image: "/images/icons/refresh.png"
    });
    $.__views.bottomToolbar.add($.__views.btn_toolbar_refresh);
    goRefresh ? $.__views.btn_toolbar_refresh.addEventListener("click", goRefresh) : __defers["$.__views.btn_toolbar_refresh!click!goRefresh"] = true;
    $.__views.btn_toolbar_messages = Ti.UI.createImageView({
        height: 27,
        width: 34,
        right: 10,
        id: "btn_toolbar_messages",
        image: "/images/icons/envelope.png"
    });
    $.__views.bottomToolbar.add($.__views.btn_toolbar_messages);
    checkMessages ? $.__views.btn_toolbar_messages.addEventListener("click", checkMessages) : __defers["$.__views.btn_toolbar_messages!click!checkMessages"] = true;
    $.__views.badge = Ti.UI.createLabel({
        top: 2,
        right: 33,
        height: 15,
        width: 15,
        backgroundColor: "transparent",
        backgroundImage: "/images/icons/badge.png",
        textAlign: Titanium.UI.TEXT_ALIGNMENT_CENTER,
        color: "#FFFFFF",
        font: {
            fontSize: 10
        },
        visible: false,
        text: "99",
        id: "badge"
    });
    $.__views.bottomToolbar.add($.__views.badge);
    exports.destroy = function() {};
    _.extend($, $.__views);
    var pages = require("pageutils");
    var current_view;
    Titanium.UI.addEventListener("app:updateMessagesBadge", function() {
        var messageCount = Alloy.Globals.getMessageCount();
        $.badge.text = messageCount;
        $.badge.visible = messageCount > 0 ? true : false;
    });
    Titanium.UI.fireEvent("app:updateMessagesBadge");
    hideBack();
    exports.setCurrentView = setCurrentView;
    exports.showBack = showBack;
    exports.hideBack = hideBack;
    exports.showSettings = showSettings;
    exports.hideSettings = hideSettings;
    exports.showRefresh = showRefresh;
    exports.hideRefresh = hideRefresh;
    __defers["$.__views.btn_toolbar_settings!click!goSettings"] && $.__views.btn_toolbar_settings.addEventListener("click", goSettings);
    __defers["$.__views.btn_toolbar_back!click!goBack"] && $.__views.btn_toolbar_back.addEventListener("click", goBack);
    __defers["$.__views.btn_toolbar_refresh!click!goRefresh"] && $.__views.btn_toolbar_refresh.addEventListener("click", goRefresh);
    __defers["$.__views.btn_toolbar_messages!click!checkMessages"] && $.__views.btn_toolbar_messages.addEventListener("click", checkMessages);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;