function receivePush(e) {
    var msg = "Received push: " + JSON.stringify(e);
    pages.log(msg);
    var data = e.data;
    alert("New message from Marley Lilly: " + data.alert);
    Alloy.Globals.fetchMessages();
}

function deviceTokenSuccess(e) {
    deviceToken = e.deviceToken;
    var flashSales = Titanium.App.Properties.getString("flashSales", "true");
    var coupons = Titanium.App.Properties.getString("coupons", "true");
    var reminders = Titanium.App.Properties.getString("reminders", "true");
    var giveaways = Titanium.App.Properties.getString("giveaways", "true");
    "true" == flashSales && subscribeToChannel("flashsales");
    "true" == coupons && subscribeToChannel("coupons");
    "true" == reminders && subscribeToChannel("reminders");
    "true" == giveaways && subscribeToChannel("giveaways");
}

function deviceTokenError(e) {
    var msg = "Failed to register for push notifications! " + e.error;
    pages.log(msg);
}

function subscribeToChannel(channel) {
    pages.log("PUSH NOTIFICATIONS: Attempting to subscribe to channel: " + channel);
    Cloud.PushNotifications.subscribeToken({
        device_token: deviceToken,
        channel: channel,
        type: "android"
    }, function(e) {
        if (e.success) pages.log("PUSH NOTIFICATIONS: Successfully subscribed to channel: " + channel); else {
            var msg = "Error:\n" + (e.error && e.message || JSON.stringify(e));
            pages.log(msg);
        }
    });
}

function unsubscribeFromChannel(channel) {
    Cloud.PushNotifications.unsubscribeToken({
        channel: channel,
        device_token: deviceToken
    }, function(e) {
        pages.log(e.success ? "PUSH NOTIFICATIONS: Successfully unsubscribed from channel: " + channel : "Error:\n" + (e.error && e.message || JSON.stringify(e)));
    });
}

function fetchConfig() {
    var xhr = Titanium.Network.createHTTPClient();
    var remote_source = "";
    remote_source = "ipad" == Alloy.Globals.platformOS ? Alloy.Globals.CONFIG_SERVER_URL + "config-ipad.xml" : Alloy.Globals.CONFIG_SERVER_URL + "config.xml";
    pages.log("ATTEMPTING TO RETRIEVE REMOTE CONFIG FILE : " + remote_source);
    xhr.open("GET", remote_source);
    xhr.onload = function() {
        statusCode = xhr.status;
        pages.log("RESULTS OF ATTEMPT TO FETCH CONFIG FILE : statusCode = " + statusCode);
        if (200 == statusCode) {
            var data = this.responseText;
            TF.remoteLog("FETCH CONFIG FILE : responseText : " + data);
            var doc = Titanium.XML.parseString(data);
            var configs = doc.getElementsByTagName("config");
            for (var i = 0; i < configs.length; i++) if ("app" == configs.item(i).attributes.getNamedItem("category").nodeValue) {
                var remote_timestamp = configs.item(i).getElementsByTagName("timestamp").item(i).text;
                Titanium.API.log("remote_timestamp = " + remote_timestamp + " | local timestamp = " + Alloy.Globals.appConfigArray["timestamp"]);
                if (Number(remote_timestamp) > Number(Alloy.Globals.appConfigArray["timestamp"]) || forceConfigReload) {
                    var f = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, "config.xml");
                    TF.remoteLog("CONFIG DATA RETRIEVED : " + data);
                    f.write(data);
                    var msg = "CONFIG: Retrieved config file and wrote to device";
                    pages.log(msg);
                    loadConfiguration();
                }
            }
        }
    };
    xhr.send();
}

function getPlatformOS() {
    return "android";
}

function loadConfiguration() {
    var f = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, "config.xml");
    f.exists() || (f = Titanium.Filesystem.getFile(Titanium.Filesystem.resourcesDirectory, "config.xml"));
    var xmltext = f.read().text;
    var doc = Titanium.XML.parseString(xmltext);
    var configs = doc.getElementsByTagName("config");
    for (var i = 0; i < configs.length; i++) {
        var item = configs.item(i);
        setConfigGlobal(item.attributes.getNamedItem("category").nodeValue, item);
    }
}

function setConfigGlobal(category, item) {
    var i = 0;
    switch (category) {
      case "app":
        var appConfigArray = [];
        var settings = item.getChildNodes();
        for (i = 0; i < settings.length; i++) {
            "#text" !== settings.item(i).getNodeName() && (appConfigArray[settings.item(i).getNodeName()] = settings.item(i).text);
            pages.log("SETTING GLOBAL VARAIBLE " + settings.item(i).getNodeName() + " TO " + settings.item(i).text);
        }
        Alloy.Globals.appConfigArray = appConfigArray;
        break;

      case "landing":
        var buttonArray = [];
        var buttons = item.getElementsByTagName("button");
        for (i = 0; i < buttons.length; i++) buttonArray[buttons.item(i).attributes.getNamedItem("id").nodeValue] = {
            title: buttons.item(i).getElementsByTagName("title").item(0).text,
            link: buttons.item(i).getElementsByTagName("link").item(0).text
        };
        Alloy.Globals.landingButtons = buttonArray;
        break;

      case "menu":
        var menuArray = [];
        var menuItems = item.getElementsByTagName("menuitem");
        for (i = 0; i < menuItems.length; i++) {
            menuArray[i] = {};
            var itemType = menuItems.item(i).attributes.getNamedItem("type").nodeValue;
            menuArray[i].type = itemType;
            menuArray[i].category = menuItems.item(i).attributes.getNamedItem("category").nodeValue;
            "url" == itemType && (menuArray[i].link = menuItems.item(i).getElementsByTagName("link").item(0).text);
            menuArray[i].title = menuItems.item(i).getElementsByTagName("title").item(0).text;
            menuArray[i].order = menuItems.item(i).getElementsByTagName("order").item(0).text;
        }
        menuArray.sort(compareOrder);
        Alloy.Globals.menuItems = menuArray;
    }
}

function compareOrder(a, b) {
    return a.order - b.order;
}

var Alloy = require("alloy"), _ = Alloy._, Backbone = Alloy.Backbone;

Alloy.Globals.CONFIG_SERVER_URL = "http://marleylilly.goredshift.com/app_data/";

Alloy.Globals.ADMIN_SERVER_URL = "http://marleylilly.goredshift.com/";

Alloy.Globals.activeWindows = {};

Alloy.Globals.currentWindow = null;

Alloy.Globals.platformOS = getPlatformOS();

Alloy.Globals.logLevel = 2;

Date.prototype.getTimestamp = function() {
    var m = this.getMonth() + 1;
    m = m > 9 ? "" + m : "0" + m;
    return d.getFullYear() + m + d.getDate() + d.getHours() + d.getMinutes() + d.getSeconds();
};

var forceConfigReload = true;

var d = new Date();

Alloy.Globals.currentTimestamp = d.getTimestamp();

var pages = require("/pageutils");

var TF = require("/testflightjs");

TF.takeOff("3a807597-c4f9-4ce7-bdbb-c8f2b13b4ae3");

TF.setOptions({
    logToConsole: true,
    logToSTDERR: true,
    sendLogOnlyOnCrash: false,
    attachBacktraceToFeedback: false,
    disableInAppUpdates: false
});

TF.remoteLog("CURRENT PLATFORM: android CURRENT MODEL: " + Titanium.Platform.model);

TF.remoteLog("DETECTED OUR PlatformOS AS " + Alloy.Globals.platformOS);

var deviceToken = null;

var Cloud = require("ti.cloud");

var db = Titanium.Database.open("messages");

db.execute("CREATE TABLE IF NOT EXISTS config (attribute TEXT, value TEXT, UNIQUE(attribute) ON CONFLICT REPLACE)");

TF.remoteLog("Created the config table");

var db_config = db.execute("SELECT * FROM config WHERE attribute = 'version'");

TF.remoteLog("Fetching the DB version");

var version = "0.1";

if (db_config.isValidRow()) {
    version = db_config.fieldByName("value");
    TF.remoteLog("Stored DB version: " + version);
}

if ("0.1" == version) {
    TF.remoteLog("Setting up messages table");
    db.execute("CREATE TABLE IF NOT EXISTS messages (id INTEGER PRIMARY KEY, message_id TEXT, timestamp INTEGER, category INTEGER, subject TEXT, body TEXT, status INTEGER, link TEXT, UNIQUE(message_id) ON CONFLICT IGNORE)");
    TF.remoteLog("Created the messages table");
    db.execute("INSERT INTO config (attribute, value) VALUES (?, ?)", "version", "1.0");
    TF.remoteLog("Saved the DB version to the config table");
    version = "1.0";
    TF.remoteLog("Finished setting up the messages table");
}

if ("1.0" == version) {
    TF.remoteLog("Altering messages table");
    Titanium.API.info("Altering messages table");
    db.execute("ALTER TABLE messages ADD COLUMN reminder INTEGER");
    db.execute("ALTER TABLE messages ADD COLUMN eventdate TEXT");
    TF.remoteLog("messages table ALTERED");
    Titanium.API.info("messages table ALTERED");
    db.execute("INSERT INTO config (attribute, value) VALUES (?, ?)", "version", "1.1");
    TF.remoteLog("Saved the DB version to the config table");
    Titanium.API.info("Saved the DB version to the config table");
    version = "1.1";
}

if ("1.1" == version) {
    db.execute("CREATE TABLE IF NOT EXISTS file_assets (id INTEGER PRIMARY KEY, filename TEXT, type TEXT, localchecksum TEXT, remotechecksum TEXT, downloaded INTEGER, UNIQUE(filename) ON CONFLICT IGNORE)");
    db.execute("DELETE FROM config WHERE attribute = ?", "version");
    db.execute("INSERT INTO config (attribute, value) VALUES (?, ?)", "version", "1.2");
    version = "1.2";
}

if ("1.2" == version) {
    db.execute("ALTER TABLE file_assets ADD COLUMN lastupdate TEXT");
    db.execute("DELETE FROM config WHERE attribute = ?", "version");
    db.execute("INSERT INTO config (attribute, value) VALUES (?, ?)", "version", "1.3");
    version = "1.3";
}

TF.remoteLog("Current DB Version = " + version);

TF.passCheckpoint("Passed the Database Init Checkpoint");

db.close();

loadConfiguration();

var current_content_timestamp = Alloy.Globals.appConfigArray["content_timestamp"];

fetchConfig();

Alloy.Globals.getMessageCount = function() {
    var db = Titanium.Database.open("messages");
    var result = db.execute("SELECT status, COUNT(*) as unreadCount FROM messages WHERE status = 0");
    var count = result.fieldByName("unreadCount");
    db.close();
    return count;
};

Alloy.Globals.fetchMessages = function(fn_complete) {
    var xhr = Titanium.Network.createHTTPClient();
    var remote_source = Alloy.Globals.ADMIN_SERVER_URL + "notifications/messagefeed";
    pages.log("About to Grab Messages from the server");
    xhr.open("GET", remote_source);
    xhr.onload = function() {
        var statusCode = xhr.status;
        if (200 == statusCode) {
            var data = this.responseText;
            var message = {};
            var db = Titanium.Database.open("messages");
            TF.remoteLog("data");
            var doc = Titanium.XML.parseString(data);
            var messages = doc.getElementsByTagName("message");
            TF.remoteLog("NUMBER OF Messages found: " + messages.length);
            for (var i = 0; i < messages.length; i++) {
                message.message_id = messages.item(i).getElementsByTagName("message_id").item(0).text;
                message.timestamp = messages.item(i).getElementsByTagName("timestamp").item(0).text;
                message.category = messages.item(i).getElementsByTagName("category").item(0).text;
                message.subject = messages.item(i).getElementsByTagName("subject").item(0).text;
                message.body = messages.item(i).getElementsByTagName("body").item(0).text;
                message.link = messages.item(i).getElementsByTagName("link").item(0).text;
                message.reminder = "true" == messages.item(i).getElementsByTagName("reminder").item(0).text ? true : false;
                message.eventdate = messages.item(i).getElementsByTagName("eventdate").item(0).text;
                message.status = 0;
                Titanium.API.info("Message REMINDER = " + message.reminder);
                try {
                    db.execute("INSERT INTO messages (message_id, timestamp, category, subject, body, status, link, reminder, eventdate) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?)", message.message_id, message.timestamp, message.category, message.subject, message.body, message.status, message.link, message.reminder, message.eventdate);
                } catch (e) {
                    pages.log("There was an error inserting a message into the Database: " + e.error);
                }
            }
            Alloy.Globals.setAppBadge(Alloy.Globals.getMessageCount());
            db.close();
            fn_complete && fn_complete();
        }
    };
    xhr.send();
};

Alloy.Globals.setMessageStatus = function(status, where) {
    var db = Titanium.Database.open("messages");
    db.execute("UPDATE messages SET status = " + status + " WHERE " + where);
    db.close();
};

Alloy.Globals.isiOS7Plus = function() {
    return false;
};

Alloy.Globals.isIphone5 = false;

Alloy.Globals.setAppBadge = function(count) {
    pages.log("MESSAGES: setAppBadget to " + count);
    Titanium.App.fireEvent("app:updateMessagesBadge");
};

String.prototype.capitalize = function() {
    var str = this.toLowerCase();
    return str.replace(/(?:^|\s)\S/g, function(a) {
        return a.toUpperCase();
    });
};

Alloy.Globals.get_remote_file = function(filename, url, forced, fn_error, fn_progress, fn_complete) {
    pages.log("FETCHING " + url);
    var file_obj = {
        file: filename,
        url: url,
        path: null
    };
    var file = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, filename);
    if (file.exists() && "0" == forced) {
        file_obj.path = Titanium.Filesystem.applicationDataDirectory + Titanium.Filesystem.separator;
        fn_complete && fn_complete("complete");
    } else if (true === Titanium.Network.online) {
        var c = Titanium.Network.createHTTPClient();
        c.setTimeout(2e4);
        c.onload = function() {
            if (200 == c.status) {
                var f = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, filename);
                f.write(this.responseData);
                f.remoteBackup = false;
                file_obj.path = Titanium.Filesystem.applicationDataDirectory;
                f = false;
                file = null;
            } else {
                file_obj.error = "file not found";
                alert("File not found");
                n_end(file_obj);
                pages.log("ERROR FETCHING REMOTE FILE FROM SERVER: " + file_obj.url + " ERROR: " + file_obj.error);
            }
            fn_complete && fn_complete("complete");
        };
        c.ondatastream = function(e) {
            fn_progress && fn_progress(e.progress);
        };
        c.onerror = function(e) {
            pages.log("ERROR FETCHING REMOTE FILE FROM SERVER: " + file_obj.url + " ERROR: " + e.error);
            file_obj.error = e.error;
            f = null;
            file = null;
            fn_error(file_obj);
        };
        c.open("GET", url);
        c.send();
    } else {
        file_obj.error = "no internet";
        alert("You are not connected to the Internet. Please connect to the Internet to continue with your request.");
    }
};

Alloy.createController("index");