function get_remote_file(filename, url, forced, fn_error, fn_progress, fn_complete) {
    var file_obj = {
        file: filename,
        url: url + "/" + filename,
        path: null
    };
    var file = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, filename);
    if (file.exists() && "0" == forced) {
        file_obj.path = Titanium.Filesystem.applicationDataDirectory + Titanium.Filesystem.separator;
        fn_complete && fn_complete("complete");
    } else if (true === Titanium.Network.online) {
        Ti.API.info("Downloading " + file_obj.url);
        var c = Titanium.Network.createHTTPClient();
        c.setTimeout(3e5);
        c.onload = function() {
            if (200 == c.status) {
                var f = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, filename);
                if (!f.exists()) {
                    mk_directory(filename);
                    f = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, filename);
                }
                f.write(this.responseData);
                f.remoteBackup = false;
                file_obj.path = Titanium.Filesystem.applicationDataDirectory;
                f = false;
                file_obj = null;
            } else {
                file_obj.error = "file not found";
                fn_error(file_obj);
            }
            fn_complete && fn_complete("complete");
        };
        c.ondatastream = function(e) {
            fn_progress && fn_progress(e.progress);
        };
        c.onerror = function(e) {
            file_obj.error = e.error;
            f = null;
            fn_error(file_obj);
            file_obj = null;
        };
        url = url.replace("android", "iphone");
        Ti.API.info("xxx The url is" + url);
        c.open("GET", url);
        c.send();
    } else {
        file_obj.error = "no internet";
        alert("No connectivity.. ");
    }
}

function mk_directory(path) {
    var pathArray = path.split(Titanium.Filesystem.separator);
    var filename = pathArray[pathArray.length - 1];
    var newPath = Titanium.Filesystem.applicationDataDirectory;
    if (pathArray.length > 1) for (var i = 0; i < pathArray.length; i++) {
        newPath += pathArray[i];
        Titanium.API.info("CHECKING FOR PATH " + newPath);
        var f = Titanium.Filesystem.getFile(newPath);
        if (!f.exists() && !f.isDirectory() && pathArray[i] !== filename) {
            Titanium.API.info("PATH " + newPath + " does not exist. CREATING IT.");
            f.createDirectory();
        }
        newPath += Titanium.Filesystem.separator;
    }
}

function fetch_queued_files(queue, fn_error, fn_progress, fn_complete) {
    var queueIndex = 0;
    var process_queue = function(result) {
        if ("undefined" != typeof result && queueIndex < queue.length) {
            var db = Titanium.Database.open("messages");
            db.execute("UPDATE file_assets SET downloaded = ? WHERE filename = ?", true, queue[queueIndex].filename);
            db.close();
            fn_progress({
                filename: queue[queueIndex].filename,
                index: queueIndex
            });
        }
        if (queueIndex < queue.length) {
            get_remote_file(queue[queueIndex].filename, queue[queueIndex].url, true, function(e) {
                Titanium.API.debug("Error downloading file: " + queue[queueIndex].url);
                fn_error({
                    url: queue[queueIndex].url,
                    error: e.error,
                    filename: queue[queueIndex].filename
                });
            }, function() {}, process_queue);
            queueIndex++;
        } else fn_complete();
    };
    process_queue();
}

exports.fetch_queued_files = fetch_queued_files;

exports.get_remote_file = get_remote_file;